### Tables.jl

[![Build Status](https://github.com/JuliaData/Tables.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/Tables.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![Codecov](https://codecov.io/gh/JuliaData/Tables.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/Tables.jl)
[![deps](https://juliahub.com/docs/Tables/deps.svg)](https://juliahub.com/ui/Packages/Tables/Z804B?t=2)
[![version](https://juliahub.com/docs/Tables/version.svg)](https://juliahub.com/ui/Packages/Tables/Z804B)
[![pkgeval](https://juliahub.com/docs/Tables/pkgeval.svg)](https://juliahub.com/ui/Packages/Tables/Z804B)

The Tables.jl package provides simple, yet powerful interface functions for working with all kinds of tabular data.

**Installation**: at the Julia REPL, `import Pkg; Pkg.add("Tables")`

**Maintenance**: Tables is maintained collectively by the [JuliaData collaborators](https://github.com/orgs/JuliaData/people).
Responsiveness to pull requests and issues can vary, depending on the availability of key collaborators.

### Documentation

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliadata.github.io/Tables.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliadata.github.io/Tables.jl/dev)

List of packages which support Tables.jl interface can be found in [INTEGRATIONS.md](INTEGRATIONS.md).

### Zenodo Link

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4458977.svg)](https://doi.org/10.5281/zenodo.4458977)

# Vector of NamedTuples
const RowTable{T} = AbstractVector{T} where {T <: NamedTuple}

# interface implementation
isrowtable(::Type{<:RowTable}) = true
schema(x::AbstractVector{NamedTuple{names, types}}) where {names, types} = Schema(names, types)
materializer(x::RowTable) = rowtable

# struct to transform `Row`s into NamedTuples
struct NamedTupleIterator{schema, T}
    x::T
end

"""
    Tables.namedtupleiterator(x)

Pass any table input source and return a `NamedTuple` iterator

See also [`rows`](@ref) and [`rowtable`](@ref).

Not for use with extremely wide tables with # of columns > 67K; current fundamental compiler limits
prevent constructing `NamedTuple`s that large.
"""
function namedtupleiterator(x)
    r = rows(x)
    sch = schema(r)
    stored(sch) && throw(ArgumentError("input table too wide ($(length(sch.names)) columns) to construct `NamedTuple` rows"))
    return NamedTupleIterator{typeof(sch), typeof(r)}(r)
end

namedtupleiterator(::Type{T}, x) where {T <: NamedTuple} = x
namedtupleiterator(T, x) = namedtupleiterator(x)

Base.IteratorEltype(::Type{NT}) where {names, types, T, NT<:NamedTupleIterator{Schema{names, types}, T}} = Base.HasEltype()
Base.IteratorEltype(::Type{NT}) where {T, NT<:NamedTupleIterator{Nothing, T}} = Base.EltypeUnknown()
Base.eltype(::Type{NT}) where {names, types, T, NT<:NamedTupleIterator{Schema{names, types}, T}} = NamedTuple{map(Symbol, names), types}
Base.IteratorSize(::Type{NT}) where {sch, T, NT<:NamedTupleIterator{sch, T}} = Base.IteratorSize(T)
Base.length(nt::NamedTupleIterator) = length(nt.x)
Base.size(nt::NamedTupleIterator) = (length(nt.x),)

@inline function _iterate(rows::NamedTupleIterator{Schema{names, T}}, st=()) where {names, T}
    # use of @generated justified because it's user-controlled; they explicitly asked for vector of namedtuples
    if @generated
        vals = Any[ :(getcolumn(row, $(fieldtype(T, i)), $i, $(quot(names[i])))) for i = 1:fieldcount(T) ]
        ret = Expr(:new, :(NamedTuple{names, T}), vals...)
        return quote
            x = iterate(rows.x, st...)
            x === nothing && return nothing
            row, st = x
            return $ret, (st,)
        end
    else
        x = iterate(rows.x, st...)
        x === nothing && return nothing
        row, st = x
        return NamedTuple{map(Symbol, names), T}(Tuple(getcolumn(row, fieldtype(T, i), i, names[i]) for i = 1:fieldcount(T))), (st,)
    end
end

@inline function Base.iterate(rows::NamedTupleIterator{Schema{names, T}}, st=()) where {names, T}
    if fieldcount(T) <= SPECIALIZATION_THRESHOLD
        return _iterate(rows, st)
    else
        x = iterate(rows.x, st...)
        x === nothing && return nothing
        row, st = x
        return NamedTuple{map(Symbol, names), T}(Tuple(getcolumn(row, fieldtype(T, i), i, names[i]) for i = 1:fieldcount(T))), (st,)
    end
end

function Base.iterate(rows::NamedTupleIterator{Nothing})
    x = iterate(rows.x)
    x === nothing && return nothing
    row, st = x
    names = Tuple(columnnames(row))
    return NamedTuple{names}(Tuple(getcolumn(row, nm) for nm in names)), (Val(names), (st,))
end

function Base.iterate(rows::NamedTupleIterator{Nothing}, state::Tuple{Val{names}, T}) where {names, T}
    x = iterate(rows.x, state[2]...)
    x === nothing && return nothing
    row, st = x
    return NamedTuple{names}(Tuple(getcolumn(row, nm) for nm in names)), (Val(names), (st,))
end

# sink function
"""
    Tables.rowtable(x) => Vector{NamedTuple}

Take any input table source, and produce a `Vector` of `NamedTuple`s,
also known as a "row table". A "row table" is a kind of default
table type of sorts, since it satisfies the Tables.jl row interface
naturally, i.e. a `Vector` naturally iterates its elements, and
`NamedTuple` satisfies the `AbstractRow` interface by default (allows
indexing value by index, name, and getting all names).

For a lazy iterator over rows see [`rows`](@ref) and [`namedtupleiterator`](@ref).

Not for use with extremely wide tables with # of columns > 67K; current fundamental compiler limits
prevent constructing `NamedTuple`s that large.
"""
function rowtable end

function rowtable(itr::T) where {T}
    r = rows(itr)
    return collect(namedtupleiterator(eltype(r), r))
end

# NamedTuple of arrays of matching dimensionality
const ColumnTable = NamedTuple{names, T} where {names, T <: NTuple{N, AbstractVector}} where {N}
rowcount(c::ColumnTable) = length(c) == 0 ? 0 : length(c[1])

function subset(x::ColumnTable, inds; viewhint::Union{Bool,Nothing}=nothing, view::Union{Bool,Nothing}=nothing)
    if view !== nothing
        @warn "`view` keyword argument is deprecated for `Tables.subset`, use `viewhint` instead"
        viewhint = view
    end
    if inds isa Integer
        return map(c -> c[inds], x)
    else
        return viewhint === true ? map(c -> vectorcheck(Base.view(c, inds)), x) : map(c -> vectorcheck(c[inds]), x)
    end
end

# interface implementation
istable(::Type{<:ColumnTable}) = true
columnaccess(::Type{<:ColumnTable}) = true
# a NamedTuple of AbstractVectors is itself a `Columns` object
columns(x::ColumnTable) = x

_eltype(::Type{A}) where {T, A <: AbstractVector{T}} = T
Base.@pure function _eltypes(::Type{NT}) where {NT <: ColumnTable}
    return Tuple{Any[ _eltype(fieldtype(NT, i)) for i = 1:fieldcount(NT) ]...}
end

names(::Type{NT}) where {nms, T, NT<:NamedTuple{nms, T}} = nms
types(::Type{NT}) where {nms, T, NT<:NamedTuple{nms, T}} = T

schema(x::T) where {T <: ColumnTable} = Schema(names(T), _eltypes(T))
materializer(x::ColumnTable) = columntable

getarray(x::AbstractArray) = x
getarray(x) = collect(x)

"""
    Tables.columntable(x) => NamedTuple of AbstractVectors

Takes any input table source `x` and returns a `NamedTuple` of `AbstractVector`s,
also known as a "column table". A "column table" is a kind of default
table type of sorts, since it satisfies the Tables.jl column interface
naturally.

Note that if `x` is an object in which columns are stored as vectors, the check that
these vectors use 1-based indexing is not performed (it should be ensured when `x` is constructed).

Not for use with extremely wide tables with # of columns > 67K; current fundamental compiler limits
prevent constructing `NamedTuple`s that large.
"""
function columntable end

function _columntable(sch::Schema{names, types}, cols) where {names, types}
    # use of @generated justified because it's user-controlled; they explicitly asked for namedtuple of vectors
    if @generated
        vals = Tuple(:(getarray(getcolumn(cols, $(fieldtype(types, i)), $i, $(quot(names[i]))))) for i = 1:fieldcount(types))
        return :(NamedTuple{map(Symbol, names)}(($(vals...),)))
    else
        return NamedTuple{map(Symbol, names)}(Tuple(getarray(getcolumn(cols, fieldtype(types, i), i, names[i])) for i = 1:fieldcount(types)))
    end
end

function columntable(sch::Schema{names, types}, cols) where {names, types}
    if fieldcount(types) <= SPECIALIZATION_THRESHOLD
        return _columntable(sch, cols)
    else
        return NamedTuple{map(Symbol, names)}(Tuple(getarray(getcolumn(cols, fieldtype(types, i), i, names[i])) for i = 1:fieldcount(types)))
    end
end

# extremely large tables or schema explicitly stored
function columntable(sch::Schema{nothing, nothing}, cols)
    nms = sch.names
    if nms !== nothing && length(nms) > SPECIALIZATION_THRESHOLD
        throw(ArgumentError("input table too wide ($(length(nms)) columns) to convert to `NamedTuple` of `AbstractVector`s"))
    end
    return NamedTuple{Tuple(map(Symbol, nms))}(Tuple(getarray(getcolumn(cols, nms[i])) for i = 1:length(nms)))
end

# unknown schema case
columntable(::Nothing, cols) =
    NamedTuple{Tuple(map(Symbol, columnnames(cols)))}(Tuple(getarray(getcolumn(cols, col)) for col in columnnames(cols)))

function columntable(itr::T) where {T}
    cols = columns(itr)
    cols isa ColumnTable && return cols
    return columntable(schema(cols), cols)
end
columntable(x::ColumnTable) = x

# implement default nrow and ncol methods for DataAPI.jl

DataAPI.nrow(table::ColumnTable) = isempty(table) ? 0 : length(first(table))
DataAPI.ncol(table::ColumnTable) = length(table)

DataAPI.nrow(table::RowTable) = length(table)
DataAPI.ncol(table::RowTable) = isempty(table) ? 0 : length(first(table))

struct IndexOnlyColumn{T}
    data::Vector{T}
end
Base.length(c::IndexOnlyColumn) = length(c.data)
Base.getindex(c::IndexOnlyColumn, i::Int) = c.data[i]

struct IndexOnlyTable{T} <: Tables.AbstractColumns
    a::IndexOnlyColumn{T}
end
Tables.columnnames(::IndexOnlyTable) = (:a,)
Tables.getcolumn(t::IndexOnlyTable, ::Int) = getfield(t, :a)
Tables.getcolumn(t::IndexOnlyTable, ::Symbol) = getfield(t, :a)

struct ZeroColumnTable <: Tables.AbstractColumns
    nrows::Int
end
Tables.columnnames(::ZeroColumnTable) = ()
Tables.getcolumn(::ZeroColumnTable, i::Int) = throw(BoundsError((), i))
Tables.getcolumn(::ZeroColumnTable, name::Symbol) = throw(ArgumentError("unknown column $name"))
Tables.rowcount(t::ZeroColumnTable) = getfield(t, :nrows)

@testset "scan.jl" begin

    T = Tables
    nt = (a = [1, 2, 3, 4, missing],
          b = ["x", "yy", "zzz", "x", "w"],
          c = [1.5, 2.5, 3.5, 4.5, 5.5],
          x_one = [10, 20, 30, 40, 50],
          x_two = [-1, -2, -3, -4, -5])

    @testset "construction & lowering" begin
        s = T.Scan(select = (:a, "b" => :bee, :c => Float32, :a => Int64 => :a2, 4, r"^x_"))
        @test length(s.select) == 6
        @test s.select[1] == T.SelectItem(:a, nothing, nothing)
        @test s.select[2] == T.SelectItem("b", nothing, :bee)
        @test s.select[3] == T.SelectItem(:c, Float32, nothing)
        @test s.select[4] == T.SelectItem(:a, Int64, :a2)
        @test s.select[5] == T.SelectItem(4, nothing, nothing)
        @test s.select[6].ref isa Regex
        @test T.Scan(select = :a).select == [T.SelectItem(:a, nothing, nothing)]
        @test T.Scan().select == [T.SelectItem(T.All(), nothing, nothing)]
        @test isempty(T.Scan(select = ()).select)
        @test_throws ArgumentError T.Scan(select = nothing)
        @test T._isidentity(T.Scan())
        @test T._isidentity(T.Scan(select = T.All()))
        @test !T._isidentity(T.Scan(limit = 5))
        @test !T._isidentity(T.Scan(offset = 1))
        @test_throws ArgumentError T.Scan(select = (:a => 1.5,))
        @test_throws ArgumentError T.Scan(select = (T.Not(:a), :b))   # mixed Not/positive
        @test_throws ArgumentError T.Scan(select = T.Not(1.5))
        @test_throws ArgumentError T.Scan(limit = -1)
        @test_throws ArgumentError T.Scan(offset = -1)
        @test_throws ArgumentError T.Scan(T.Scan(); limit = -1)
        @test_throws ArgumentError T.Scan(T.Scan(); offset = -1)
        @test_throws ArgumentError T.Scan(T.Scan().select, nothing, -1, 0, true)
        @test T.Scan(T.Scan(); limit = Int16(2)).limit == 2
        @test_throws ArgumentError T.Scan(filter = T.col(:a))         # bare column
        @test_throws ArgumentError T.Scan(filter = !T.col(:a))
        @test_throws ArgumentError T.Scan(filter = T.col(:a) & (T.col(:b) > 1))
        @test_throws ArgumentError T.Scan(filter = (x -> true))       # closures rejected
    end

    @testset "expression algebra" begin
        c = T.col(:a)
        @test (c > 1) isa T.Cmp{Int}
        @test (1 > c).op == T.OP_LT                                   # reversed comparison flips
        @test T.colcmp(==, c, 1) == T.Cmp(T.OP_EQ, T.Col(:a), 1)
        @test T.colcmp(!=, c, 1).op == T.OP_NE
        @test T.colcmp(<, c, 1).op == T.OP_LT
        @test T.colcmp(<=, c, 1).op == T.OP_LE
        @test T.colcmp(>, c, 1).op == T.OP_GT
        @test T.colcmp(>=, c, 1).op == T.OP_GE
        @test T.colcmp(==, c, :ready).rhs == :ready                    # general literal form
        @test T.colcmp(==, c, 1).op isa T.ComparisonOperator
        @test T.isnull(c) == T.IsNull(T.Col(:a), false)
        @test Base.ismissing(c) === false
        @test which(Base.ismissing, (typeof(c),)) === which(Base.ismissing, (Any,))
        @test Base.isequal(c, c) === true
        @test Base.isequal(c, 1) === false
        @test !T.isnull(c) == T.IsNull(T.Col(:a), true)
        @test c == T.col(:a)
        @test c != T.col(:b)
        @test_throws ArgumentError T.colcmp(==, T.col(:a), T.col(:b)) # col-to-col filter
        @test_throws ArgumentError T.colcmp(isless, c, 1)
        @test_throws ArgumentError T.Cmp(T.OP_EQ, T.col(:a), T.col(:b))
        @test_throws ArgumentError T.In(T.col(:a), T.col(:b))
        e = (c > 1) & (c < 5) & T.colin(T.col(:b), ("x", "w"))
        @test e isa T.AndExpr && length(e.args) == 3                  # flattened
        o = (c > 1) | (c < 0) | T.isnull(c)
        @test o isa T.OrExpr && length(o.args) == 3
        @test T.colin(T.col(:b), ["x"]) isa T.In
        @test startswith(T.col(:b), "z") isa T.StrPred
    end

    @testset "resolve" begin
        names = [:a, :b, :c, :x_one, :x_two]
        @test T.All === DataAPI.All
        b = T.resolve(T.Scan(), names)
        @test [c.index for c in b.columns] == 1:5
        b = T.resolve(T.Scan(select = (r"^x_", :a => :first)), names)
        @test [(c.index, c.name) for c in b.columns] == [(4, :x_one), (5, :x_two), (1, :first)]
        b = T.resolve(T.Scan(select = (:a => :first, T.All())), names)
        @test [(c.index, c.name) for c in b.columns] ==
              [(1, :first), (1, :a), (2, :b), (3, :c), (4, :x_one), (5, :x_two)]
        @test_throws ArgumentError T.resolve(T.Scan(select = (:a, T.All())), names)
        b = T.resolve(T.Scan(select = T.Not((r"^x_", :b))), names)
        @test [c.index for c in b.columns] == [1, 3]
        b = T.resolve(T.Scan(filter = (T.col(:a) > 1) & T.isnull(T.col(:c))), names)
        @test sort(b.filtercols) == [1, 3]
        positional = T.resolve(T.Scan(filter = T.col(3) > 1), names)
        @test positional.filter.lhs.ref === :c
        @test T.filtermask(positional, (c = [1, 2, 3],)) == [false, true, true]
        @test_throws ArgumentError T.resolve(T.Scan(select = :nope), names)
        @test_throws ArgumentError T.resolve(T.Scan(select = 6), names)
        @test_throws ArgumentError T.resolve(T.Scan(select = r"^nope"), names)
        @test_throws ArgumentError T.resolve(T.Scan(select = T.Not(r"^nope")), names)
        @test_throws ArgumentError T.resolve(T.Scan(select = (:a, :b => :a)), names)   # dup output
        @test_throws ArgumentError T.resolve(T.Scan(select = r"^x_" => :same), names)  # multi rename
        @test_throws ArgumentError T.resolve(T.Scan(filter = T.col(:nope) > 1), names)
        @test_throws ArgumentError T.resolve(
            T.Scan(filter = T.OpNode(:custom, Any[T.col(2), 1])), names,
        )
        # validate=false silently drops unmatched, keeps the rest
        b = T.resolve(T.Scan(select = (:nope, :a), validate = false), names)
        @test [c.index for c in b.columns] == [1]
        b = T.resolve(T.Scan(select = (9, :a), validate = false), names)
        @test [c.index for c in b.columns] == [1]
        b = T.resolve(T.Scan(select = T.Not((r"^nope", :b)), validate = false), names)
        @test [c.index for c in b.columns] == [1, 3, 4, 5]
        b = T.resolve(T.Scan(filter = T.col(:nope) > 1, validate = false), names)
        @test isempty(b.filtercols)
        @test T.filtermask(b, (a = [1, 2],)) == [false, false]
    end

    @testset "scan: filter semantics (SQL missing), limit/offset, projection" begin
        out = T.scan(nt, T.Scan(filter = T.col(:a) > 1))
        @test out.a == [2, 3, 4]                                      # missing row EXCLUDED
        out = T.scan(nt, T.Scan(filter = T.isnull(T.col(:a))))
        @test length(out.a) == 1 && ismissing(out.a[1])
        out = T.scan(nt, T.Scan(filter = !T.isnull(T.col(:a))))
        @test out.a == [1, 2, 3, 4]
        out = T.scan(nt, T.Scan(filter = T.colcmp(!=, T.col(:a), 1)))
        @test out.a == [2, 3, 4]                                      # != never matches missing
        out = T.scan(nt, T.Scan(filter = T.colin(T.col(:b), ("x", "w"))))
        @test out.b == ["x", "x", "w"]
        out = T.scan(nt, T.Scan(filter = startswith(T.col(:b), "z") | endswith(T.col(:b), "y")))
        @test out.b == ["yy", "zzz"]
        missingvals = (a = Union{Int, Missing}[1, missing, 3],
                       b = Union{String, Missing}["x", missing, "z"])
        @test T.filtermask(T.colin(T.col(:a), (1, missing)), missingvals) ==
              [true, false, false]
        @test T.filtermask(T.colin(T.col(:a), (2, missing)), missingvals) ==
              [false, false, false]
        @test T.filtermask(T.colin(T.col(:a), Set([missing])), missingvals) ==
              [false, false, false]
        @test T.filtermask(startswith(T.col(:b), "x"), missingvals) ==
              [true, false, false]
        @test T.filtermask(!T.colin(T.col(:a), (1, missing)), missingvals) ==
              [false, false, false]
        @test T.filtermask(T.Cmp(T.OP_NE, T.col(:a), 1), missingvals) ==
              [false, false, true]
        @test_throws ArgumentError T.filtermask(!T.col(:a), missingvals)
        @test T.filtermask(T.AndExpr(T.ScanExpr[]), missingvals) == [true, true, true]
        @test T.filtermask(T.OrExpr(T.ScanExpr[]), missingvals) == [false, false, false]
        # the final function barrier keeps only exact `true` (SQL WHERE)
        @test T._boolmask(BitVector([true, false])) == [true, false]
        @test T._boolmask(Bool[false, true]) == [false, true]
        @test T._boolmask(Union{Bool, Missing}[true, missing, false]) ==
              [true, false, false]
        @test T._boolmask(Any[true, 1, missing, nothing]) ==
              [true, false, false, false]
        @test_throws ArgumentError T.Cmp(0xff, T.col(:a), 1)
        @test_throws ArgumentError T.StrPred(0xff, T.col(:b), "x")
        out = T.scan(nt, T.Scan(limit = 2, offset = 1))
        @test isequal(out.a, [2, 3])
        out = T.scan(nt, T.Scan(filter = T.col(:c) > 2.0, limit = 2))
        @test out.c == [2.5, 3.5]
        out = T.scan(nt, T.Scan(offset = 10))
        @test isempty(out.a)
        out = T.scan(nt, T.Scan(offset = typemax(Int)))
        @test isempty(out.a)
        out = T.scan(nt, T.Scan(offset = 1, limit = typemax(Int)))
        @test isequal(out.a, [2, 3, 4, missing])
        # projection order, rename, type override
        out = T.scan(nt, T.Scan(select = (:c => Float32 => :cf, 1)))
        @test keys(out) == (:cf, :a)
        @test out.cf isa Vector{Float32}
        # type override preserves missing
        out = T.scan(nt, T.Scan(select = (:a => Float64,)))
        @test isequal(out.a, [1.0, 2.0, 3.0, 4.0, missing])
        @test eltype(out.a) == Union{Float64, Missing}
        converted = Union{Float64, Missing}[1.0, missing]
        @test T._converted(Float64, converted) === converted
        @test_throws InexactError T.scan((a = [1.5],), T.Scan(select = (:a => Int,)))
        indexonly = IndexOnlyTable(IndexOnlyColumn([10, 20, 30, 40]))
        @test T.scan(indexonly, T.Scan(select = :a, offset = 1, limit = 2)).a == [20, 30]
        @test T.filtermask(T.col(:a) > 20, indexonly) == [false, false, true, true]
        @test T.filtermask(T.colin(T.col(:a), (10, 40)), indexonly) ==
              [true, false, false, true]
        indexmissing = IndexOnlyTable(IndexOnlyColumn(Union{Int, Missing}[10, missing, 30]))
        @test T.filtermask(T.isnull(T.col(:a)), indexmissing) == [false, true, false]
        indexstrings = IndexOnlyTable(IndexOnlyColumn(["ab", "bc", "ax"]))
        @test T.filtermask(startswith(T.col(:a), "a"), indexstrings) == [true, false, true]
        # empty residual = identity
        @test T.scan(nt, T.Scan()) === nt
    end

    @testset "scan: validate=false filters treat unmatched refs as all-missing" begin
        nt2 = (a = [1, 2, 3], b = ["x", "y", "z"])
        # strict (default): unknown filter refs error, matching resolve
        @test_throws ArgumentError T.scan(nt2, T.Scan(filter = T.col(:gone) > 1))
        @test_throws ArgumentError T.filtermask(T.col(:gone) > 1, nt2)
        # lenient: comparisons/membership/strings against the absent column
        # evaluate to missing → rows excluded, SQL-style
        for f in (T.col(:gone) > 1, T.colin(T.col(:gone), (1, 2)),
                  startswith(T.col(:gone), "x"))
            out = T.scan(nt2, T.Scan(filter = f, validate = false))
            @test isempty(out.a)
        end
        # the absent column reads as missing: isnull keeps all, !isnull keeps none
        out = T.scan(nt2, T.Scan(filter = T.isnull(T.col(:gone)), validate = false))
        @test out.a == [1, 2, 3]
        out = T.scan(nt2, T.Scan(filter = !T.isnull(T.col(:gone)), validate = false))
        @test isempty(out.a)
        # three-valued composition with a matched predicate
        out = T.scan(nt2, T.Scan(filter = (T.col(:gone) > 1) | (T.col(:a) >= 3),
                                   validate = false))
        @test out.a == [3]
        out = T.scan(nt2, T.Scan(filter = (T.col(:gone) > 1) & (T.col(:a) >= 1),
                                   validate = false))
        @test isempty(out.a)
        # the Scan form of filtermask follows validate; resolve still omits the
        # unmatched ref from filtercols
        @test T.filtermask(T.Scan(filter = T.isnull(T.col(:gone)), validate = false),
                           nt2) == [true, true, true]
        b = T.resolve(T.Scan(filter = (T.col(:gone) > 1) & (T.col(:a) > 1),
                             validate = false), (:a, :b))
        @test b.filtercols == [1]
    end

    @testset "scan: collection-valued rows compare whole-value per row" begin
        lists = (l = [[1, 2], [3], [1, 2]], n = [10, 20, 30])
        # equality against a vector literal is per-row whole-value equality —
        # never an elementwise broadcast into the rows (which zips silently
        # when lengths happen to match and throws DimensionMismatch when not)
        out = T.scan(lists, T.Scan(filter = T.colcmp(==, T.col(:l), [1, 2])))
        @test out.n == [10, 30]
        out = T.scan(lists, T.Scan(filter = T.colcmp(!=, T.col(:l), [1, 2])))
        @test out.n == [20]
        @test T.filtermask(T.colin(T.col(:l), ([[3]], [[1, 2]])), lists) ==
              [false, false, false]
        @test T.filtermask(T.colin(T.col(:l), ([3],)), lists) == [false, true, false]
        # a 2-row column against a 2-element literal must still be whole-value
        two = (l = [[1, 2], [5, 6]], n = [1, 2])
        out = T.scan(two, T.Scan(filter = T.colcmp(==, T.col(:l), [5, 6])))
        @test out.n == [2]
        # missing rows keep SQL semantics through whole-value comparison
        lm = (l = Union{Missing, Vector{Int}}[[1], missing, [2]], n = [1, 2, 3])
        out = T.scan(lm, T.Scan(filter = T.colcmp(==, T.col(:l), [2])))
        @test out.n == [3]
    end

    @testset "generic executor + residual construction" begin
        s = T.Scan(select = (:b, :a), filter = T.col(:a) >= 2, limit = 1)
        out = T.scan(nt, s)
        @test out.b == ["yy"] && out.a == [2]
        # works through any Tables.jl source, e.g. a row iterator
        rows = Tables.rowtable(nt)
        out = T.scan(rows, s)
        @test out.b == ["yy"] && out.a == [2]
        @test T.filtermask(s, nt) == [false, true, true, true, false]
        # a source that pushed select/limit down hands the filter to Tables.scan
        residual = T.Scan(s; select = T.All(), limit = nothing, offset = 0)
        @test T._isallselection(residual.select) && residual.limit === nothing && residual.filter === s.filter
        pushed = (b = nt.b, a = nt.a)                # what the source materialized (projection done)
        @test isequal(T.scan(pushed, residual).a, [2, 3, 4])   # filter applied generically
        @test T._isidentity(T.Scan(s; select = T.All(), filter = nothing, limit = nothing))
        @test T.Scan(s; select = (:c,)).select == T.Scan(select = (:c,)).select
    end

    @testset "zero-column results preserve row counts" begin
        projected = T.scan(nt, T.Scan(select = ()))
        @test isempty(T.columnnames(projected))
        @test T.rowcount(projected) == 5
        @test DataAPI.nrow(projected) == 5
        @test length(T.rows(projected)) == 5

        filtered = T.scan(nt, T.Scan(select = (), filter = T.col(:a) > 1))
        @test T.rowcount(filtered) == 3

        source = ZeroColumnTable(1_000_000)
        windowed = T.scan(source, T.Scan(offset = 7, limit = 2))
        @test T.rowcount(windowed) == 2
        @test_throws ArgumentError T.scan(source, T.Scan(filter = T.isnull(T.col(:gone))))
        missingmatch = T.scan(source, T.Scan(
            filter = T.isnull(T.col(:gone)), validate = false, limit = 3,
        ))
        @test T.rowcount(missingmatch) == 3
        missingcmp = T.scan(source, T.Scan(
            filter = T.colcmp(==, T.col(:gone), 1), validate = false,
        ))
        @test T.rowcount(missingcmp) == 0
        overflowwindow = T.scan(source, T.Scan(offset = typemax(Int), limit = typemax(Int)))
        @test T.rowcount(overflowwindow) == 0

        T.scan(source, T.Scan(limit = 1))
        @test @allocated(T.scan(source, T.Scan(limit = 1))) < 100_000
    end

    @testset "display" begin
        s = T.Scan(select = (:a => Int64 => :z, T.All()), filter = !T.isnull(T.col(:a)), limit = 3)
        str = sprint(show, s)
        @test occursin("select =", str) && occursin("limit = 3", str)
        @test occursin("isnull", sprint(show, T.Scan(filter = T.isnull(T.col(:x)))))
        @test occursin("filter = true", sprint(show, T.Scan(filter = T.AndExpr(T.ScanExpr[]))))
        @test occursin("filter = false", sprint(show, T.Scan(filter = T.OrExpr(T.ScanExpr[]))))
        @test sprint(show, T.Scan()) == "Tables.Scan()"
        @test sprint(show, T.Scan(select = ())) == "Tables.Scan(select = ())"
        io = IOBuffer()
        T.describe(io, s, T.Scan())
        @test occursin("fully pushed down", String(take!(io)))
    end

    @testset "All arguments, Union{} override, residual composition" begin
        # DataAPI.All(cols...) with arguments must not silently select everything
        @test_throws ArgumentError T.Scan(select = T.All(:a))
        @test_throws ArgumentError T.Scan(select = (T.All(:a, :b),))

        # a Union{} column still honors the requested override type
        empty = T.scan((u = Union{}[],), T.Scan(select = (:u => Float64,)))
        @test T.columntable(empty).u isa Vector{Float64}

        # residual composition: stripping a consumed axis reproduces the
        # reference result, in execution order (filter, then row bounds,
        # then projection)
        source = (a = collect(1:6), b = collect(10.0:10.0:60.0))
        request = T.Scan(select = (:b => :value,), filter = T.col(:a) > 2,
                         limit = 2, offset = 1)
        reference = T.columntable(T.scan(source, request))
        @test reference == (value = [40.0, 50.0],)
        # source consumed the filter
        mask = T.filtermask(request, source)
        filtered = (a = source.a[mask], b = source.b[mask])
        residual = T.Scan(request; filter = nothing)
        @test T.columntable(T.scan(filtered, residual)) == reference
        # source consumed the filter and the row bounds
        bounded = (a = filtered.a[2:3], b = filtered.b[2:3])
        residual2 = T.Scan(request; filter = nothing, limit = nothing, offset = 0)
        @test T.columntable(T.scan(bounded, residual2)) == reference
    end

end

using Test, Tables, OrderedCollections, TableTraits, DataValues, QueryOperators, IteratorInterfaceExtensions, SparseArrays, DataAPI

@testset "utils.jl" begin

    @test getproperty((1, 2), 1) == 1

    NT = NamedTuple{(), Tuple{}}
    @test Tables.names(NT) === ()
    @test Tables.types(NT) === Tuple{}
    @test isempty(Tables.runlength(Tables.types(NT)))
    @test Tables.columnindex(Tables.names(NT), :i) == 0
    @test Tables.columntype(Tables.names(NT), Tables.types(NT), :i) == Union{}

    NT = NamedTuple{(:a, :b, :c), NTuple{3, Int64}}
    @test Tables.names(NT) === (:a, :b, :c)
    @test Tables.types(NT) === Tuple{Int64, Int64, Int64}
    @test Tables.runlength(Tables.types(NT)) == [(Int64, 3)]
    @test Tables.columnindex(Tables.names(NT), :a) == 1
    @test Tables.columnindex(Tables.names(NT), :i) == 0
    @test Tables.columntype(Tables.names(NT), Tables.types(NT), :a) == Int64
    @test Tables.columntype(Tables.names(NT), Tables.types(NT), :i) == Union{}

    NT = NamedTuple{Tuple(Symbol("a$i") for i = 1:20), Tuple{vcat(fill(Int, 10), fill(String, 10))...}}
    @test Tables.names(NT) === Tuple(Symbol("a$i") for i = 1:20)
    @test Tables.types(NT) === Tuple{vcat(fill(Int, 10), fill(String, 10))...}
    @test Tables.runlength(Tables.types(NT)) == [(Int, 10), (String, 10)]
    @test Tables.columnindex(Tables.names(NT), :a20) == 20
    @test Tables.columnindex(Tables.names(NT), :i) == 0
    @test Tables.columntype(Tables.names(NT), Tables.types(NT), :a20) == String
    @test Tables.columntype(Tables.names(NT), Tables.types(NT), :i) == Union{}

    nt = (a=1, b=2, c=3)
    NT = typeof(nt)
    output = [0, 0, 0]
    Tables.eachcolumn(Tables.Schema(Tables.names(NT), Tables.types(NT)), nt) do val, col, nm
        output[col] = val
    end
    @test output == [1, 2, 3]

    nt = NamedTuple{Tuple(Symbol("a$i") for i = 1:101)}(Tuple(i for i = 1:101))
    NT = typeof(nt)
    @test Tables.runlength(Tables.types(NT)) == [(Int, 101)]
    output = zeros(Int, 101)
    Tables.eachcolumn(Tables.Schema(Tables.names(NT), Tables.types(NT)), nt) do val, col, nm
        output[col] = val
    end
    @test output == [i for i = 1:101]

    nt = NamedTuple{Tuple(Symbol("a$i") for i = 1:101)}(Tuple(i % 2 == 0 ? i : "$i" for i = 1:101))
    NT = typeof(nt)
    @test Tables.runlength(Tables.types(NT)) == [i % 2 == 0 ? (Int, 1) : (String, 1) for i = 1:101]
    output = Vector{Any}(undef, 101)
    Tables.eachcolumn(Tables.Schema(Tables.names(NT), Tables.types(NT)), nt) do val, col, nm
        output[col] = val
    end
    @test output == [i % 2 == 0 ? i : "$i" for i = 1:101]

    nt = (a=Ref(0), b=Ref(0))
    Tables.eachcolumn(Tables.Schema((:a, :b), nothing), (a=1, b=2)) do val, col, nm
        nt[nm][] = val
    end
    @test nt.a[] == 1
    @test nt.b[] == 2

    nt = (a=[1,2,3], b=[4,5,6])
    @test Tables.columnindex(nt, :i) == 0
    @test Tables.columnindex(nt, :a) == 1
    @test Tables.columntype(nt, :a) == Int
    @test Tables.columntype(nt, :i) == Union{}

    rows = Tables.rows(nt)
    @test eltype(rows) == Tables.ColumnsRow{typeof(nt)}
    @test Tables.schema(rows) == Tables.Schema((:a, :b), (Int, Int))
    @test rows.a == [1,2,3]
    @test propertynames(rows) == Tables.columnnames(rows) == (:a, :b)
    row = first(rows)
    @test row.a == 1
    @test Tables.getcolumn(row, :a) == 1
    @test Tables.getcolumn(row, 1) == 1
    @test Tables.istable(rows)
    @test Tables.rowaccess(rows)
    @test Tables.rows(rows) === rows
    @test Tables.columnaccess(rows)
    @test Tables.columns(rows) === nt
    @test Tables.materializer(rows) === Tables.materializer(nt)

    @test Tables.rowmerge(row; b=200, hey="hello") == (a=1, b=200, hey="hello")
    @test Tables.rowmerge(row, (hey="hello", a=200)) == (a=200, b=4, hey="hello")
    @test Tables.rowmerge(row, (hey="hello", a=200), row, (x=:x, y=:y, hey="bye")) == (a=1, b=4, hey="bye", x=:x, y=:y)

    @test Tables.sym(1) === 1
    @test Tables.sym("hey") == :hey

    @test propertynames(Tables.Schema((:a, :b), nothing)) == (:names, :types)

    v = Tables.EmptyVector(1)
    @test_throws UndefRefError v[1]
    @test Base.IndexStyle(typeof(v)) == Base.IndexLinear()

    @test Tables.istable(Tables.CopiedColumns)
    @test Tables.columnaccess(Tables.CopiedColumns)
    c = Tables.CopiedColumns(nt)
    @test Tables.columns(c) === c
    @test Tables.materializer(c) == Tables.materializer(nt)
    @test Tables.getcolumn(c, :a) == [1,2,3]
    @test Tables.getcolumn(c, 1) == [1,2,3]

    @test_throws ArgumentError Tables.columntable([1,2,3])

    tt = [(1,2,3), (4,5,6)]
    r = Tables.nondatavaluerows(tt)
    row = first(r)
    @test getproperty(row, 1) == 1
    @test Tables.columntable(tt) == NamedTuple{(Symbol("1"), Symbol("2"), Symbol("3"))}(([1, 4], [2, 5], [3, 6]))

    @test Tables.getarray([1,2,3]) == [1,2,3]
    @test Tables.getarray((1,2,3)) == [1,2,3]

    # empty schema
    sch = Tables.Schema((), ())
    @test sch.names == ()
    @test sch.types == ()
end

@testset "namedtuples.jl" begin

    nt = (a=1, b=2, c=3)
    rt = [nt, nt, nt]
    @test Tables.rows(rt) === rt
    @test Tables.schema(rt).names == Tables.names(typeof(nt))
    @test Tables.namedtupleiterator(eltype(rt), rt) === rt

    rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
    nt = (a=[1,2,3], b=[4.0, 5.0, 6.0], c=["7", "8", "9"])
    @test Tables.rowcount(nt) == 3
    @test Tables.schema(nt) == Tables.Schema((:a, :b, :c), Tuple{Int, Float64, String})
    @test Tables.istable(typeof(nt))
    @test Tables.columnaccess(typeof(nt))
    @test Tables.columns(nt) === nt
    @test rowtable(nt) == rt
    @test columntable(rt) == nt
    @test rt == (rt |> columntable |> rowtable)
    @test nt == (nt |> rowtable |> columntable)

    @test Tables.buildcolumns(nothing, rt) == nt
    @test Tables.columntable(nothing, nt) == nt

    @testset "columntable subset" begin
        @test Tables.subset(nt, 1) == (a=1, b=4.0, c="7")
        @test Tables.subset(nt, 1, viewhint=false) == (a=1, b=4.0, c="7")
        @test Tables.subset(nt, 1, viewhint=nothing) == (a=1, b=4.0, c="7")
        @test Tables.subset(nt, 1:2) == (a=[1,2], b=[4.0, 5.0], c=["7","8"])
        @test Tables.subset(nt, 1:2, viewhint=false) == (a=[1,2], b=[4.0, 5.0], c=["7","8"])
        @test Tables.subset(nt, 1:2, viewhint=nothing) == (a=[1,2], b=[4.0, 5.0], c=["7","8"])
        @test_throws ArgumentError Tables.subset(nt, [1:2 1:2])
        @test_throws ArgumentError Tables.subset(Tables.dictrowtable(nt), [1:2 1:2])

        @test Tables.subset(nt, 1, viewhint=true) == (a=1, b=4.0, c="7")
        rs = Tables.subset(nt, 1:2, viewhint=true)
        @test rs == (a=[1,2], b=[4.0, 5.0], c=["7","8"])
        @test rs.a.parent === nt.a
    end

    @testset "rowtable subset" begin
        @test Tables.subset(rt, 1) == (a=1, b=4.0, c="7")
        @test Tables.subset(rt, 1, viewhint=false) == (a=1, b=4.0, c="7")
        @test Tables.subset(rt, 1, viewhint=nothing) == (a=1, b=4.0, c="7")
        @test Tables.subset(rt, 1:2) == [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8")]
        @test Tables.subset(rt, 1:2, viewhint=false) == [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8")]
        @test Tables.subset(rt, 1:2, viewhint=nothing) == [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8")]
        @test_throws ArgumentError Tables.subset(rt, [1:2 1:2])

        @test Tables.subset(rt, 1, viewhint=true) == (a=1, b=4.0, c="7")
        rs = Tables.subset(rt, 1:2, viewhint=true)
        @test rs == [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8")]
        @test rs.parent === rt
    end

    # test push!
    rtf = Iterators.Filter(x->x.a >= 1, rt)
    @test Tables.columntable(rtf) == nt
    @test Tables.buildcolumns(nothing, rtf) == nt

    rt = [(a=1, b=4.0, c="7"), (a=2.0, b=missing, c="8"), (a=3, b=6.0, c="9")]
    @test Tables.istable(typeof(rt))
    @test Tables.rowaccess(typeof(rt))
    tt = Tables.buildcolumns(nothing, rt)
    @test isequal(tt, (a = [1.0, 2.0, 3.0], b = Union{Missing, Float64}[4.0, missing, 6.0], c = ["7", "8", "9"]))
    @test tt.a[1] === 1.0
    @test tt.a[2] === 2.0
    @test tt.a[3] === 3.0

    nti = Tables.NamedTupleIterator{Nothing, typeof(rt)}(rt)
    @test Base.IteratorEltype(typeof(nti)) == Base.EltypeUnknown()
    @test Base.IteratorSize(typeof(nti)) == Base.HasShape{1}()
    @test length(nti) == 3
    nti2 = collect(nti)
    @test isequal(rt, nti2)
    nti = Tables.NamedTupleIterator{typeof(Tables.Schema((:a, :b, :c), (Union{Int, Float64}, Union{Float64, Missing}, String))), typeof(rt)}(rt)
    @test eltype(typeof(nti)) == NamedTuple{(:a, :b, :c),Tuple{Union{Float64, Int},Union{Missing, Float64},String}}

    # test really wide tables
    nms = Tuple(Symbol("i", i) for i = 1:101)
    vals = Tuple(rand(Int, 3) for i = 1:101)
    nt = NamedTuple{nms}(vals)
    rt = Tables.rowtable(nt)
    @test length(rt) == 3
    @test length(rt[1]) == 101
    @test eltype(rt).parameters[1] == nms
    @test Tables.columntable(rt) == nt
    @test Tables.buildcolumns(nothing, rt) == nt

    # 228
    @test Tables.columntable(NamedTuple[]) === NamedTuple()

    @testset "Type stability of schema(x).types" begin
        _get_types(X) = Tables.schema(X).types

        x = (a=[1.0], b=[1.0])
        @inferred Tuple{Type{Float64},Type{Float64}} _get_types(x)

        # Trigger other branch which lacks type stability:
        x_wide = NamedTuple([Symbol("x$(i)") => [1.0] for i=1:513])
        @inferred NTuple{513,DataType} _get_types(x_wide)
    end
end

@testset "Materializer" begin
    rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
    nt = (a=[1,2,3], b=[4.0, 5.0, 6.0], c=["7", "8", "9"])

    @test nt == Tables.materializer(nt)(Tables.columns(nt))
    @test nt == Tables.materializer(nt)(Tables.columns(rt))
    @test nt == Tables.materializer(nt)(rt)
    @test rt == Tables.materializer(rt)(nt)

    function select(table, cols::Symbol...)
        Tables.istable(table) || throw(ArgumentError("select requires a table input"))
        nt = Tables.columntable(table)  # columntable(t) creates a NamedTuple of AbstractVectors
        newcols = NamedTuple{cols}(nt)
        Tables.materializer(table)(newcols)
    end

    @test select(nt, :a, :b, :c) == nt
    @test select(nt, :c, :a) == NamedTuple{(:c, :a)}(nt)
    @test select(rt, :a) == [(a=1,), (a=2,), (a=3,)]

    @test Tables.materializer(1) === Tables.columntable
end

# Table with tuple columns.
struct MockTable end
Tables.istable(::Type{MockTable}) = true
Tables.columnaccess(::Type{MockTable}) = true
Tables.columnnames(x::MockTable) = (:a, :b, :c)
Tables.columns(x::MockTable) = x
Tables.getcolumn(x::MockTable, ::Symbol) = (1, 2, 3)
Tables.getcolumn(x::MockTable, ::Int) = (1, 2, 3)
Tables.schema(x::MockTable) = Tables.Schema((:a, :b, :c), NTuple{3, Int})

struct TestMatrixTable <: AbstractMatrix{Int}
end
Tables.istable(::Type{TestMatrixTable}) = true
Tables.columnaccess(::Type{TestMatrixTable}) = true
Tables.columnnames(x::TestMatrixTable) = (:a, :b, :c)
Tables.columns(x::TestMatrixTable) = x
Tables.getcolumn(x::TestMatrixTable, ::Symbol) = (1, 2, 3)
Tables.getcolumn(x::TestMatrixTable, ::Int) = (1, 2, 3)
Tables.schema(x::TestMatrixTable) = Tables.Schema((:a, :b, :c), NTuple{3, Int})

@testset "Matrix integration" begin
    rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
    nt = (a=[1,2,3], b=[4.0, 5.0, 6.0])

    mat = Tables.matrix(rt)
    @test nt.a == mat[:, 1]
    @test size(mat) == (3, 3)
    @test eltype(mat) == Any
    @test_throws ArgumentError Tables.rows(mat)
    @test_throws ArgumentError Tables.columns(mat)
    mat2 = Tables.matrix(nt)
    @test eltype(mat2) == Float64
    @test mat2[:, 1] == nt.a
    @test !Tables.istable(mat2)
    @test !Tables.istable(typeof(mat2))
    mat3 = Tables.matrix(nt; transpose=true)
    @test size(mat3) == (2, 3)
    @test mat3[1, :] == nt.a
    @test mat3[2, :] == nt.b
    sp = Tables.table(sparse(mat[:, 1:2]))
    @test Tables.columnnames(sp) == [:Column1, :Column2]
    @test Tables.getcolumn(sp, 1) == [1, 2, 3]

    tbl = Tables.table(mat) |> columntable
    @test keys(tbl) == (:Column1, :Column2, :Column3)
    @test tbl.Column1 == [1, 2, 3]
    tbl2 = Tables.table(mat2) |> rowtable
    @test length(tbl2) == 3
    @test map(x->x.Column1, tbl2) == [1.0, 2.0, 3.0]

    mattbl = Tables.table(mat)
    @test Tables.istable(typeof(mattbl))
    @test Tables.rowaccess(typeof(mattbl))
    @test Tables.columnaccess(typeof(mattbl))
    @test Tables.columns(mattbl) === mattbl
    @test mattbl.Column1 == [1,2,3]
    @test Tables.getcolumn(mattbl, :Column1) == [1,2,3]
    @test Tables.getcolumn(mattbl, 1) == [1,2,3]
    matrowtbl = Tables.rows(mattbl)
    matrow = first(matrowtbl)
    @test eltype(matrowtbl) == typeof(matrow)
    @test matrow.Column1 == 1
    @test Tables.getcolumn(matrow, :Column1) == 1
    @test Tables.getcolumn(matrow, 1) == 1
    @test propertynames(mattbl) == propertynames(matrow) == [:Column1, :Column2, :Column3]

    mattbl = Tables.table(mat, header=[:A, :B, :C])
    @test Tables.columnnames(mattbl) == [:A, :B, :C]
    mattbl = Tables.table(mat, header=view(["DUMMY", "A", "B", "C"], 2:4))
    @test Tables.columnnames(mattbl) == [:A, :B, :C]
    mattbl = Tables.table(mat, header=(["DUMMY", "A", "B", "C"][i] for i in 2:4))
    @test Tables.columnnames(mattbl) == [:A, :B, :C]
    mattbl = Tables.table(mat, header=1:3)
    @test Tables.columnnames(mattbl) == Symbol.(1:3)
    @test_throws ArgumentError Tables.table(mat, header=[:A, :B, :C, :D])

    X = [1 2; 3 4; 5 6]
    tbl = Tables.table(X)
    tbl[1][1] = 100
    @test X[1, 1] == 100
    tbl[2][3] = 200
    @test X[3, 2] == 200

    # #155
    m = hcat([1,2,3],[1,2,3])
    T = Tables.table(m)
    M = Tables.matrix(T)
    Mt = Tables.matrix(T, transpose=true)
    @test M[:, 1] == [1, 2, 3]
    # 182
    @test M === m #checks that both are the same object in memory
    @test Mt == permutedims(m)
    # 167
    @test !Tables.istable(Matrix{Union{}}(undef, 2, 3))

    # Tables.Columns roundtrip
    X = [1 0 0; 0 1 0; 0 0 1]
    X′ = Tables.matrix(Tables.Columns(Tables.table(X)))
    @test X′ == X
    # test for presence of superfluous wrapping
    @test typeof(X′) == typeof(X)

    # Treating vectors as 1-column tables:
    x = [1,2,3,4,5]
    tbl = Tables.Columns(Tables.table(x))
    @test keys(tbl) == [:Column1]
    @test keys(Tables.Columns(Tables.table(x, header=["col1"]))) == [:col1]
    x′ = Tables.matrix(tbl)
    @test x′ == reshape(x, :, 1) == Tables.matrix(Tables.table(x))

    # For the case that `Tables.getcolumn` doesn't return an `AbstractVector`
    # e.g Tuple, see #263
    @test Tables.matrix(MockTable()) == repeat([1, 2, 3], 1, 3)

    tbl = TestMatrixTable()
    ctbl = columntable(tbl)
    @test ctbl.a == [1, 2, 3]
    @test ctbl.b == [1, 2, 3]
    @test ctbl.c == [1, 2, 3]
    rtbl = rowtable(tbl)
    @test rtbl[1].a == 1
    @test rtbl[1].b == 1
    @test rtbl[1].c == 1
end

import Base: ==
struct GenericRow
    a::Int
    b::Float64
    c::String
end
==(a::GenericRow, b::GenericRow) = a.a == b.a && a.b == b.b && a.c == b.c

struct GenericRowTable
    data::Vector{GenericRow}
end
==(a::GenericRowTable, b::GenericRowTable) = all(a.data .== b.data)

Base.eltype(g::GenericRowTable) = GenericRow
Base.length(g::GenericRowTable) = length(g.data)
Base.size(g::GenericRowTable) = (length(g.data),)
Tables.istable(::Type{GenericRowTable}) = true
Tables.rowaccess(::Type{GenericRowTable}) = true
Tables.rows(x::GenericRowTable) = x
Tables.schema(x::GenericRowTable) = Tables.Schema((:a, :b, :c), Tuple{Int, Float64, String})

function Base.iterate(g::GenericRowTable, st=1)
    st > length(g.data) && return nothing
    return g.data[st], st + 1
end

genericrowtable(x) = GenericRowTable(collect(map(x->GenericRow(x.a, x.b, x.c), Tables.rows(x))))

struct GenericColumn{T} <: AbstractVector{T}
    data::Vector{T}
end
Base.eltype(g::GenericColumn{T}) where {T} = T
Base.size(g::GenericColumn) = (length(g.data),)
==(a::GenericColumn, b::GenericColumn) = a.data == b.data
Base.getindex(g::GenericColumn, i::Int) = g.data[i]

struct GenericColumnTable
    names::Dict{Symbol, Int}
    data::Vector{GenericColumn}
end

Tables.istable(::Type{GenericColumnTable}) = true
Tables.columnaccess(::Type{GenericColumnTable}) = true
Tables.columns(x::GenericColumnTable) = x
Tables.schema(g::GenericColumnTable) = Tables.Schema(Tuple(keys(getfield(g, 1))), Tuple{(eltype(x) for x in getfield(g, 2))...})
Base.getproperty(g::GenericColumnTable, nm::Symbol) = getfield(g, 2)[getfield(g, 1)[nm]]
Base.propertynames(g::GenericColumnTable) = Tuple(keys(getfield(g, 1)))

function genericcolumntable(x)
    cols = Tables.columns(x)
    sch = Tables.schema(x)
    data = [GenericColumn(getproperty(cols, nm)) for nm in sch.names]
    return GenericColumnTable(Dict(nm=>i for (i, nm) in enumerate(sch.names)), data)
end
==(a::GenericColumnTable, b::GenericColumnTable) = getfield(a, 1) == getfield(b, 1) && getfield(a, 2) == getfield(b, 2)

# is both row and column access
struct GenericTable
end
Tables.istable(::Type{GenericTable}) = true
Tables.rowaccess(::Type{GenericTable}) = true
Tables.rows(x::GenericTable) = x
Tables.schema(x::GenericTable) = Tables.Schema((:a, :b, :c), Tuple{Int, Float64, String})
Tables.columnaccess(::Type{GenericTable}) = true
Tables.columns(x::GenericTable) = x
Base.eltype(g::GenericTable) = GenericRow
Base.length(g::GenericTable) = 1
Base.size(g::GenericTable) = (1,)
function Base.iterate(g::GenericTable, st=1)
    st > 1 && return nothing
    return GenericRow(1, 2.0, "3"), 2
end
Base.getproperty(g::GenericTable, nm::Symbol) = GenericColumn([1, 2, 3])
Base.propertynames(g::GenericTable) = (:a, :b, :c)

@testset "Tables.jl interface" begin

    @test !Tables.istable(1)
    @test !Tables.istable(Int)
    @test !Tables.rowaccess(1)
    @test !Tables.rowaccess(Int)
    @test !Tables.columnaccess(1)
    @test !Tables.columnaccess(Int)
    @test Tables.schema(1) === nothing

    sch = Tables.Schema{(:a, :b), Tuple{Int64, Float64}}()
    @test Tables.Schema((:a, :b), Tuple{Int64, Float64}) === sch
    @test Tables.Schema(NamedTuple{(:a, :b), Tuple{Int64, Float64}}) === sch
    @test Tables.Schema((:a, :b), nothing) === Tables.Schema{(:a, :b), nothing}()
    @test Tables.Schema([:a, :b], [Int64, Float64]) === sch
    show(sch)
    @test sch.names == (:a, :b)
    @test sch.types == (Int64, Float64)
    @test_throws ArgumentError sch.foobar

    gr = GenericRowTable([GenericRow(1, 4.0, "7"), GenericRow(2, 5.0, "8"), GenericRow(3, 6.0, "9")])
    gc = GenericColumnTable(Dict(:a=>1, :b=>2, :c=>3), GenericColumn[GenericColumn([1,2,3]), GenericColumn([4.0, 5.0, 6.0]), GenericColumn(["7", "8", "9"])])
    @test gc == (gr |> genericcolumntable)
    @test gr == (gc |> genericrowtable)
    @test gr == (gr |> genericrowtable)

    @test_throws ArgumentError Tables.columns(Int64)
    @test_throws ArgumentError Tables.rows(Int64)

    # 204
    rows = NamedTuple{(:a, :b), Tuple{Int64, Float64}}[]
    t = Tables.columns(rows)
    @test Tables.schema(t) == Tables.Schema((:a, :b), (Int64, Float64))
    rows = GenericRow[]
    t = Tables.columns(rows)
    @test Tables.schema(t) == Tables.Schema((:a, :b, :c), (Int, Float64, String))
    rows = Tuple{Int64, Float64, String}[]
    t = Tables.columns(rows)
    @test Tables.schema(t) == Tables.Schema((:Column1, :Column2, :Column3), (Int64, Float64, String))

    # 311
    gt = GenericTable()
    @test Tables.schema(gt) == Tables.Schema((:a, :b, :c), (Int, Float64, String))
    @test Tables.columns(gt) == gt
    @test Tables.rows(gt) == gt
    @test_throws ArgumentError Tables.rows(GenericTable)
end

@testset "isless" begin
    t = (x = [1, 1, 0, 2], y = [-1, 1, 3, 2])
    a,b,c,d = Tables.rows(t)
    @test isless(a, b)
    @test isless(c, d)
    @test !isless(d, a)
    @test !isequal(a, b)
    @test isequal(a, a)
    @test sortperm([a, b, c, d]) == [3, 1, 2, 4]
end

struct ColumnSource
end

TableTraits.supports_get_columns_copy_using_missing(::ColumnSource) = true

function TableTraits.get_columns_copy_using_missing(x::ColumnSource)
    return (a=[1,2,3], b=[4.,5.,6.], c=["A", "B", "C"])
end

let x=ColumnSource()
    @test Tables.source(Tables.columns(x)) == Tables.source(Tables.CopiedColumns(TableTraits.get_columns_copy_using_missing(x)))
end

struct ColumnSource2
end

IteratorInterfaceExtensions.isiterable(x::ColumnSource2) = true
TableTraits.isiterabletable(::ColumnSource2) = true

IteratorInterfaceExtensions.getiterator(::ColumnSource2) =
    Tables.rows((a=[1,2,3], b=[4.,5.,6.], c=["A", "B", "C"]))

let x=ColumnSource2()
    @test Tables.source(Tables.columns(x)) == (a=[1,2,3], b=[4.,5.,6.], c=["A", "B", "C"])
end

@testset "TableTraits integration" begin
    rt = (a = Real[1, 2.0, 3], b = Union{Missing, Float64}[4.0, missing, 6.0], c = ["7", "8", "9"])

    dv = Tables.datavaluerows(rt)
    @test Base.IteratorSize(typeof(dv)) == Base.HasLength()
    @test eltype(dv) == NamedTuple{(:a, :b, :c),Tuple{Real,DataValue{Float64},String}}
    @test_throws MethodError size(dv)
    rt2 = collect(dv)
    @test rt2[1] == (a = 1, b = DataValue{Float64}(4.0), c = "7")

    ei = Tables.nondatavaluerows(QueryOperators.EnumerableIterable{eltype(dv), typeof(dv)}(dv))
    @test Tables.istable(typeof(ei))
    @test Tables.rowaccess(typeof(ei))
    @test Tables.rows(ei) === ei
    @test Base.IteratorEltype(typeof(ei)) == Base.HasEltype()
    @test Base.IteratorSize(typeof(ei)) == Base.HasLength()
    @test eltype(ei) == Tables.IteratorRow{NamedTuple{(:a, :b, :c),Tuple{Real,DataValue{Float64},String}}}
    @test eltype(typeof(ei)) == Tables.IteratorRow{NamedTuple{(:a, :b, :c),Tuple{Real,DataValue{Float64},String}}}
    @test_throws MethodError size(ei)
    nt = ei |> columntable
    @test isequal(rt, nt)
    rt3 = ei |> rowtable
    @test isequal(rt |> rowtable, rt3)

    # rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
    mt = Tables.nondatavaluerows(ei.x |> y->QueryOperators.map(y, x->(a=x.b, c=x.c), Expr(:block)))
    @inferred (mt |> columntable)
    @inferred (mt |> rowtable)

    # uninferrable case
    mt = Tables.nondatavaluerows(ei.x |> y->QueryOperators.map(y, x->(a=x.a, c=x.c), Expr(:block)))
    @test (mt |> columntable) == (a = Real[1, 2.0, 3], c = ["7", "8", "9"])
    @test length(mt |> rowtable) == 3

    rt = (a = Missing[missing, missing], b=[1,2])
    dv = Tables.datavaluerows(rt)
    @test eltype(dv) == NamedTuple{(:a, :b), Tuple{DataValue{Union{}}, Int}}

    # DataValue{Any}
    @test isequal(Tables.columntable(Tables.nondatavaluerows([(a=DataValue{Any}(), b=DataValue{Int}())])), (a = Any[missing], b = Union{Missing, Int64}[missing]))
end

@testset "AbstractDict" begin

    d = Dict(:a => 1, :b => missing, :c => "7")
    n = (a=1, b=missing, c="7")
    drt = [d, d, d]
    rt = [n, n, n]
    dct = Dict(:a => [1, 1, 1], :b => [missing, missing, missing], :c => ["7", "7", "7"])
    ct = (a = [1, 1, 1], b = [missing, missing, missing], c = ["7", "7", "7"])
    @test Tables.istable(drt)
    @test Tables.rowaccess(drt)
    @test Tables.rows(drt) === drt
    @test Tables.schema(drt) === nothing
    @test isequal(Tables.rowtable(drt), rt)
    @test isequal(Tables.columntable(drt), ct)

    @test Tables.istable(dct)
    @test Tables.columnaccess(dct)
    @test Tables.columns(dct) === dct
    @test Tables.schema(dct) == Tables.Schema((:a, :b, :c), Tuple{Int, Missing, String})
    @test isequal(Tables.rowtable(dct), rt)
    @test isequal(Tables.columntable(dct), ct)

    # a Dict w/ scalar values isn't a table
    @test_throws Exception Tables.columns(d)

    # Dicts with String keys
    d = OrderedDict("a" => 1, "b" => missing, "c" => "7")
    n = (a=1, b=missing, c="7")
    drt = [d, d, d]
    rt = [n, n, n]
    dct = OrderedDict("a" => [1, 1, 1], "b" => [missing, missing, missing], "c" => ["7", "7", "7"])
    ct = (a = [1, 1, 1], b = [missing, missing, missing], c = ["7", "7", "7"])
    @test Tables.istable(drt)
    @test Tables.rowaccess(drt)
    @test Tables.rows(drt) === drt
    @test Tables.schema(drt) === nothing
    @test isequal(Tables.rowtable(drt), rt)
    @test isequal(Tables.columntable(drt), ct)

    @test Tables.istable(dct)
    @test Tables.columnaccess(dct)
    @test Tables.columns(dct) === dct
    @test Tables.schema(dct) == Tables.Schema((:a, :b, :c), Tuple{Int, Missing, String})
    @test isequal(Tables.rowtable(dct), rt)
    @test isequal(Tables.columntable(dct), ct)
end

struct Row <: Tables.AbstractRow
    a::Int
    b::Union{Float64, Missing}
    c::String
end

Tables.getcolumn(r::Row, i::Int) = getfield(r, i)
Tables.getcolumn(r::Row, nm::Symbol) = getfield(r, nm)
Tables.getcolumn(r::Row, ::Type{T}, i::Int, nm::Symbol) where {T} = getfield(r, i)
Tables.columnnames(r::Row) = fieldnames(Row)

struct DummyRow <: Tables.AbstractRow end

@testset "AbstractRow" begin

    row = Row(1, missing, "hey")
    row2 = Row(2, 3.14, "ho")

    @test Base.IteratorSize(typeof(row)) == Base.HasLength()
    @test length(row) == 3
    @test firstindex(row) == 1
    @test lastindex(row) == 3
    @test isequal((row[1], row[2], row[3]), (1, missing, "hey"))
    @test isequal((row[:a], row[:b], row[:c]), (1, missing, "hey"))
    @test isequal((row.a, row.b, row.c), (1, missing, "hey"))
    @test isequal((getproperty(row, 1), getproperty(row, 2), getproperty(row, 3)), (1, missing, "hey"))
    @test propertynames(row) == (:a, :b, :c)
    @test keys(row) == (:a, :b, :c)
    @test isequal(values(row), [1, missing, "hey"])
    @test haskey(row, :a)
    @test haskey(row, 1)
    @test get(row, 1, 0) == get(row, :a, 0) == 1
    @test get(() -> 0, row, 1) == get(() -> 0, row, :a) == 1
    @test isequal(collect(row), [1, missing, "hey"])
    @test !isempty(row)
    @test isequal(NamedTuple(row), (a=1, b=missing, c="hey"))
    show(row)

    art = [row, row2]
    ct = (a=[1, 2], b=[missing, 3.14], c=["hey", "ho"])
    @test Tables.istable(art)
    @test Tables.rowaccess(art)
    @test Tables.rows(art) === art
    @test Tables.schema(art) === nothing
    @test isequal(Tables.columntable(art), ct)

    r = DummyRow()
    @test_throws ErrorException("`Tables.getcolumn` must be specifically overloaded for DummyRow <: Union{AbstractRow, AbstractColumns}`") Tables.getcolumn(r, 1)
    @test_throws ErrorException("`Tables.getcolumn` must be specifically overloaded for DummyRow <: Union{AbstractRow, AbstractColumns}`") Tables.getcolumn(r, :a)
    @test_throws ErrorException("`Tables.columnnames` must be specifically overloaded for DummyRow <: Union{AbstractRow, AbstractColumns}`") Tables.columnnames(r)
end

struct TestColumns <: Tables.AbstractColumns
    a::Vector{Int}
    b::Vector{Union{Float64, Missing}}
    c::Vector{String}
end

Tables.getcolumn(r::TestColumns, i::Int) = getfield(r, i)
Tables.getcolumn(r::TestColumns, nm::Symbol) = getfield(r, nm)
Tables.getcolumn(r::TestColumns, ::Type{T}, i::Int, nm::Symbol) where {T} = getfield(r, i)
Tables.columnnames(r::TestColumns) = fieldnames(TestColumns)

struct DummyCols <: Tables.AbstractColumns end

@testset "AbstractColumns" begin

    col = TestColumns([1, 2], [missing, 3.14], ["hey", "ho"])

    @test Base.IteratorSize(typeof(col)) == Base.HasLength()
    @test length(col) == 3
    @test firstindex(col) == 1
    @test lastindex(col) == 3
    @test isequal((col[1], col[2], col[3]), ([1,2], [missing,3.14], ["hey","ho"]))
    @test isequal((col[:a], col[:b], col[:c]), ([1,2], [missing,3.14], ["hey","ho"]))
    @test isequal((col.a, col.b, col.c), ([1,2], [missing,3.14], ["hey","ho"]))
    @test isequal((getproperty(col, 1), getproperty(col, 2), getproperty(col, 3)), ([1,2], [missing,3.14], ["hey","ho"]))
    @test propertynames(col) == (:a, :b, :c)
    @test keys(col) == (:a, :b, :c)
    @test isequal(values(col), [[1,2], [missing,3.14], ["hey","ho"]])
    @test haskey(col, :a)
    @test haskey(col, 1)
    @test get(col, 1, 0) == get(col, :a, 0) == [1,2]
    @test get(() -> 0, col, 1) == get(() -> 0, col, :a) == [1,2]
    @test isequal(collect(col), [[1,2], [missing,3.14], ["hey","ho"]])
    show(col)

    tbl = TestColumns(rand(Int, 100), rand(100), [ "a" for _ = 1:100])
    @test length(sprint(show, tbl)) < 500

    ct = (a=[1, 2], b=[missing, 3.14], c=["hey", "ho"])
    @test Tables.istable(col)
    @test Tables.columnaccess(col)
    @test Tables.columns(col) === col
    @test Tables.schema(col) === nothing
    @test isequal(Tables.columntable(col), ct)

    c = DummyCols()
    @test_throws ErrorException("`Tables.getcolumn` must be specifically overloaded for DummyCols <: Union{AbstractRow, AbstractColumns}`") Tables.getcolumn(c, 1)
    @test_throws ErrorException("`Tables.getcolumn` must be specifically overloaded for DummyCols <: Union{AbstractRow, AbstractColumns}`") Tables.getcolumn(c, :a)
    @test_throws ErrorException("`Tables.columnnames` must be specifically overloaded for DummyCols <: Union{AbstractRow, AbstractColumns}`") Tables.columnnames(c)
end

@testset "Tables.Columns" begin
    X = (A=[1,2], B=[im, -im], C=["kirk", "spock"])

    Xc = Tables.Columns(X)
    @test Tables.schema(X) == Tables.schema(Xc)
    for i ∈ 1:3
        @test Tables.getcolumn(X, i) == Tables.getcolumn(Xc, i)
    end
    for i ∈ (:A, :B, :C)
        @test Tables.getcolumn(X, i) == Tables.getcolumn(Xc, i)
    end
    @test Tables.columnnames(X) == Tables.columnnames(Xc)

    tbl = Tables.Columns((; a=rand(Int, 100), b=rand(100), c=[ "a" for _ = 1:100]))
    @test length(sprint(show, tbl)) < 500
end

struct IsRowTable
    rows::Vector{NamedTuple}
end

Base.iterate(x::IsRowTable) = iterate(x.rows)
Base.iterate(x::IsRowTable, st) = iterate(x.rows, st)
Base.length(x::IsRowTable) = length(x.rows)

Tables.isrowtable(::Type{IsRowTable}) = true

@testset "Tables.isrowtable" begin

    nt = (a=1, b=3.14, c="hey")
    rt = IsRowTable([nt, nt, nt])
    @test Tables.istable(rt)
    @test Tables.rowaccess(rt)
    @test Tables.rows(rt) === rt
    @test Tables.columntable(rt) == Tables.columntable([nt, nt, nt])

end

@testset "Tables.partitions" begin

    ct = (a=[1, 2], b=[missing, 3.14], c=["hey", "ho"])

    for tbl in Tables.partitions(ct)
        @test tbl === ct
    end

    parts = [ct, ct]
    for tbl in Tables.partitions(Tables.partitioner(parts))
        @test tbl === ct
    end

    for tbl in Tables.partitions(Tables.partitioner(x -> x, parts))
        @test Tables.columns(tbl) === ct
    end

end

@testset "Dict tables" begin

    rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
    ct = (a=[1, 2, 3], b=[4.0, 5.0, 6.0], c=["7", "8", "9"])

    dct = Tables.dictcolumntable(rt)
    @test Tables.istable(dct)
    @test Tables.columnaccess(dct)
    @test Tables.columns(dct) === dct
    @test Tables.schema(dct) == Tables.Schema((:a, :b, :c), (Int, Float64, String))
    @test dct.a == [1, 2, 3]
    @test dct.b == [4.0, 5.0, 6.0]
    @test dct.c == ["7", "8", "9"]
    # Tables.subset
    drow = Tables.subset(dct, 1)
    @test drow.a == 1 && drow.b == 4.0 && drow.c == "7"
    drows = Tables.subset(dct, [1, 2])
    @test drows.a == [1, 2] && drows.b == [4.0, 5.0] && drows.c == ["7", "8"]
    @test Tables.rowcount(drows) == 2

    dct = Tables.dictcolumntable(ct)
    @test dct.a == [1, 2, 3]
    @test dct.b == [4.0, 5.0, 6.0]
    @test dct.c == ["7", "8", "9"]
    cct = Tables.columntable(dct)
    @test cct.a == [1, 2, 3]
    @test cct.b == [4.0, 5.0, 6.0]
    @test cct.c == ["7", "8", "9"]

    drt = Tables.dictrowtable(rt)
    @test Tables.isrowtable(drt)
    @test Tables.schema(drt) == Tables.Schema((:a, :b, :c), (Int, Float64, String))
    row = first(drt)
    @test (row.a, row.b, row.c) == (1, 4.0, "7")
    cct = Tables.columntable(drt)
    @test cct.a == [1, 2, 3]
    @test cct.b == [4.0, 5.0, 6.0]
    @test cct.c == ["7", "8", "9"]

    rt = [
        (a=1, b=2, c=3),
        (b=4.0, c=missing, d=5),
        (a=6, d=7),
        (a=8, b=9, c=10, d=missing),
        (d=11, c=10, b=9, a=8)
    ]

    drt = Tables.dictrowtable(rt)
    @test Tables.schema(drt) == Tables.Schema((:a, :b, :c, :d), (Union{Missing, Int}, Union{Missing, Float64, Int}, Union{Missing, Int}, Union{Missing, Int}))
    @test length(drt) == 5
    ct = Tables.columntable(drt)
    @test isequal(ct.a, [1, missing, 6, 8, 8])
    @test isequal(ct.b, Union{Int, Float64, Missing}[2, 4.0, missing, 9, 9])
    @test isequal(ct.c, [3, missing, missing, 10, 10])
    @test isequal(ct.d, [missing, 5, 7, missing, 11])

    dct = Tables.dictcolumntable(rt)
    @test isequal(dct.a, [1, missing, 6, 8, 8])
    @test isequal(ct.b, Union{Int, Float64, Missing}[2, 4.0, missing, 9, 9])
    @test isequal(ct.c, [3, missing, missing, 10, 10])
    @test isequal(dct.d, [missing, 5, 7, missing, 11])

    # https://github.com/JuliaData/Tables.jl/issues/286
    dta = Tables.dictcolumntable([(; a="hey"), (; b=2)]).a
    @test isequal(dta, ["hey", missing])
    # Tables.subset
    drow = Tables.subset(drt, 1)
    @test drow.a == 1 && drow.b == 2 && drow.c == 3
    drows = Tables.subset(drt, [1, 2])
    @test length(drows) == 2
    drowsv = Tables.subset(drt, [1, 2]; viewhint=true)
    @test length(drowsv) == 2
end

# extremely wide tables
struct WideTable <: Tables.AbstractColumns
end

Tables.istable(::Type{WideTable}) = true
Tables.columnaccess(::Type{WideTable}) = true
Tables.columns(x::WideTable) = x
Tables.schema(::WideTable) = Tables.Schema([Symbol("x", i) for i = 1:(Tables.SCHEMA_SPECIALIZATION_THRESHOLD + 1)], [Float64 for _ = 1:(Tables.SCHEMA_SPECIALIZATION_THRESHOLD + 1)])
Tables.getcolumn(g::WideTable, nm::Symbol) = rand(100)
Tables.getcolumn(g::WideTable, i::Int) = rand(100)
Base.getindex(::WideTable, i::Int) = rand(100)
Tables.columnnames(::WideTable) = [Symbol("x", i) for i = 1:(Tables.SCHEMA_SPECIALIZATION_THRESHOLD + 1)]

struct WideTable2 <: Tables.AbstractColumns
end

Tables.istable(::Type{WideTable2}) = true
Tables.columnaccess(::Type{WideTable2}) = true
Tables.columns(x::WideTable2) = x
Tables.schema(::WideTable2) = Tables.Schema([Symbol("x", i) for i = 1:1000], [Float64 for _ = 1:1000]; stored=true)
Tables.getcolumn(g::WideTable2, nm::Symbol) = rand(100)
Base.getindex(::WideTable2, i::Int) = rand(100)
Tables.columnnames(::WideTable2) = [Symbol("x", i) for i = 1:1000]

@testset "wide tables" begin
    x = WideTable();
    sch = Tables.schema(x)
    @test sch.names == [Symbol("x", i) for i = 1:(Tables.SCHEMA_SPECIALIZATION_THRESHOLD + 1)]
    @test sch.types == [Float64 for _ = 1:(Tables.SCHEMA_SPECIALIZATION_THRESHOLD + 1)]
    @test typeof(sch) == Tables.Schema{nothing, nothing}
    r = Tables.rows(x)
    Tables.eachcolumn(sch, first(r)) do y, i, nm
        @test y isa Float64
        @test i isa Integer
        @test nm isa Symbol
    end
    Tables.eachcolumns(sch, first(r), x) do y, i, nm, col
        @test y isa Float64
        @test i isa Integer
        @test nm isa Symbol
        @test col isa Vector{Float64}
    end
    @test_throws ArgumentError Tables.columntable(x)
    @test_throws ArgumentError Tables.rowtable(x)
    y = Tables.dictrowtable(x);
    @test length(y) == 100
    y = Tables.dictcolumntable(x);
    @test Tables.schema(y) == Tables.schema(x)
    # y = Tables.matrix(x); # works, just takes a really long time and a lot of memory

    x = WideTable2();
    sch = Tables.schema(x)
    @test sch.names == [Symbol("x", i) for i = 1:1000]
    @test sch.types == [Float64 for _ = 1:1000]
    @test typeof(sch) == Tables.Schema{nothing, nothing}
    r = Tables.rows(x)
    Tables.eachcolumn(sch, first(r)) do y, i, nm
        @test y isa Float64
        @test i isa Integer
        @test nm isa Symbol
    end
    Tables.eachcolumns(sch, first(r), x) do y, i, nm, col
        @test y isa Float64
        @test i isa Integer
        @test nm isa Symbol
        @test col isa Vector{Float64}
    end

end

@testset "ByRow" begin
    @test Tables.ByRow(x -> x^2)(1:3) == [1, 4, 9]
    @test Tables.ByRow((x, y) -> x*y)(1:3, 2:4) == [2, 6, 12]
    @test Tables.ByRow((x, y, z) -> x*y*z)(1:3, 2:4, 3:5) == [6, 24, 60]
    let i = 0
        @test Tables.ByRow(x -> (i += 1; return i))(spzeros(5)) == 1:5
    end
    # check that map is not what we want
    let i = 0
        @test map(x -> (i += 1; return i), spzeros(5)) == [1, 1, 1, 1, 1]
    end
    # equal length test
    @test_throws ArgumentError Tables.ByRow((x, y) -> x*y)(1:3, 2:5)

    # ColumnTable case
    @test Tables.ByRow(x -> x.a)((a=1:2, b=3:4)) == [1, 2]
    # equal length test
    @test_throws ArgumentError Tables.ByRow(x -> x.a)((a=1:2, b=3:5))
    @test_throws ArgumentError Tables.ByRow(x -> x.a)((a=1:10, b=3:5))

    # Table being a vector of structs is treated just as a vector
    @test Tables.ByRow(identity)([1=>2, 3=>4]) == [1=>2, 3=>4]
    @test Tables.ByRow(Dict)([1=>2, 3=>4]) == [Dict(1=>2), Dict(3=>4)]

    # empty arguments tests
    @test_throws ArgumentError Tables.ByRow(() -> 1)()
    @test_throws ArgumentError Tables.ByRow(() -> 1)(NamedTuple())

    # wrong argument tests
    @test_throws MethodError Tables.ByRow(identity)(1)
    @test_throws MethodError Tables.ByRow(identity)([1 2])
end

@testset "istable on dictionaries" begin
    @test Tables.istable(Dict{Union{String}, Vector})
    @test Tables.istable(Dict{Union{Symbol}, Vector})
    @test Tables.istable(Dict{Union{SubString}, Vector})
    @test Tables.istable(Dict{Union{AbstractString}, Vector})
    @test !Tables.istable(Dict{Union{String, Symbol}, Vector})
    @test Tables.istable(Vector{Dict{Symbol}})
    @test Tables.istable(Vector{Dict{String}})
    @test Tables.istable(Vector{Dict{SubString}})
    @test Tables.istable(Vector{Dict{AbstractString}})

    @test Set(Tables.columnnames(Dict(:a=>1, :b=>2))) == Set([:a, :b])
    @test Set(Tables.columnnames(Dict("a"=>1, "b"=>2))) == Set([:a, :b])
    @test Set(Tables.columnnames(Dict("a"=>1, SubString("b")=>2))) == Set([:a, :b])
    @test Set(Tables.columnnames(Dict(SubString("a")=>1, SubString("b")=>2))) == Set([:a, :b])

    @test Tables.getcolumn(Dict(:a=>1, :b=>2), :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, "b"=>2), :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, SubString("b")=>2), :a) == 1
    @test Tables.getcolumn(Dict(SubString("a")=>1, SubString("b")=>2), :a) == 1
    @test Tables.getcolumn(Dict(:a=>1, :b=>2), :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, "b"=>2), :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, SubString("b")=>2), :a) == 1
    @test Tables.getcolumn(Dict(SubString("a")=>1, SubString("b")=>2), :a) == 1
    @test Tables.getcolumn(Dict(:a=>1, :b=>2), Int, 1, :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, "b"=>2), Int, 1, :a) == 1
    @test Tables.getcolumn(Dict("a"=>1, SubString("b")=>2), Int, 1, :a) == 1
    @test Tables.getcolumn(Dict(SubString("a")=>1, SubString("b")=>2), Int, 1, :a) == 1
end

@testset "test nrow and ncol" begin
    # AbstractColumns
    @test DataAPI.nrow(Tables.CopiedColumns(NamedTuple())) == 0
    @test DataAPI.ncol(Tables.CopiedColumns(NamedTuple())) == 0
    @test DataAPI.nrow(Tables.CopiedColumns((a=1:3, b=2:4))) == 3
    @test DataAPI.ncol(Tables.CopiedColumns((a=1:3, b=2:4))) == 2

    # ColumnTable
    @test DataAPI.nrow(NamedTuple()) == 0
    @test DataAPI.ncol(NamedTuple()) == 0
    @test DataAPI.nrow((a=1:3, b=2:4)) == 3
    @test DataAPI.ncol((a=1:3, b=2:4)) == 2

    # AbstractRowTable
    @test DataAPI.nrow(collect(Tables.rows(Tables.table(ones(0, 0))))) == 0
    @test DataAPI.ncol(collect(Tables.rows(Tables.table(ones(0, 0))))) == 0
    @test DataAPI.nrow(collect(Tables.rows(Tables.table(ones(2, 3))))) == 2
    @test DataAPI.ncol(collect(Tables.rows(Tables.table(ones(2, 3))))) == 3

    # RowTable
    @test DataAPI.nrow(NamedTuple[]) == 0
    @test DataAPI.ncol(NamedTuple[]) == 0
    @test DataAPI.nrow([(a=1,b=2), (a=3, b=4), (a=5, b=6)]) == 3
    @test DataAPI.ncol([(a=1, b=2), (a=3, b=4), (a=5, b=6)]) == 2

    # MatrixTable
    @test DataAPI.nrow(Tables.table(ones(0, 0))) == 0
    @test DataAPI.ncol(Tables.table(ones(0, 0))) == 0
    @test DataAPI.nrow(Tables.table(ones(2, 3))) == 2
    @test DataAPI.ncol(Tables.table(ones(2, 3))) == 3
    @test DataAPI.nrow(Tables.table([])) == 0
    @test DataAPI.ncol(Tables.table([])) == 1
    @test DataAPI.nrow(Tables.table([1, 2])) == 2
    @test DataAPI.ncol(Tables.table([1, 2])) == 1

    # MatrixRowTable
    @test DataAPI.nrow(Tables.rows(Tables.table(ones(0, 0)))) == 0
    @test DataAPI.ncol(Tables.rows(Tables.table(ones(0, 0)))) == 0
    @test DataAPI.nrow(Tables.rows(Tables.table(ones(2, 3)))) == 2
    @test DataAPI.ncol(Tables.rows(Tables.table(ones(2, 3)))) == 3
    @test DataAPI.nrow(Tables.rows(Tables.table([]))) == 0
    @test DataAPI.ncol(Tables.rows(Tables.table([]))) == 1
    @test DataAPI.nrow(Tables.rows(Tables.table([1, 2]))) == 2
    @test DataAPI.ncol(Tables.rows(Tables.table([1, 2]))) == 1

    # DictRowTable
    @test DataAPI.nrow(Tables.dictrowtable(NamedTuple[])) == 0
    @test DataAPI.ncol(Tables.dictrowtable(NamedTuple[])) == 0
    @test DataAPI.nrow(Tables.dictrowtable([(a=1, b=2), (a=3, b=4), (a=5, b=6)])) == 3
    @test DataAPI.ncol(Tables.dictrowtable([(a=1, b=2), (a=3, b=4), (a=5, b=6)])) == 2
end

@testset "#357" begin
    dct = Tables.dictcolumntable((a=1:3, b=4.0:6.0, c=["7", "8", "9"]))
    sch = Tables.schema(dct)
    sch = Tables.Schema(sch.names, sch.types, stored=true)
    dct = Tables.DictColumnTable(sch, getfield(dct, :values))
    nt = Tables.columntable(dct)
    @test nt.a == [1, 2, 3]
    @test nt.b == [4.0, 5.0, 6.0]
    @test nt.c == ["7", "8", "9"]
end

struct MockRow <: Tables.AbstractRow
    a
    b
    c
end

Tables.getcolumn(row::MockRow, name::Symbol) = getfield(row, name)
Tables.columnnames(::MockRow) = fieldnames(MockRow)

@testset "Issue #361" begin
    tbl = [MockRow(1, 2, 3), MockRow(4, 5, 6)]

    expected = """
        MockRow[
        MockRow:
         :a  1
         :b  2
         :c  3,
        MockRow:
         :a  4
         :b  5
         :c  6]"""
    expected = replace(expected, "," => ", ")  # Add trailing spaces
    @test sprint(show, tbl, context=:compact => false) == expected

    expected_compact = "MockRow[(a = 1, b = 2, c = 3), (a = 4, b = 5, c = 6)]"
    @test sprint(show, tbl, context=:compact => true) == expected_compact
end
include("scan.jl")

# Dict of Vectors as table
struct DictColumnTable <: AbstractColumns
    schema::Schema
    values::OrderedDict{Symbol, AbstractVector}
end

"""
    Tables.dictcolumntable(x) => Tables.DictColumnTable

Take any Tables.jl-compatible source `x` and return a `DictColumnTable`, which
can be thought of as a `OrderedDict` mapping column names as `Symbol`s to `AbstractVector`s.
The order of the input table columns is preserved via the `Tables.schema(::DictColumnTable)`.

For "schema-less" input tables, `dictcolumntable` employs a "column unioning" behavior,
as opposed to inferring the schema from the first row like `Tables.columns`. This
means that as rows are iterated, each value from the row is joined into an aggregate
final set of columns. This is especially useful when input table rows may not include
columns if the value is missing, instead of including an actual value `missing`, which
is common in json, for example. This results in a performance cost tracking all seen
values and inferring the final unioned schemas, so it's recommended to use only when
needed.
"""
function dictcolumntable(x)
    if columnaccess(x)
        cols = columns(x)
        names = columnnames(cols)
        sch = schema(cols)
        out = OrderedDict(nm => getcolumn(cols, nm) for nm in names)
    else
        r = rows(x)
        L = Base.IteratorSize(typeof(r))
        len = Base.haslength(r) ? length(r) : 0
        sch = schema(r)
        if sch !== nothing
            names, types = sch.names, sch.types
            out = OrderedDict{Int, AbstractVector}(i => allocatecolumn(types[i], len) for i = 1:length(types))
            for (i, row) in enumerate(r)
                eachcolumns(add!, sch, row, out, L, i)
            end
            out = OrderedDict(names[k] => v for (k, v) in out)
        else
            names = Symbol[]
            seen = Set{Symbol}()
            out = OrderedDict{Symbol, AbstractVector}()
            for (i, row) in enumerate(r)
                for nm in columnnames(row)
                    push!(seen, nm)
                    val = getcolumn(row, nm)
                    if haskey(out, nm)
                        col = out[nm]
                        if typeof(val) <: eltype(col)
                            add!(val, 0, nm, col, L, i)
                        else # widen column type
                            new = allocatecolumn(promote_type(eltype(col), typeof(val)), length(col))
                            i > 1 && copyto!(new, 1, col, 1, i - 1)
                            add!(new, val, L, i)
                            out[nm] = new
                        end
                    else
                        push!(names, nm)
                        if i == 1
                            new = allocatecolumn(typeof(val), len)
                            add!(new, val, L, i)
                            out[nm] = new
                        else
                            new = allocatecolumn(Union{Missing, typeof(val)}, len)
                            add!(new, val, L, i)
                            out[nm] = new
                        end
                    end
                end
                for nm in names
                    if !(nm in seen)
                        col = out[nm]
                        if !(eltype(col) >: Missing)
                            new = allocatecolumn(Union{Missing, eltype(col)}, len)
                            i > 1 && copyto!(new, 1, col, 1, i - 1)
                            out[nm] = new
                        end
                    end
                end
                empty!(seen)
            end
            sch = Schema(collect(keys(out)), eltype.(values(out)))
        end
    end
    return DictColumnTable(sch, out)
end

istable(::Type{DictColumnTable}) = true
columnaccess(::Type{DictColumnTable}) = true
columns(x::DictColumnTable) = x
schema(x::DictColumnTable) = getfield(x, :schema)
columnnames(x::DictColumnTable) = getfield(x, :schema).names
getcolumn(x::DictColumnTable, i::Int) = getfield(x, :values)[columnnames(x)[i]]
getcolumn(x::DictColumnTable, nm::Symbol) = getfield(x, :values)[nm]

# Vector of Dicts as table
struct DictRowTable
    names::Vector{Symbol}
    types::Dict{Symbol, Type}
    values::Vector{Dict{Symbol, Any}}
end

isrowtable(::Type{DictRowTable}) = true
schema(x::DictRowTable) = Schema(getfield(x, :names), [getfield(x, :types)[nm] for nm in getfield(x, :names)])

struct DictRow <: AbstractRow
    names::Vector{Symbol}
    row::Dict{Symbol, Any}
end

columnnames(x::DictRow) = getfield(x, :names)
getcolumn(x::DictRow, i::Int) = get(getfield(x, :row), columnnames(x)[i], missing)
getcolumn(x::DictRow, nm::Symbol) = get(getfield(x, :row), nm, missing)

Base.IteratorSize(::Type{DictRowTable}) = Base.HasLength()
Base.length(x::DictRowTable) = length(getfield(x, :values))
Base.IteratorEltype(::Type{DictRowTable}) = Base.HasEltype()
Base.eltype(::Type{DictRowTable}) = DictRow

function Base.iterate(x::DictRowTable, st=1)
    st > length(x) && return nothing
    return DictRow(x.names, x.values[st]), st + 1
end

function subset(x::DictRowTable, inds; viewhint::Union{Bool,Nothing}=nothing, view::Union{Bool,Nothing}=nothing)
    if view !== nothing
        @warn "`view` keyword argument is deprecated for `Tables.subset`, use `viewhint` instead" maxlog=10
        viewhint = view
    end
    values = viewhint === true ? Base.view(getfield(x, :values), inds) : getfield(x, :values)[inds]
    if inds isa Integer
        return DictRow(getfield(x, :names), values)
    else
        values isa AbstractVector || throw(ArgumentError("`Tables.subset`: invalid `inds` argument, expected `RowTable` output, got $(typeof(values))"))
        return DictRowTable(getfield(x, :names), getfield(x, :types), values)
    end
end

"""
    Tables.dictrowtable(x) => Tables.DictRowTable

Take any Tables.jl-compatible source `x` and return a `DictRowTable`, which
can be thought of as a `Vector` of `OrderedDict` rows mapping column names as `Symbol`s to values.
The order of the input table columns is preserved via the `Tables.schema(::DictRowTable)`.

For "schema-less" input tables, `dictrowtable` employs a "column unioning" behavior,
as opposed to inferring the schema from the first row like `Tables.columns`. This
means that as rows are iterated, each value from the row is joined into an aggregate
final set of columns. This is especially useful when input table rows may not include
columns if the value is missing, instead of including an actual value `missing`, which
is common in json, for example. This results in a performance cost tracking all seen
values and inferring the final unioned schemas, so it's recommended to use only when
the union behavior is needed.
"""
function dictrowtable(x)
    names = Symbol[]
    seen = Set{Symbol}()
    types = OrderedDict{Symbol, Type}()
    r = rows(x)
    L = Base.IteratorSize(typeof(r))
    out = Vector{OrderedDict{Symbol, Any}}(undef, Base.haslength(r) ? length(r) : 0)
    for (i, drow) in enumerate(r)
        row = OrderedDict{Symbol, Any}(nm => getcolumn(drow, nm) for nm in columnnames(drow))
        add!(row, 0, :_, out, L, i)
        if isempty(names)
            for (k, v) in row
                push!(names, k)
                types[k] = typeof(v)
            end
            seen = Set(names)
        else
            for nm in names
                if haskey(row, nm)
                    T = types[nm]
                    v = row[nm]
                    if !(typeof(v) <: T)
                        types[nm] = Union{T, typeof(v)}
                    end
                else
                    types[nm] = Union{Missing, types[nm]}
                end
            end
            for (k, v) in row
                if !(k in seen)
                    push!(seen, k)
                    push!(names, k)
                    # we mark the type as Union{T, Missing} here because
                    # we're at least on the 2nd row, and we didn't see
                    # this column in the 1st row, so its value will be
                    # `missing` for that row
                    types[k] = Union{typeof(v), Missing}
                end
            end
        end
    end
    return DictRowTable(names, types, out)
end

# implement default nrow and ncol methods for DataAPI.jl

DataAPI.nrow(table::DictRowTable) = length(table)
DataAPI.ncol(table::DictRowTable) = length(getfield(table, :names))

using Tables
using Documenter
using Documenter.Remotes: GitHub

DocMeta.setdocmeta!(Tables, :DocTestSetup, :(using Tables); recursive=true)

makedocs(;
    modules=[Tables],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
        "Using the Interface" => "using-the-interface.md",
        "Implementing the Interface" => "implementing-the-interface.md",
        "API Reference" => "api.md",
    ],
    repo=GitHub("JuliaData/Tables.jl"),
    sitename="Tables.jl",
    authors="Jacob Quinn",
    checkdocs=:none,
)

deploydocs(;
    repo="github.com/JuliaData/Tables.jl",
    devbranch = "main"
)

istable(::Type{<:AbstractMatrix}) = false

# for AbstractMatrix types, we don't want to automatically treat them as tables
# *unless* someone has defined their own w/ appropriate Tables definitions
rows(m::T) where {T <: AbstractMatrix} = istable(m) ? _rows(m) : throw(ArgumentError("a '$T' is not a table; see `?Tables.table` for ways to treat an AbstractVecOrMat as a table"))
columns(m::T) where {T <: AbstractMatrix} = istable(m) ? _columns(m) : throw(ArgumentError("a '$T' is not a table; see `?Tables.table` for ways to treat an AbstractVecOrMat as a table"))

struct MatrixTable{T <: AbstractVecOrMat} <: AbstractColumns
    names::Vector{Symbol}
    lookup::Dict{Symbol, Int}
    matrix::T
end

struct MatrixRowTable{T <: AbstractVecOrMat}
    names::Vector{Symbol}
    lookup::Dict{Symbol, Int}
    matrix::T
end

const MatrixTables{T} = Union{MatrixTable{T}, MatrixRowTable{T}}

names(m::MatrixTables) = getfield(m, :names)

# row interface
istable(::Type{<:MatrixTable}) = true
rowaccess(::Type{<:MatrixTable}) = true
rows(x::MatrixTable) = MatrixRowTable(getfield(x, :names), getfield(x, :lookup), getfield(x, :matrix))

struct MatrixRow{T} <: AbstractRow
    row::Int
    source::MatrixRowTable{T}
end

getcolumn(m::MatrixRow, ::Type, col::Int, nm::Symbol) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), col]
getcolumn(m::MatrixRow, i::Int) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), i]
getcolumn(m::MatrixRow, nm::Symbol) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), getfield(getfield(m, :source), :lookup)[nm]]
columnnames(m::MatrixRow) = names(getfield(m, :source))

schema(m::MatrixTables{T}) where {T} = Schema(Tuple(names(m)), NTuple{size(getfield(m, :matrix), 2), eltype(T)})
Base.eltype(::Type{M}) where {T,M<:MatrixRowTable{T}} = MatrixRow{T}
Base.length(m::MatrixRowTable) = size(getfield(m, :matrix), 1)

Base.iterate(m::MatrixRowTable, st=1) = st > length(m) ? nothing : (MatrixRow(st, m), st + 1)

# column interface
columnaccess(::Type{<:MatrixTable}) = true
columns(m::MatrixTable) = m
getcolumn(m::MatrixTable, i::Int) = view(getfield(m, :matrix), :, i)
getcolumn(m::MatrixTable, ::Type, col::Int, nm::Symbol) = getcolumn(m, col)
getcolumn(m::MatrixTable, nm::Symbol) = getcolumn(m, getfield(m, :lookup)[nm])
columnnames(m::MatrixTable) = names(m)

"""
    Tables.table(m::AbstractVecOrMat; [header])

Wrap an `AbstractVecOrMat` (`Matrix`, `Vector`, `Adjoint`, etc.) in a `MatrixTable`, which satisfies the
Tables.jl interface.  (An `AbstractVector` is treated as a 1-column matrix.) This allows accessing the matrix via `Tables.rows` and `Tables.columns`.
An optional keyword argument iterator `header` can be passed which will be converted to a
`Vector{Symbol}` to be used as the column names. Note that no copy of the `AbstractVecOrMat`
is made.
"""
function table(m::AbstractVecOrMat; header=[Symbol("Column$i") for i = 1:size(m, 2)])
    symbol_header = header isa Vector{Symbol} ? header : [Symbol(h) for h in header]
    if length(symbol_header) != size(m, 2)
        throw(ArgumentError("provided column names `header` length must match number of columns in matrix ($(size(m, 2)))"))
    end
    lookup = Dict(nm=>i for (i, nm) in enumerate(symbol_header))
    return MatrixTable(symbol_header, lookup, m)
end

"""
    Tables.matrix(table; transpose::Bool=false)

Materialize any table source input as a new `Matrix` or in the case of a `MatrixTable`
return the originally wrapped matrix. If the table column element types are not homogeneous,
they will be promoted to a common type in the materialized `Matrix`. Note that column names are
ignored in the conversion. By default, input table columns will be materialized as corresponding
matrix columns; passing `transpose=true` will transpose the input with input columns as matrix rows
or in the case of a `MatrixTable` apply `permutedims` to the originally wrapped matrix.
"""
function matrix(table; transpose::Bool=false)
    cols = Columns(table)
    types = schema(cols).types
    T = reduce(promote_type, types)
    n, p = rowcount(cols), length(types)
    if !transpose
        matrix = Matrix{T}(undef, n, p)
        for (i, col) in enumerate(cols)
            matrix[:, i] .= col
        end
    else
        matrix = Matrix{T}(undef, p, n)
        for (i, col) in enumerate(cols)
            matrix[i, :] .= col
        end
    end
    return matrix
end

function matrix(table::MatrixTable; transpose::Bool=false)
    matrix = getfield(table, :matrix)
    if transpose
        return permutedims(matrix)
    elseif matrix isa AbstractVector
        # always return a matrix, for type stability
        return reshape(matrix, :, 1)
    else
        return matrix
    end
end

# implement default nrow and ncol methods for DataAPI.jl

DataAPI.nrow(table::MatrixRowTable) = length(table)
DataAPI.ncol(table::MatrixRowTable) = size(getfield(table, :matrix), 2) # this is correct even if m is a vector

# Tables.Scan: a plain-data scan request — column selection/renaming/type
# overrides, row predicates, and limits — one shared vocabulary that any
# data source can accept and push down. Two pieces:
#
#     Tables.Scan(...)             the request (a value; no Function fields)
#     Tables.scan(table, scan)     the generic executor over any Tables.jl table
#
# Sources that can push a scan down accept it as a keyword — `CSV.File(path;
# scan=Tables.Scan(...))`, `Arrow.Table(path; scan=...)` — and apply what they
# can WHILE materializing (skipping columns never parsed, rows never decoded).
# What a source cannot push down it either rejects with an ArgumentError, or
# hands to `Tables.scan` as a residual (e.g. `Tables.Scan(scan; filter=nothing)`
# after evaluating the filter itself; axes strip in execution order — filter,
# then row bounds, then projection). Sources are free to support only a
# subset — the value is the shared vocabulary and the pushdown, not a
# capability-negotiation protocol.
#
# Design commitments (each learned the hard way by prior systems):
#   * Every node is a plain value — no `Function` fields anywhere. Closures are
#     opaque to pushdown and to static compilation; expression values are not.
#   * The source's answer is the residual itself, not a capability
#     advertisement. Pushed and residual work may overlap (a source that
#     prunes by a predicate but cannot guarantee exactness keeps the filter in
#     the residual).
#   * Missing follows SQL WHERE: a predicate evaluating to `missing` excludes
#     the row. `isnull`/`!isnull` are first-class nodes; comparisons never
#     match missing.
#   * Filters reference SOURCE column names (pre-rename); the pipeline order
#     is fixed: resolve → filter → offset/limit → project/rename/type.
#   * Selection order defines output order.

# --- column references & selection items --------------------------------------

import DataAPI: All

"""
    Tables.Not(ref)

Selection item excluding `ref` (a name, index, `Regex`, or a `Tuple`/`Vector`
of those) from the full column set. `Not` items cannot be mixed with positive
selections in the same `select`.
"""
struct Not{T}
    ref::T
end

const ColRef = Union{Symbol, String, Int, Regex}

"""
    Tables.SelectItem

One resolved element of `Scan.select`: a column reference plus optional type
override and output name. Users never construct these directly — the `Scan`
constructor lowers `ref`, `ref => name`, `ref => Type`, and
`ref => Type => name` forms.
"""
struct SelectItem
    ref::Union{Symbol, String, Int, Regex, Not, All}
    type::Union{Nothing, Type}
    rename::Union{Nothing, Symbol}
end

function _selectitem(x::Not)
    refs = x.ref isa Union{Tuple, AbstractVector} ? x.ref : (x.ref,)
    all(r -> r isa ColRef, refs) ||
        throw(ArgumentError("Not references must be Symbol/String/Int/Regex values"))
    return SelectItem(x, nothing, nothing)
end
function _selectitem(x::All)
    # DataAPI.All(cols...) with arguments is deprecated DataFrames syntax;
    # silently selecting every column would be a data-loss trap
    isempty(x.cols) ||
        throw(ArgumentError("Tables.All() takes no arguments in a scan selection; " *
                            "list the columns directly instead of All(cols...)"))
    return SelectItem(x, nothing, nothing)
end
_selectitem(x::Union{Symbol, String, Int, Regex, Not}) = SelectItem(x, nothing, nothing)
_selectitem(p::Pair{<:Union{Symbol, String, Int, Regex}, Symbol}) = SelectItem(p.first, nothing, p.second)
_selectitem(p::Pair{<:Union{Symbol, String, Int, Regex}, String}) = SelectItem(p.first, nothing, Symbol(p.second))
_selectitem(p::Pair{<:Union{Symbol, String, Int, Regex}, <:Type}) = SelectItem(p.first, p.second, nothing)
_selectitem(p::Pair{<:Union{Symbol, String, Int, Regex}, <:Pair{<:Type, Symbol}}) =
    SelectItem(p.first, p.second.first, p.second.second)
_selectitem(x) = throw(ArgumentError("unsupported select item $(repr(x)); expected a column " *
    "reference (Symbol/String/Int/Regex/Not/All), or ref => name, ref => Type, ref => Type => name"))

# --- the expression algebra ----------------------------------------------------
#
# A small closed vocabulary — the intersection every surveyed engine supports
# and every statistics pruner can use. Growth happens through `OpNode`
# (name + children), never through new struct kinds every consumer must learn.

abstract type ScanExpr end

struct Col <: ScanExpr
    ref::Union{Symbol, String, Int}
end
"""
    Tables.col(ref)

A column reference inside a `Scan` filter: `col(:price) > 100`. Comparisons
against literals, `colin`, `isnull`, `startswith`/`endswith`/`contains`, and
`&`/`|`/`!` build plain expression values.
"""
col(r::Union{Symbol, AbstractString, Int}) = Col(r isa AbstractString ? String(r) : r)

@enum ComparisonOperator::UInt8 begin
    OP_EQ = 0x01
    OP_NE = 0x02
    OP_LT = 0x03
    OP_LE = 0x04
    OP_GT = 0x05
    OP_GE = 0x06
end
const _OPNAMES = ("==", "!=", "<", "<=", ">", ">=")
_colcolerr() = throw(ArgumentError("column-to-column comparisons are not supported; " *
                                   "compare a column against a literal value"))

struct Cmp{T} <: ScanExpr
    op::ComparisonOperator
    lhs::Col
    rhs::T
    function Cmp(op::ComparisonOperator, lhs::Col, rhs::T) where {T}
        rhs isa Col && _colcolerr()
        return new{T}(op, lhs, rhs)
    end
end
function Cmp(op::Integer, lhs::Col, rhs)
    0x01 <= op <= 0x06 || throw(ArgumentError("unknown comparison operator code $op"))
    return Cmp(ComparisonOperator(op), lhs, rhs)
end

_comparisonoperator(::typeof(==)) = OP_EQ
_comparisonoperator(::typeof(!=)) = OP_NE
_comparisonoperator(::typeof(<)) = OP_LT
_comparisonoperator(::typeof(<=)) = OP_LE
_comparisonoperator(::typeof(>)) = OP_GT
_comparisonoperator(::typeof(>=)) = OP_GE
_comparisonoperator(op) = throw(ArgumentError(
    "unsupported comparison function $(repr(op)); expected ==, !=, <, <=, >, or >=",
))
"""
    Tables.colcmp(op, col, value)

Build a comparison predicate for a column and a literal value. `op` must be
`==`, `!=`, `<`, `<=`, `>`, or `>=`. Ordered comparisons also support the
shorthand `col(:x) < value` for numeric, string, and character values.

Use `colcmp` for equality so `==` and `isequal` on expression objects keep
their normal Boolean contracts.
"""
colcmp(op, c::Col, value) = Cmp(_comparisonoperator(op), c, value)

struct In{T} <: ScanExpr
    lhs::Col
    values::T
    function In(lhs::Col, values::T) where {T}
        values isa Col && _colcolerr()
        return new{T}(lhs, values)
    end
end

"""
    Tables.colin(col, values)

Build a membership predicate: `colin(col(:status), ("active", "trial"))`.
If the column value is `missing`, the predicate result is also `missing`.
"""
colin(c::Col, values) = In(c, values)

struct IsNull <: ScanExpr
    lhs::Col
    negated::Bool
end

"""
    Tables.isnull(col)

Build a predicate that is true when the column value is Julia's `missing`.
Use `!Tables.isnull(col)` to match values that are not `missing`.

The `isnull` name is deliberate. Defining `Base.ismissing(::Col)` would
specialize Base's broad fallback and invalidate unrelated precompiled code
when Tables loads. Use `isnull` rather than `colcmp(==, col(:x), missing)`,
which follows SQL semantics and matches no row.
"""
function isnull end
isnull(c::Col) = IsNull(c, false)

@enum StringPredicate::UInt8 begin
    STR_STARTSWITH = 0x01
    STR_ENDSWITH = 0x02
    STR_CONTAINS = 0x03
end

struct StrPred <: ScanExpr
    kind::StringPredicate
    lhs::Col
    s::String
    function StrPred(kind::StringPredicate, lhs::Col, s::AbstractString)
        return new(kind, lhs, String(s))
    end
end
function StrPred(kind::Integer, lhs::Col, s::AbstractString)
    0x01 <= kind <= 0x03 || throw(ArgumentError("unknown string predicate code $kind"))
    return StrPred(StringPredicate(kind), lhs, s)
end

struct AndExpr <: ScanExpr
    args::Vector{ScanExpr}
end
struct OrExpr <: ScanExpr
    args::Vector{ScanExpr}
end
struct NotExpr <: ScanExpr
    arg::ScanExpr
end
struct AlwaysTrue <: ScanExpr end
struct AlwaysFalse <: ScanExpr end

"""
    Tables.OpNode(name, args)

The expression algebra's growth channel. Every node has a symbolic `name` and
plain-data arguments. A source can recognize and consume that name before
generic resolution. An unconsumed `OpNode` is rejected by `Tables.resolve` and
the generic executor.
"""
struct OpNode <: ScanExpr
    name::Symbol
    args::Vector{Any}
end

for T in (Number, AbstractString, AbstractChar)
    @eval begin
        Base.:<(c::Col, v::$T) = colcmp(<, c, v)
        Base.:<(v::$T, c::Col) = colcmp(>, c, v)
        Base.:<=(c::Col, v::$T) = colcmp(<=, c, v)
        Base.:<=(v::$T, c::Col) = colcmp(>=, c, v)
    end
end
Base.:(==)(a::Col, b::Col) = a.ref == b.ref
Base.isequal(a::Col, b::Col) = isequal(a.ref, b.ref)
Base.hash(c::Col, h::UInt) = hash(c.ref, h + 0x6f38a7d1)
Base.:<(::Col, ::Col) = _colcolerr()
Base.:<=(::Col, ::Col) = _colcolerr()

Base.startswith(c::Col, s::AbstractString) = StrPred(STR_STARTSWITH, c, String(s))
Base.endswith(c::Col, s::AbstractString) = StrPred(STR_ENDSWITH, c, String(s))
Base.contains(c::Col, s::AbstractString) = StrPred(STR_CONTAINS, c, String(s))

_ands(e::AndExpr) = e.args
_ands(e::ScanExpr) = ScanExpr[e]
_ors(e::OrExpr) = e.args
_ors(e::ScanExpr) = ScanExpr[e]
Base.:&(a::ScanExpr, b::ScanExpr) = AndExpr(vcat(_ands(a), _ands(b)))
Base.:|(a::ScanExpr, b::ScanExpr) = OrExpr(vcat(_ors(a), _ors(b)))
Base.:!(e::ScanExpr) = NotExpr(e)
Base.:!(e::NotExpr) = e.arg
Base.:!(e::IsNull) = IsNull(e.lhs, !e.negated)

# a bare Col is not a predicate; catch the likely mistake early
_checkpredicate(::Nothing) = nothing
function _checkpredicate(e::Union{AndExpr, OrExpr})
    foreach(_checkpredicate, e.args)
    return e
end
function _checkpredicate(e::NotExpr)
    _checkpredicate(e.arg)
    return e
end
_checkpredicate(e::ScanExpr) = e
_checkpredicate(e::Col) =
    throw(ArgumentError("a bare column reference is not a predicate; compare it against a value"))
_checkpredicate(x) =
    throw(ArgumentError("filter must be a Tables.ScanExpr built from Tables.col(...), got $(typeof(x))"))

# --- the Scan value --------------------------------------------------------------

"""
    Tables.Scan(; select=Tables.All(), filter=nothing, limit=nothing, offset=nothing, validate=true)

A scan request: what to keep, what to call it, how to type it, which rows
qualify, and how many. Plain data all the way down — see `Tables.scan` for
the generic executor and the module comment for how sources push it down.

  * `select`: a column reference or tuple/vector of select items
    (`ref`, `ref => name`, `ref => Type`, `ref => Type => name`; refs in the
    pair forms are `Symbol`/`String`/`Int`/`Regex`, while bare `Tables.Not`
    and `Tables.All()` items stand alone). `Tables.All()` keeps every column;
    `()` selects zero columns. Selection order = output order.
  * `filter`: an expression built from `Tables.col`; a row is kept iff the
    predicate evaluates to exactly `true` (`missing` excludes, SQL-style).
    Filters see source column names, before renames.
  * `limit`/`offset`: applied to qualifying rows, after the filter.
  * `validate`: error on select/filter references that match no column.
    `false` is the schema-evolution knob: unmatched SELECT references are
    silently dropped, and an unmatched FILTER reference evaluates as an
    all-missing column (`isnull(col(:gone))` keeps every row; comparisons
    against it exclude, SQL-style).
"""
struct Scan
    select::Vector{SelectItem}
    filter::Union{Nothing, ScanExpr}
    limit::Union{Nothing, Int}
    offset::Int
    validate::Bool
    function Scan(select::Vector{SelectItem},
                  filter, limit::Union{Nothing, Int},
                  offset::Int, validate::Bool)
        limit === nothing || limit >= 0 ||
            throw(ArgumentError("limit must be ≥ 0 (got $limit)"))
        offset >= 0 || throw(ArgumentError("offset must be ≥ 0 (got $offset)"))
        nots = count(it -> it.ref isa Not, select)
        0 < nots < length(select) &&
            throw(ArgumentError("Not(...) selections cannot be mixed with positive selections"))
        return new(select, _checkpredicate(filter), limit, offset, validate)
    end
end

_selectitems(select::Vector{SelectItem}) = select
_selectitems(select::Union{Tuple, AbstractVector}) = SelectItem[_selectitem(x) for x in select]
_selectitems(select) = SelectItem[_selectitem(select)]

function Scan(; select=All(), filter=nothing, limit::Union{Nothing, Integer}=nothing,
                offset::Union{Nothing, Integer}=nothing, validate::Bool=true)
    items = _selectitems(select)
    lim = limit === nothing ? nothing : Int(limit)
    off = offset === nothing ? 0 : Int(offset)
    return Scan(items, filter, lim, off, validate)
end

"""
    Tables.Scan(scan::Scan; select=scan.select, filter=scan.filter,
                limit=scan.limit, offset=scan.offset, validate=scan.validate)

Copy a scan with some axes replaced — how a source builds the RESIDUAL it
hands to `Tables.scan` after pushing the rest down. The axes compose in a
fixed order — filter, then row bounds, then projection — so a source may only
strip an axis it performed exactly, together with every axis that comes
before it: a reader that evaluated the filter itself hands over
`Tables.Scan(scan; filter=nothing)`; one that also applied the row bounds
hands over `Tables.Scan(scan; filter=nothing, limit=nothing, offset=0)`.
Projection (`select=All()`) can only be stripped in addition when no residual
filter references a column the projection dropped or renamed. A reader that
cannot consume the filter must leave `limit`/`offset` in the residual too —
they count qualifying rows, not raw rows.
"""
function Scan(s::Scan; select=s.select, filter=s.filter,
              limit::Union{Nothing, Integer}=s.limit,
              offset::Union{Nothing, Integer}=s.offset, validate::Bool=s.validate)
    items = _selectitems(select)
    lim = limit === nothing ? nothing : Int(limit)
    off = offset === nothing ? 0 : Int(offset)
    return Scan(items, filter, lim, off, validate)
end

function _isallselection(select::Vector{SelectItem})
    length(select) == 1 || return false
    item = only(select)
    return item.ref isa All && item.type === nothing && item.rename === nothing
end

_isidentity(s::Scan) =
    _isallselection(s.select) && s.filter === nothing && s.limit === nothing && s.offset == 0


# --- schema resolution -----------------------------------------------------------

"""
    Tables.BoundColumn

One output column after `Tables.resolve`: the source column index, the output
name (post-rename, uniqueness enforced), and the optional type override.
"""
struct BoundColumn
    index::Int
    name::Symbol
    type::Union{Nothing, Type}
end

"""
    Tables.BoundScan

A `Scan` resolved against a concrete schema: output columns in order, the
filter with positional references normalized to source names, the source
column indices it references, and the row bounds. Sources can use this after
resolving a raw `Scan`.
"""
struct BoundScan
    columns::Vector{BoundColumn}
    filter::Union{Nothing, ScanExpr}
    filtercols::Vector{Int}
    limit::Union{Nothing, Int}
    offset::Int
    validate::Bool
end

_findcol(names, r::Symbol) = findfirst(==(r), names)
_findcol(names, r::String) = findfirst(==(Symbol(r)), names)
_findcol(names, r::Int) = 1 <= r <= length(names) ? r : nothing
function _findcols(names, r::Regex)
    return findall(nm -> occursin(r, String(nm)), names)
end
function _findcols(names, r)
    i = _findcol(names, r)
    return i === nothing ? Int[] : Int[i]
end
_refstr(r) = r isa Regex ? "r$(repr(r.pattern))" : repr(r)

function _expand!(out::Vector{BoundColumn}, names, it::SelectItem, validate::Bool)
    r = it.ref
    if r isa All
        append!(out, BoundColumn(i, nm, it.type) for (i, nm) in enumerate(names))
    else
        found = _findcols(names, r)
        if isempty(found)
            validate && throw(ArgumentError("select reference $(_refstr(r)) matches no column " *
                                            "(pass validate=false to skip unmatched references)"))
            return
        end
        r isa Regex && it.rename !== nothing && length(found) > 1 &&
            throw(ArgumentError("pattern rename $(repr(it.rename)) applies to multiple columns"))
        append!(out, BoundColumn(i, it.rename === nothing ? names[i] : it.rename, it.type)
                     for i in found)
    end
    return
end

_notrefs(x::Union{Tuple, AbstractVector}) = collect(Any, x)
_notrefs(x) = Any[x]

function _resolvefilter(e::ScanExpr, names, refs::Vector{Int}, validate::Bool)
    if e isa Col
        i = _findcol(names, e.ref)
        i === nothing && validate &&
            throw(ArgumentError("filter references unknown column $(_refstr(e.ref))"))
        i === nothing && return e
        i in refs || push!(refs, i)
        return Col(names[i])
    elseif e isa Cmp
        return Cmp(e.op, _resolvefilter(e.lhs, names, refs, validate), e.rhs)
    elseif e isa In
        return In(_resolvefilter(e.lhs, names, refs, validate), e.values)
    elseif e isa IsNull
        return IsNull(_resolvefilter(e.lhs, names, refs, validate), e.negated)
    elseif e isa StrPred
        return StrPred(e.kind, _resolvefilter(e.lhs, names, refs, validate), e.s)
    elseif e isa AndExpr || e isa OrExpr
        args = ScanExpr[_resolvefilter(a, names, refs, validate) for a in e.args]
        return e isa AndExpr ? AndExpr(args) : OrExpr(args)
    elseif e isa NotExpr
        return NotExpr(_resolvefilter(e.arg, names, refs, validate))
    elseif e isa OpNode
        throw(ArgumentError("cannot resolve extension node $(repr(e.name)); " *
                            "a source must consume it before calling Tables.resolve"))
    end
    return e
end

"""
    Tables.resolve(scan::Scan, names) -> BoundScan

Resolve a `Scan` against a source's column names (any iterable of `Symbol`s).
Errors on unmatched references (under `validate`), mixed `Not`/positive
selections, and duplicate output names. Regex references expand in file
order; selection order defines output order. Positional filter references are
replaced with source names so the resolved filter remains valid over a subset
containing only its referenced columns.
"""
function resolve(scan::Scan, names)
    nms = collect(Symbol, names)
    cols = BoundColumn[]
    if _isallselection(scan.select)
        append!(cols, BoundColumn(i, nm, nothing) for (i, nm) in enumerate(nms))
    elseif !isempty(scan.select) && scan.select[1].ref isa Not
        excluded = Set{Int}()
        for it in scan.select, r in _notrefs((it.ref::Not).ref)
            found = _findcols(nms, r)
            scan.validate && isempty(found) && throw(ArgumentError(
                "Not(...) $(r isa Regex ? "pattern" : "reference") $(_refstr(r)) matches no column",
            ))
            union!(excluded, found)
        end
        append!(cols, BoundColumn(i, nm, nothing) for (i, nm) in enumerate(nms) if !(i in excluded))
    else
        foreach(it -> _expand!(cols, nms, it, scan.validate), scan.select)
    end
    seen = Set{Symbol}()
    for c in cols
        c.name in seen && throw(ArgumentError("duplicate output column name $(repr(c.name)); " *
                                              "rename one of the selections"))
        push!(seen, c.name)
    end
    refs = Int[]
    filter = scan.filter === nothing ? nothing :
             _resolvefilter(scan.filter, nms, refs, scan.validate)
    return BoundScan(cols, filter, refs, scan.limit, scan.offset, scan.validate)
end

# --- generic evaluation ------------------------------------------------------------

_getcol(cols, ref::Symbol) = getcolumn(cols, ref)
_getcol(cols, ref::String) = getcolumn(cols, Symbol(ref))
_getcol(cols, ref::Int) = getcolumn(cols, ref)

# Under `strict`, an unknown filter reference is an error. Otherwise, it
# resolves to an all-missing column. `isnull` then keeps every row, comparisons
# exclude every row, and Boolean expressions use three-valued logic.
function _resolvecol(cols, ref, strict::Bool)
    i = _findcol(columnnames(cols), ref)
    i === nothing || return getcolumn(cols, i)
    strict && throw(ArgumentError("filter references unknown column $(_refstr(ref))"))
    return nothing
end

# Three-valued vectorized evaluation; the top level keeps rows where the
# result is exactly `true` (SQL WHERE). Comparison kernels close over their
# literal so collection-valued rows compare whole values per row instead of
# broadcasting the literal against the column. The fallback uses only the
# scalar-indexing contract required by Tables.jl; the AbstractVector path
# keeps broadcast's optimized kernels.
_columnmap(f, c::AbstractVector, ::Int) = f.(c)
_columnmap(f, c, n::Int) = [f(c[i]) for i in 1:n]

function _evalexpr(e::ScanExpr, cols, strict::Bool=true)
    if e isa Cmp
        a = _resolvecol(cols, e.lhs.ref, strict)
        a === nothing && return fill(missing, rowcount(cols))
        n = rowcount(cols)
        return e.op == OP_EQ ? _columnmap(x -> x == e.rhs, a, n) :
               e.op == OP_NE ? _columnmap(x -> x != e.rhs, a, n) :
               e.op == OP_LT ? _columnmap(x -> x < e.rhs, a, n) :
               e.op == OP_LE ? _columnmap(x -> x <= e.rhs, a, n) :
               e.op == OP_GT ? _columnmap(x -> x > e.rhs, a, n) :
               e.op == OP_GE ? _columnmap(x -> x >= e.rhs, a, n) :
               throw(ArgumentError("unknown comparison operator code $(e.op)"))
    elseif e isa In
        a = _resolvecol(cols, e.lhs.ref, strict)
        a === nothing && return fill(missing, rowcount(cols))
        return _columnmap(x -> ismissing(x) ? missing : in(x, e.values), a, rowcount(cols))
    elseif e isa IsNull
        a = _resolvecol(cols, e.lhs.ref, strict)
        a === nothing &&
            return e.negated ? falses(rowcount(cols)) : trues(rowcount(cols))
        return e.negated ? _columnmap(x -> !ismissing(x), a, rowcount(cols)) :
                           _columnmap(ismissing, a, rowcount(cols))
    elseif e isa StrPred
        a = _resolvecol(cols, e.lhs.ref, strict)
        a === nothing && return fill(missing, rowcount(cols))
        f = e.kind == STR_STARTSWITH ? startswith :
            e.kind == STR_ENDSWITH ? endswith :
            e.kind == STR_CONTAINS ? contains :
            throw(ArgumentError("unknown string predicate code $(e.kind)"))
        return _columnmap(x -> ismissing(x) ? missing : f(x, e.s), a, rowcount(cols))
    elseif e isa AndExpr
        isempty(e.args) && return trues(rowcount(cols))
        return mapreduce(a -> _evalexpr(a, cols, strict), (x, y) -> x .& y, e.args)
    elseif e isa OrExpr
        isempty(e.args) && return falses(rowcount(cols))
        return mapreduce(a -> _evalexpr(a, cols, strict), (x, y) -> x .| y, e.args)
    elseif e isa NotExpr
        return .!_evalexpr(e.arg, cols, strict)
    elseif e isa AlwaysTrue
        return trues(rowcount(cols))
    elseif e isa AlwaysFalse
        return falses(rowcount(cols))
    end
    throw(ArgumentError("cannot generically evaluate $(typeof(e))"))
end

# The Bool-mask comprehension runs behind a FUNCTION BARRIER: `_evalexpr`
# returns an abstractly-typed vector (its result type depends on the
# expression tree), and `Bool[x === true for x in v]` over an abstract `v`
# melts into per-element dynamic dispatch — measured 100× slower than the
# same loop behind a barrier (62 ms → 0.6 ms over a 1M-row mask). The
# barrier costs ONE dynamic dispatch per mask instead. The column kernels
# inside `_evalexpr` specialize on the concrete container at their own call
# boundary.
@noinline _boolmask(v::AbstractVector) = Bool[x === true for x in v]
"""
    Tables.filtermask(scan_or_expr, table) -> AbstractVector{Bool}

Evaluate a scan's filter over a table's columns: `mask[i]` is `true` iff row
`i` qualifies (a `missing` predicate result excludes the row). Sources use
this for their own pushdown implementations. The bare-expression form is
strict about unknown column references. The `Scan` form follows the scan's
`validate` setting. The `BoundScan` form uses its resolved filter and is safe
to evaluate over a table containing only `filtercols`.
"""
filtermask(e::ScanExpr, table) = _boolmask(_evalexpr(_checkpredicate(e), columns(table)))
filtermask(s::Scan, table) = s.filter === nothing ?
    trues(rowcount(columns(table))) :
    _boolmask(_evalexpr(s.filter, columns(table), s.validate))
filtermask(s::BoundScan, table) = s.filter === nothing ?
    trues(rowcount(columns(table))) :
    _boolmask(_evalexpr(s.filter, columns(table), s.validate))

_converted(::Nothing, c::AbstractVector) = c
function _converted(::Type{T}, c::AbstractVector) where {T}
    # eltype Union{} (necessarily empty) is vacuously <: everything, but the
    # requested output schema still owes the override type
    if eltype(c) !== Union{} && eltype(c) <: Union{T, Missing}
        return c
    end
    anymissing = any(ismissing, c)
    E = anymissing ? Union{T, Missing} : T
    out = allocatecolumn(E, length(c))
    @inbounds for i in eachindex(c)
        x = c[i]
        out[i] = ismissing(x) ? missing : convert(T, x)
    end
    return out
end

_takecolumn(c::AbstractVector, idx) = c[idx]
_takecolumn(c, idx) = [c[i] for i in idx]

struct _ScanTable{T <: NamedTuple} <: AbstractColumns
    columns::T
    nrows::Int
end
columnnames(t::_ScanTable) = propertynames(getfield(t, :columns))
getcolumn(t::_ScanTable, i::Int) = getfield(getfield(t, :columns), i)
getcolumn(t::_ScanTable, name::Symbol) = getproperty(getfield(t, :columns), name)
rowcount(t::_ScanTable) = getfield(t, :nrows)

function _zerocolumnpredicate(e)
    e === nothing && return true
    e isa AlwaysTrue && return true
    e isa AlwaysFalse && return false
    e isa IsNull && return !e.negated
    if e isa AndExpr
        sawmissing = false
        for arg in e.args
            result = _zerocolumnpredicate(arg)
            result === false && return false
            result === missing && (sawmissing = true)
        end
        return sawmissing ? missing : true
    elseif e isa OrExpr
        sawmissing = false
        for arg in e.args
            result = _zerocolumnpredicate(arg)
            result === true && return true
            result === missing && (sawmissing = true)
        end
        return sawmissing ? missing : false
    elseif e isa NotExpr
        result = _zerocolumnpredicate(e.arg)
        return result === missing ? missing : !result
    elseif e isa OpNode
        throw(ArgumentError("cannot generically evaluate extension node $(repr(e.name))"))
    end
    return missing
end

function _windowcount(n::Int, filterresult, offset::Int, limit::Union{Nothing, Int})
    filterresult === true || return 0
    skipped = min(offset, n)
    available = n - skipped
    return limit === nothing ? available : min(limit, available)
end

"""
    Tables.scan(table, scan::Scan) -> table′

Apply a `Scan` generically over any Tables.jl table: filter, then offset/limit,
then projection, renames, and type overrides. A filter keeps only exact `true`;
`missing` excludes the row. The input table is returned unchanged for an
identity request. Other results are column tables. A zero-column result keeps
its row count.

This is the reference behavior every pushdown must preserve. A source can hand
its unconsumed residual request to this function.
"""
function scan(table, scan::Scan)
    _isidentity(scan) && return table
    cols = columns(table)
    b = resolve(scan, columnnames(cols))
    nrows = rowcount(cols)
    if isempty(columnnames(cols))
        taken = _windowcount(nrows, _zerocolumnpredicate(b.filter), b.offset, b.limit)
        return _ScanTable(NamedTuple(), taken)
    elseif b.filter !== nothing
        keep = filtermask(b, cols)
        idx = findall(keep)
    else
        idx = 1:nrows
    end
    skipped = min(b.offset, length(idx))
    available = length(idx) - skipped
    taken = b.limit === nothing ? available : min(b.limit, available)
    idx = idx[(skipped + 1):(skipped + taken)]
    outnames = Tuple(c.name for c in b.columns)
    isempty(outnames) && return _ScanTable(NamedTuple(), taken)
    outcols = Tuple(_converted(c.type, _takecolumn(getcolumn(cols, c.index), idx)) for c in b.columns)
    return NamedTuple{outnames}(outcols)
end

# --- display -----------------------------------------------------------------------

function _exprstr(e::ScanExpr)
    e isa Cmp && return "colcmp($(_OPNAMES[Int(e.op)]), col($(repr(e.lhs.ref))), $(repr(e.rhs)))"
    e isa In && return "colin(col($(repr(e.lhs.ref))), $(repr(e.values)))"
    e isa IsNull && return (e.negated ? "!isnull(" : "isnull(") * "col($(repr(e.lhs.ref))))"
    e isa StrPred && return (e.kind == STR_STARTSWITH ? "startswith" :
                             e.kind == STR_ENDSWITH ? "endswith" : "contains") *
                            "(col($(repr(e.lhs.ref))), $(repr(e.s)))"
    e isa AndExpr && return isempty(e.args) ? "true" :
        join(("(" * _exprstr(a) * ")" for a in e.args), " & ")
    e isa OrExpr && return isempty(e.args) ? "false" :
        join(("(" * _exprstr(a) * ")" for a in e.args), " | ")
    e isa NotExpr && return "!(" * _exprstr(e.arg) * ")"
    e isa AlwaysTrue && return "true"
    e isa AlwaysFalse && return "false"
    e isa OpNode && return "OpNode($(repr(e.name)), …)"
    return string(e)
end

function Base.show(io::IO, s::Scan)
    print(io, "Tables.Scan(")
    parts = String[]
    if !_isallselection(s.select)
        sel = join((begin
            r = it.ref isa Not ? "Not($(_refstr(it.ref.ref)))" :
                it.ref isa All ? "All()" : _refstr(it.ref)
            it.type !== nothing && (r *= " => $(it.type)")
            it.rename !== nothing && (r *= " => $(repr(it.rename))")
            r
        end for it in s.select), ", ")
        push!(parts, "select = ($sel)")
    end
    s.filter === nothing || push!(parts, "filter = " * _exprstr(s.filter))
    s.limit === nothing || push!(parts, "limit = $(s.limit)")
    s.offset == 0 || push!(parts, "offset = $(s.offset)")
    s.validate || push!(parts, "validate = false")
    print(io, join(parts, ", "), ")")
end

"""
    Tables.describe([io,] scan, residual)

Print a scan next to the residual a source handed to `Tables.scan` — the
EXPLAIN affordance for pushdown debugging.
"""
function describe(io::IO, scan::Scan, residual::Scan)
    println(io, "scan:     ", scan)
    println(io, "residual: ", _isidentity(residual) ? "(empty — fully pushed down)" : residual)
end
describe(scan::Scan, residual::Scan) = describe(stdout, scan, residual)

"helper function to calculate a run-length encoding of a tuple type"
Base.@pure function runlength(::Type{T}) where {T <: Tuple}
    rle = Tuple{Type, Int}[]
    fieldcount(T) == 0 && return rle
    curT = fieldtype(T, 1)
    prevT = curT
    len = 1
    for i = 2:fieldcount(T)
        @inbounds curT = fieldtype(T, i)
        if curT === prevT
            len += 1
        else
            push!(rle, (prevT, len))
            prevT = curT
            len = 1
        end
    end
    push!(rle, (curT, len))
    return rle
end

"""
    Tables.eachcolumn(f, sch::Tables.Schema{names, types}, x::Union{Tables.AbstractRow, Tables.AbstractColumns})
    Tables.eachcolumn(f, sch::Tables.Schema{names, nothing}, x::Union{Tables.AbstractRow, Tables.AbstractColumns})

Takes a function `f`, table schema `sch`, `x`, which is an object that satisfies the `AbstractRow` or `AbstractColumns` interfaces;
it generates calls to get the value for each column (`Tables.getcolumn(x, nm)`) and then calls `f(val, index, name)`, where `f` is the
user-provided function, `val` is the column value (`AbstractRow`) or entire column (`AbstractColumns`), `index` is the column index as an `Int`,
and `name` is the column name as a `Symbol`.

An example using `Tables.eachcolumn` is:
```julia
rows = Tables.rows(tbl)
sch = Tables.schema(rows)
if sch === nothing
    state = iterate(rows)
    state === nothing && return
    row, st = state
    sch = Tables.schema(Tables.columnnames(row), nothing)
    while state !== nothing
        Tables.eachcolumn(sch, row) do val, i, nm
            bind!(stmt, i, val)
        end
        state = iterate(rows, st)
        state === nothing && return
        row, st = state
    end
else
    for row in rows
        Tables.eachcolumn(sch, row) do val, i, nm
            bind!(stmt, i, val)
        end
    end
end
```
Note in this example we account for the input table potentially returning `nothing` from `Tables.schema(rows)`; in that case, we start
iterating the rows, and build a partial schema using the column names from the first row `sch = Tables.schema(Tables.columnnames(row), nothing)`,
which is valid to pass to `Tables.eachcolumn`.
"""
function eachcolumn end

quot(s::Symbol) = Meta.QuoteNode(s)
quot(x::Int) = x

@inline function eachcolumn(f::F, sch::Schema{names, types}, row::T) where {F, names, types, T}
    N = fieldcount(types)
    if N <= SPECIALIZATION_THRESHOLD
        Base.@nexprs 100 i -> begin
            if i <= N
                f(getcolumn(row, fieldtype(types, i), i, names[i]), i, names[i])
            end
        end
    else
        for (i, nm) in enumerate(names)
            f(getcolumn(row, fieldtype(types, i), i, nm), i, nm)
        end
    end
    return
end

@inline function eachcolumn(f::F, sch::Schema{names, nothing}, row::T) where {F, names, T}
    N = length(names)
    if N <= SPECIALIZATION_THRESHOLD
        Base.@nexprs 100 i -> begin
            if i <= N
                f(getcolumn(row, names[i]), i, names[i])
            end
        end
    else
        for (i, nm) in enumerate(names)
            f(getcolumn(row, nm), i, nm)
        end
    end
    return
end

@inline function eachcolumn(f::F, sch::Schema{nothing, nothing}, row::T) where {F, T}
    for (i, nm) in enumerate(sch.names)
        f(getcolumn(row, nm), i, nm)
    end
    return
end

# these are specialized `eachcolumn`s where we also want
# the indexing of `columns` to be constant propagated, so it needs to be returned from the generated function
@inline function eachcolumns(f::F, sch::Schema{names, types}, row::T, columns::S, args...) where {F, names, types, T, S}
    N = fieldcount(types)
    if N <= SPECIALIZATION_THRESHOLD
        Base.@nexprs 100 i -> begin
            if i <= N
                f(getcolumn(row, fieldtype(types, i), i, names[i]), i, names[i], columns[i], args...)
            end
        end
    else
        for (i, nm) in enumerate(names)
            f(getcolumn(row, fieldtype(types, i), i, nm), i, nm, columns[i], args...)
        end
    end
    return
end

@inline function eachcolumns(f::F, sch::Schema{names, nothing}, row::T, columns::S, args...) where {F, names, T, S}
    N = length(names)
    if N <= SPECIALIZATION_THRESHOLD
        Base.@nexprs 100 i -> begin
            if i <= N
                f(getcolumn(row, names[i]), i, names[i], columns[i], args...)
            end
        end
    else
        for (i, nm) in enumerate(names)
            f(getcolumn(row, nm), i, nm, columns[i], args...)
        end
    end
    return
end

@inline function eachcolumns(f::F, sch::Schema{nothing, nothing}, row::T, columns::S, args...) where {F, T, S}
    for (i, nm) in enumerate(sch.names)
        f(getcolumn(row, nm), i, nm, columns[i], args...)
    end
    return
end

"""
    rowmerge(row, other_rows...)
    rowmerge(row; fields_to_merge...)

Return a `NamedTuple` by merging `row` (an `AbstractRow`-compliant value) with `other_rows`
(one or more `AbstractRow`-compliant values) via `Base.merge`. This function is similar to
`Base.merge(::NamedTuple, ::NamedTuple...)`, but accepts `AbstractRow`-compliant values
instead of `NamedTuple`s.

A convenience method `rowmerge(row; fields_to_merge...) = rowmerge(row, fields_to_merge)`
is defined that enables the `fields_to_merge` to be specified as keyword arguments.
"""
rowmerge(row, other) = merge(_row_to_named_tuple(row), _row_to_named_tuple(other))
rowmerge(row, other, more...) = merge(_row_to_named_tuple(row), rowmerge(other, more...))
rowmerge(row; fields_to_merge...) = rowmerge(row, values(fields_to_merge))

_row_to_named_tuple(row::NamedTuple) = row
_row_to_named_tuple(row) = NamedTuple(Row(row))

"""
    ByRow <: Function

`ByRow(f)` returns a function which applies function `f` to each element in a vector.

`ByRow(f)` can be passed two types of arguments:
- One or more 1-based `AbstractVector`s of equal length: In this case the returned value
  is a vector resulting from applying `f` to elements of passed vectors element-wise.
  Function `f` is called exactly once for each element of passed vectors (as opposed to `map`
  which assumes for some types of source vectors (e.g. `SparseVector`) that the
  wrapped function is pure, and may call the function `f` only once for multiple
  equal values.
- A `Tables.ColumnTable` holding 1-based columns of equal length: In this case the function
  `f` is passed a `NamedTuple` created for each row of passed table.

The return value of `ByRow(f)` is always a vector.

`ByRow` expects that at least one argument is passed to it and in the case of
`Tables.ColumnTable` passed that the table has at least one column. In some
contexts of operations on tables (for example `DataFrame`) the user might want
to pass no arguments (or an empty `Tables.ColumnTable`) to `ByRow`. This case
must be separately handled by the code implementing the logic of processing the
`ByRow` operation on this specific parent table (the reason is that passing such
arguments to `ByRow` does not allow it to determine the number of rows of the
source table).

# Examples
```jldoctest
julia> Tables.ByRow(x -> x^2)(1:3)
3-element Vector{Int64}:
 1
 4
 9

julia> Tables.ByRow((x, y) -> x*y)(1:3, 2:4)
3-element Vector{Int64}:
  2
  6
 12

julia> Tables.ByRow(x -> x.a)((a=1:2, b=3:4))
2-element Vector{Int64}:
 1
 2

julia> Tables.ByRow(x -> (a=x.a*2, b=sin(x.b), c=x.c))((a=[1, 2, 3],
                                                        b=[1.2, 3.4, 5.6],
                                                        c=["a", "b", "c"]))
3-element Vector{@NamedTuple{a::Int64, b::Float64, c::String}}:
 (a = 2, b = 0.9320390859672263, c = "a")
 (a = 4, b = -0.2555411020268312, c = "b")
 (a = 6, b = -0.6312666378723216, c = "c")
```
"""
struct ByRow{T} <: Function
    fun::T
end

# invoke the generic AbstractVector function to ensure function is called
# exactly once for each element
function (f::ByRow)(cols::AbstractVector...)
    if !(all(col -> ==(length(first(cols)))(length(col)) && firstindex(col) == 1, cols))
        throw(ArgumentError("All passed vectors must have the same length and use 1-based indexing"))
    end
    return invoke(map,
                  Tuple{typeof(f.fun), ntuple(i -> AbstractVector, length(cols))...},
                  f.fun, cols...)
end

function (f::ByRow)(table::ColumnTable)
    if !(all(col -> ==(length(first(table)))(length(col)) && firstindex(col) == 1, table))
        throw(ArgumentError("All passed vectors must have the same length and use 1-based indexing"))
    end
    return [f.fun(nt) for nt in Tables.namedtupleiterator(table)]
end

(f::ByRow)() = throw(ArgumentError("no arguments passed"))
(f::ByRow)(::NamedTuple{(), Tuple{}}) =
    throw(ArgumentError("no columns passed in Tables.ColumnTable"))

Base.@pure function nondatavaluenamedtuple(::Type{NT}) where {names, NT <: NamedTuple{names}}
    TT = Tuple{Any[ DataValueInterfaces.nondatavaluetype(fieldtype(NT, i)) for i = 1:fieldcount(NT) ]...}
    return NamedTuple{names, TT}
end

Base.@pure function datavaluenamedtuple(::Tables.Schema{names, types}) where {names, types}
    TT = Tuple{Any[ DataValueInterfaces.datavaluetype(fieldtype(types, i)) for i = 1:fieldcount(types) ]...}
    return NamedTuple{names, TT}
end

# IteratorWrapper takes an input Row iterators, it will unwrap any DataValue elements as plain Union{T, Missing}
struct IteratorWrapper{S}
    x::S
end

"""
    Tables.nondatavaluerows(x)

Takes any Queryverse-compatible `NamedTuple` iterator source and 
converts to a Tables.jl-compatible `AbstractRow` iterator. Will automatically
unwrap any `DataValue`s, replacing `NA` with `missing`.
Useful for translating Query.jl results back to non-`DataValue`-based tables.
"""
nondatavaluerows(x) = IteratorWrapper(IteratorInterfaceExtensions.getiterator(x))
Tables.istable(::Type{<:IteratorWrapper}) = true
Tables.rowaccess(::Type{<:IteratorWrapper}) = true
Tables.rows(x::IteratorWrapper) = x

function Tables.schema(dv::IteratorWrapper{S}) where {S}
    eT = eltype(dv.x)
    (!(eT <: NamedTuple) || eT === Union{}) && return schema(dv.x)
    return Tables.Schema(nondatavaluenamedtuple(eT))
end

Base.IteratorEltype(::Type{I}) where {S, I<:IteratorWrapper{S}} = Base.IteratorEltype(S)
Base.eltype(::Type{I}) where {S, I<:IteratorWrapper{S}} = IteratorRow{eltype(S)}
Base.IteratorSize(::Type{I}) where {S, I<:IteratorWrapper{S}} = Base.IteratorSize(S)
Base.length(rows::IteratorWrapper) = length(rows.x)
Base.size(rows::IteratorWrapper) = size(rows.x)

@noinline invalidtable(::T, ::S) where {T, S} = throw(ArgumentError("'$T' iterates '$S' values, which doesn't satisfy the Tables.jl `AbstractRow` interface"))

@inline function Base.iterate(rows::IteratorWrapper)
    x = iterate(rows.x)
    x === nothing && return nothing
    row, st = x
    columnnames(row) === () && invalidtable(rows.x, row)
    return IteratorRow(row), st
end

@inline function Base.iterate(rows::IteratorWrapper, st)
    x = iterate(rows.x, st)
    x === nothing && return nothing
    row, st = x
    return IteratorRow(row), st
end

struct IteratorRow{T} <: AbstractRow
    row::T
end

getrow(r::IteratorRow) = getfield(r, :row)
wrappedtype(::Type{I}) where {T, I<:IteratorRow{T}} = T
wrappedtype(::Type{T}) where {T} = T

unwrap(::Type{T}, x) where {T} = convert(T, x)
unwrap(::Type{Any}, x) = x.hasvalue ? x.value : missing

nondv(T) = DataValueInterfaces.nondatavaluetype(T)
undatavalue(x::T) where {T} = T == nondv(T) ? x : unwrap(nondv(T), x)

@inline getcolumn(r::IteratorRow, ::Type{T}, col::Int, nm::Symbol) where {T} = undatavalue(getcolumn(getrow(r), T, col, nm))
@inline getcolumn(r::IteratorRow, nm::Symbol) = undatavalue(getcolumn(getrow(r), nm))
@inline getcolumn(r::IteratorRow, i::Int) = undatavalue(getcolumn(getrow(r), i))
columnnames(r::IteratorRow) = columnnames(getrow(r))

# DataValueRowIterator wraps a Row iterator and will wrap `Union{T, Missing}` typed fields in DataValues
struct DataValueRowIterator{NT, sch, S}
    x::S
end

"""
    Tables.datavaluerows(x) => NamedTuple iterator

Takes any table input `x` and returns a `NamedTuple` iterator
that will replace missing values with `DataValue`-wrapped values;
this allows any table type to satisfy the TableTraits.jl 
Queryverse integration interface by defining: 

```
IteratorInterfaceExtensions.getiterator(x::MyTable) = Tables.datavaluerows(x)
```
"""
function datavaluerows(x)
    r = Tables.rows(x)
    s = Tables.schema(r)
    s === nothing && error("Schemaless sources cannot be passed to datavaluerows.")
    return DataValueRowIterator{datavaluenamedtuple(s), typeof(s), typeof(r)}(r)
end

Base.eltype(::Type{D}) where {NT, D<:DataValueRowIterator{NT}} = NT
Base.IteratorSize(::Type{D}) where {NT, sch, S, D<:DataValueRowIterator{NT, sch, S}} = Base.IteratorSize(S)
Base.length(rows::DataValueRowIterator) = length(rows.x)
Base.size(rows::DataValueRowIterator) = size(rows.x)

function Base.iterate(rows::DataValueRowIterator{NamedTuple{names, dtypes}, Schema{names, rtypes}, S}, st=()) where {names, dtypes, rtypes, S}
    # use of @generated justified here because Queryverse has stated only support for "reasonable amount of columns"
    if @generated
        vals = Any[ :(convert($(fieldtype(dtypes, i)), getcolumn(row, $(fieldtype(rtypes, i)), $i, $(Meta.QuoteNode(names[i]))))) for i = 1:length(names) ]
        ret = Expr(:new, :(NamedTuple{names, dtypes}), vals...)
        q = quote
            x = iterate(rows.x, st...)
            x === nothing && return nothing
            row, st = x
            return $ret, (st,)
        end
        # @show q
        return q
    else
        x = iterate(rows.x, st...)
        x === nothing && return nothing
        row, st = x
        return NamedTuple{names, dtypes}(Tuple(convert(fieldtype(dtypes, i), getcolumn(row, fieldtype(rtypes, i), i, names[i])) for i = 1:length(names))), (st,)
    end
end

module Tables

using DataValueInterfaces, DataAPI, TableTraits, IteratorInterfaceExtensions, OrderedCollections

export rowtable, columntable

if !hasmethod(getproperty, Tuple{Tuple, Int})
    Base.getproperty(t::Tuple, i::Int) = t[i]
end

import Base: ==

"""
    Tables.AbstractColumns

An interface type defined as an ordered set of columns that support
retrieval of individual columns by name or index. A retrieved column
must be a 1-based indexable collection with known length, i.e. an object
that supports `length(col)` and `col[i]` for any `i = 1:length(col)`.
`Tables.columns` must return an object that satisfies the `Tables.AbstractColumns` interface.
While `Tables.AbstractColumns` is an abstract type that custom "columns" types may subtype for
useful default behavior (indexing, iteration, property-access, etc.), users should not use it
for dispatch, as Tables.jl interface objects **are not required** to subtype, but only
implement the required interface methods.

Interface definition:

| Required Methods                                         | Default Definition            | Brief Description                                                                                                                                            |
|----------------------------------------------------------|-------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `Tables.getcolumn(table, i::Int)`                        | `getfield(table, i)`          | Retrieve a column by index                                                                                                                                   |
| `Tables.getcolumn(table, nm::Symbol)`                    | `getproperty(table, nm)`      | Retrieve a column by name                                                                                                                                    |
| `Tables.columnnames(table)`                              | `propertynames(table)`        | Return column names for a table as a 1-based indexable collection                                                                                                   |
| **Optional methods**                                     |                               |                                                                                                                                                              |
| `Tables.getcolumn(table, ::Type{T}, i::Int, nm::Symbol)` | `Tables.getcolumn(table, nm)` | Given a column eltype `T`, index `i`, and column name `nm`, retrieve the column. Provides a type-stable or even constant-prop-able mechanism for efficiency. |

Note that subtypes of `Tables.AbstractColumns` **must** overload all required methods listed
above instead of relying on these methods' default definitions.

While types aren't required to subtype `Tables.AbstractColumns`, benefits of doing so include:
  * Indexing interface defined (using `getcolumn`); i.e. `tbl[i]` will retrieve the column at index `i`
  * Property access interface defined (using `columnnames` and `getcolumn`); i.e. `tbl.col1` will retrieve column named `col1`
  * Iteration interface defined; i.e. `for col in table` will iterate each column in the table
  * `AbstractDict` methods defined (`get`, `haskey`, etc.) for checking and retrieving columns
  * A default `show` method
This allows a custom table type to behave as close as possible to a builtin `NamedTuple` of vectors object.
"""
abstract type AbstractColumns end

"""
    Tables.AbstractRow

Abstract interface type representing the expected `eltype` of the iterator returned from `Tables.rows(table)`.
`Tables.rows` must return an iterator of elements that satisfy the `Tables.AbstractRow` interface.
While `Tables.AbstractRow` is an abstract type that custom "row" types may subtype for
useful default behavior (indexing, iteration, property-access, etc.), users should not use it
for dispatch, as Tables.jl interface objects **are not required** to subtype, but only
implement the required interface methods.

Interface definition:

| Required Methods                                       | Default Definition          | Brief Description                                                                                                                                                |
|--------------------------------------------------------|-----------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `Tables.getcolumn(row, i::Int)`                        | `getfield(row, i)`          | Retrieve a column value by index                                                                                                                                 |
| `Tables.getcolumn(row, nm::Symbol)`                    | `getproperty(row, nm)`      | Retrieve a column value by name                                                                                                                                  |
| `Tables.columnnames(row)`                              | `propertynames(row)`        | Return column names for a row as a 1-based indexable collection                                                                                                         |
| **Optional methods**                                   |                             |                                                                                                                                                                  |
| `Tables.getcolumn(row, ::Type{T}, i::Int, nm::Symbol)` | `Tables.getcolumn(row, nm)` | Given a column element type `T`, index `i`, and column name `nm`, retrieve the column value. Provides a type-stable or even constant-prop-able mechanism for efficiency. |

Note that subtypes of `Tables.AbstractRow` **must** overload all required methods listed above
instead of relying on these methods' default definitions.

While custom row types aren't required to subtype `Tables.AbstractRow`, benefits of doing so include:
  * Indexing interface defined (using `getcolumn`); i.e. `row[i]` will return the column value at index `i`
  * Property access interface defined (using `columnnames` and `getcolumn`); i.e. `row.col1` will retrieve the value for the column named `col1`
  * Iteration interface defined; i.e. `for x in row` will iterate each column value in the row
  * `AbstractDict` methods defined (`get`, `haskey`, etc.) for checking and retrieving column values
  * A default `show` method
This allows the custom row type to behave as close as possible to a builtin `NamedTuple` object.
"""
abstract type AbstractRow end

"""
    Tables.getcolumn(::AbstractColumns, nm::Symbol) => Indexable collection with known length
    Tables.getcolumn(::AbstractColumns, i::Int) => Indexable collection with known length
    Tables.getcolumn(::AbstractColumns, T, i::Int, nm::Symbol) => Indexable collection with known length

    Tables.getcolumn(::AbstractRow, nm::Symbol) => Column value
    Tables.getcolumn(::AbstractRow, i::Int) => Column value
    Tables.getcolumn(::AbstractRow, T, i::Int, nm::Symbol) => Column value

Retrieve an entire column (from `AbstractColumns`) or single row column value (from an `AbstractRow`) by column name (`nm`), index (`i`),
or if desired, by column element type (`T`), index (`i`), and name (`nm`). When called on a `AbstractColumns` interface object,
the returned object should be a 1-based indexable collection with known length. When called on a `AbstractRow` interface
object, it returns the single column value. The methods taking a single `Symbol` or `Int` are both required
for the `AbstractColumns` and `AbstractRow` interfaces; the third method is optional if type stability is possible.
The default definition of `Tables.getcolumn(x, i::Int)` is `getfield(x, i)`. The default definition of
`Tables.getcolumn(x, nm::Symbol)` is `getproperty(x, nm)`.
"""
function getcolumn end

getcolumn(x, i::Int) = getfield(x, i)
getcolumn(x, nm::Symbol) = getproperty(x, nm)
getcolumn(x, ::Type{T}, i::Int, nm::Symbol) where {T} = getcolumn(x, nm)
getcolumn(x::NamedTuple{names, types}, ::Type{T}, i::Int, nm::Symbol) where {names, types, T} = Core.getfield(x, i)

"""
    Tables.columnnames(::Union{AbstractColumns, AbstractRow}) => Indexable collection

Retrieves the list of column names as a 1-based indexable collection (like a `Tuple` or `Vector`)
for a `AbstractColumns` or `AbstractRow` interface object.
The default definition calls `propertynames(x)`.
The returned column names must be unique.
"""
function columnnames end

columnnames(x) = propertynames(x)

"""
    Tables.isrowtable(x) => Bool

For convenience, some table objects that are naturally "row oriented" can
define `Tables.isrowtable(::Type{TableType}) = true` to simplify satisfying the
Tables.jl interface. Requirements for defining `isrowtable` include:
  * `Tables.rows(x) === x`, i.e. the table object itself is a `Row` iterator
  * If the table object is mutable, it should support:
    * `push!(x, row)`: allow pushing a single row onto table
    * `append!(x, rows)`: allow appending set of rows onto table
  * If table object is mutable and indexable, it should support:
    * `x[i] = row`: allow replacing of a row with another row by index

A table object that defines `Tables.isrowtable` will have definitions for
`Tables.istable`, `Tables.rowaccess`, and `Tables.rows` automatically defined.
"""
function isrowtable end

isrowtable(::T) where {T} = isrowtable(T)
isrowtable(::Type{T}) where {T} = false
# to avoid ambiguities
isrowtable(::Type{T}) where {T <: AbstractVector{Union{}}} = false

# default definitions for AbstractDict to act as an AbstractColumns or AbstractRow
getcolumn(x::AbstractDict{Symbol}, i::Int) = x[columnnames(x)[i]]
getcolumn(x::AbstractDict{Symbol}, nm::Symbol) = x[nm]
getcolumn(x::AbstractDict{Symbol}, ::Type{T}, i::Int, nm::Symbol) where {T} = x[nm]
columnnames(x::AbstractDict{Symbol}) = collect(keys(x))

getcolumn(x::AbstractDict{<:AbstractString}, i::Int) = x[String(columnnames(x)[i])]
getcolumn(x::AbstractDict{<:AbstractString}, nm::Symbol) = x[String(nm)]
getcolumn(x::AbstractDict{<:AbstractString}, ::Type{T}, i::Int, nm::Symbol) where {T} = x[String(nm)]
columnnames(x::AbstractDict{<:AbstractString}) = collect(Symbol(k) for k in keys(x))

# AbstractVector of Dicts for Tables.rows
const DictRows = AbstractVector{T} where {T <: Union{AbstractDict{<:AbstractString}, AbstractDict{Symbol}}}
isrowtable(::Type{<:DictRows}) = true
# DictRows doesn't naturally lend itself to the `Tables.schema` requirement
# we can't just look at the first row, because the types might change,
# row-to-row (e.g. `missing`, then `1.1`, etc.). Therefore, the safest option
# is to just return `nothing`
schema(x::DictRows) = nothing

# Dict of AbstractVectors for Tables.columns
const DictColumns = Union{<:AbstractDict{<:AbstractString, <:AbstractVector}, <:AbstractDict{Symbol, <:AbstractVector}}
istable(::Type{<:DictColumns}) = true
columnaccess(::Type{<:DictColumns}) = true
columns(x::DictColumns) = x
schema(x::DictColumns) = Schema(collect(keys(x)), eltype.(values(x)))

# for other AbstractDict, let's throw an informative error
columns(x::T) where {T <: AbstractDict} = error("to treat $T as a table, it must have a key type of `Symbol`, and a value type `<: AbstractVector`")

# default definitions for AbstractRow, AbstractColumns
const RorC = Union{AbstractRow, AbstractColumns}

# avoids mutual recursion with default definitions (issue #221)
getcolumn(::T, ::Int) where {T <: RorC} = error("`Tables.getcolumn` must be specifically overloaded for $T <: Union{AbstractRow, AbstractColumns}`")
getcolumn(::T, ::Symbol) where {T <: RorC} = error("`Tables.getcolumn` must be specifically overloaded for $T <: Union{AbstractRow, AbstractColumns}`")
columnnames(::T) where {T <: RorC} = error("`Tables.columnnames` must be specifically overloaded for $T <: Union{AbstractRow, AbstractColumns}`")

Base.IteratorSize(::Type{R}) where {R <: RorC} = Base.HasLength()
Base.length(r::RorC) = length(columnnames(r))
Base.IndexStyle(::Type{<:RorC}) = Base.IndexLinear()
Base.firstindex(r::RorC) = 1
Base.lastindex(r::RorC) = length(r)
Base.getindex(r::RorC, i::Int) = getcolumn(r, i)
Base.getindex(r::RorC, nm::Symbol) = getcolumn(r, nm)
Base.getproperty(r::RorC, nm::Symbol) = getcolumn(r, nm)
Base.getproperty(r::RorC, i::Int) = getcolumn(r, i)
Base.propertynames(r::RorC) = columnnames(r)
Base.keys(r::RorC) = columnnames(r)
Base.values(r::RorC) = collect(r)
Base.haskey(r::RorC, key::Symbol) = key in columnnames(r)
Base.haskey(r::RorC, i::Int) = 0 < i <= length(columnnames(r))
Base.get(r::RorC, key::Union{Integer, Symbol}, default) = haskey(r, key) ? getcolumn(r, key) : default
Base.get(f::Base.Callable, r::RorC, key::Union{Integer, Symbol}) = haskey(r, key) ? getcolumn(r, key) : f()
Base.iterate(r::RorC, i=1) = i > length(r) ? nothing : (getcolumn(r, i), i + 1)
Base.isempty(r::RorC) = length(r) == 0

function Base.NamedTuple(r::RorC)
    names = columnnames(r)
    return NamedTuple{Tuple(map(Symbol, names))}(Tuple(getcolumn(r, nm) for nm in names))
end

function Base.show(io::IO, x::T) where {T <: AbstractRow}
    if get(io, :compact, false) || get(io, :limit, false)
        get(io, :typeinfo, nothing) === nothing && print(io, "$T: ")
        show(io, NamedTuple(x))
    else
        # Assume we are called from within a container show method when typeinfo is set.
        get(io, :typeinfo, nothing) !== nothing && println(io)

        println(io, "$T:")
        names = collect(columnnames(x))
        values = [getcolumn(x, nm) for nm in names]
        Base.print_matrix(io, hcat(names, values))
    end
end

function Base.show(io::IO, table::AbstractColumns; max_cols = 20)
    ncols = length(columnnames(table))
    print(io, "$(typeof(table)) with $(rowcount(table)) rows, $(ncols) columns, and ")
    sch = schema(table)
    if sch !== nothing
        print(io, "schema:\n")
        show(IOContext(io, :print_schema_header => false), sch)
    else
        print(io, "an unknown schema.")
    end
end

# AbstractRow AbstractVector as Rows
const AbstractRowTable = AbstractVector{T} where {T <: AbstractRow}
isrowtable(::Type{<:AbstractRowTable}) = true
schema(x::AbstractRowTable) = nothing

# AbstractColumns as Columns
istable(::Type{<:AbstractColumns}) = true
columnaccess(::Type{<:AbstractColumns}) = true
columns(x::AbstractColumns) = x
schema(x::AbstractColumns) = nothing

"""
    Tables.Row(row)

Convenience type to wrap any `AbstractRow` interface object in a dedicated struct
to provide useful default behaviors (allows any `AbstractRow` to be used like a `NamedTuple`):
  * Indexing interface defined; i.e. `row[i]` will return the column value at index `i`, `row[nm]` will return column value for column name `nm`
  * Property access interface defined; i.e. `row.col1` will retrieve the value for the column named `col1`
  * Iteration interface defined; i.e. `for x in row` will iterate each column value in the row
  * `AbstractDict` methods defined (`get`, `haskey`, etc.) for checking and retrieving column values
"""
struct Row{T} <: AbstractRow
    x::T
end

Row(x::Row) = x

"""
    Tables.Columns(tbl)

Convenience type that calls `Tables.columns` on an input `tbl` and wraps the resulting `AbstractColumns` interface object in a dedicated struct
to provide useful default behaviors (allows any `AbstractColumns` to be used like a `NamedTuple` of `Vectors`):
  * Indexing interface defined; i.e. `row[i]` will return the column at index `i`, `row[nm]` will return column for column name `nm`
  * Property access interface defined; i.e. `row.col1` will retrieve the value for the column named `col1`
  * Iteration interface defined; i.e. `for x in row` will iterate each column in the row
  * `AbstractDict` methods defined (`get`, `haskey`, etc.) for checking and retrieving columns

Note that `Tables.Columns` calls `Tables.columns` internally on the provided table argument.
`Tables.Columns` can be used for dispatch if needed.
"""
struct Columns{T} <: AbstractColumns
    x::T

    function Columns(x)
        cols = columns(x)
        return new{typeof(cols)}(cols)
    end
end

Columns(x::Columns) = x

# Columns can only wrap something that is a table, so we pass the schema through
schema(x::Columns) = schema(getx(x))

const RorC2 = Union{Row, Columns}

getx(x::RorC2) = getfield(x, :x)

getcolumn(x::RorC2, i::Int) = getcolumn(getx(x), i)
getcolumn(x::RorC2, nm::Symbol) = getcolumn(getx(x), nm)
getcolumn(x::RorC2, ::Type{T}, i::Int, nm::Symbol) where {T} = getcolumn(getx(x), T, i, nm)
columnnames(x::RorC2) = columnnames(getx(x))

"""
    Tables.istable(x) => Bool

Check if an object has specifically defined that it is a table. Note that
not all valid tables will return true, since it's possible to satisfy the
Tables.jl interface at "run-time", e.g. a `Generator` of `NamedTuple`s iterates
`NamedTuple`s, which satisfies the `AbstractRow` interface, but there's no static way
of knowing that the generator is a table.

It is recommended that for users implementing `MyType`, they define only
`istable(::Type{MyType})`. `istable(::MyType)` will then automatically delegate to this
method.

`istable` calls `TableTraits.isiterabletable` as a fallback. This can have a considerable
runtime overhead in some contexts. To avoid these and use `istable` as a compile-time trait,
it can be called on a type as `istable(typeof(obj))`.
"""
function istable end

istable(x::T) where {T} = istable(T) || TableTraits.isiterabletable(x) === true
istable(::Type{T}) where {T} = isrowtable(T)
# to avoid ambiguities
istable(::Type{T}) where {T <: AbstractVector{Union{}}} = false
istable(::AbstractVector{Union{}}) = false

"""
    Tables.rowaccess(x) => Bool

Check whether an object has specifically defined that it implements the `Tables.rows`
function that does _not_ copy table data.  That is to say, `Tables.rows(x)` must be done
with O(1) time and space complexity when `Tables.rowaccess(x) == true`.  Note that
`Tables.rows` will work on any object that iterates `AbstractRow`-compatible objects, even if
they don't define `rowaccess`, e.g. a `Generator` of `NamedTuple`s.  However, this
generic fallback may copy the data from input table `x`.  Also note that just because
an object defines `rowaccess` doesn't mean a user should call `Tables.rows` on it;
`Tables.columns` will also work, providing a valid `AbstractColumns` object from the rows.
Hence, users should call `Tables.rows` or `Tables.columns` depending on what is most
natural for them to *consume* instead of worrying about what and how the input is oriented.

It is recommended that for users implementing `MyType`, they define only
`rowaccess(::Type{MyType})`. `rowaccess(::MyType)` will then automatically delegate to this
method.
"""
function rowaccess end

rowaccess(x::T) where {T} = rowaccess(T)
rowaccess(::Type{T}) where {T} = isrowtable(T)

"""
    Tables.columnaccess(x) => Bool

Check whether an object has specifically defined that it implements the `Tables.columns`
function that does _not_ copy table data.  That is to say, `Tables.columns(x)` must be done
with O(1) time and space complexity when `Tables.columnaccess(x) == true`.  Note that
`Tables.columns` has generic fallbacks allowing it to produces `AbstractColumns` objects, even if
the input doesn't define `columnaccess`.  However, this generic fallback may copy the data
from input table `x`.  Also note that just because an object defines `columnaccess` doesn't
mean a user should call `Tables.columns` on it; `Tables.rows` will also work, providing a
valid `AbstractRow` iterator. Hence, users should call `Tables.rows` or `Tables.columns` depending
on what is most natural for them to *consume* instead of worrying about what and how the
input is oriented.

It is recommended that for users implementing `MyType`, they define only
`columnaccess(::Type{MyType})`. `columnaccess(::MyType)` will then automatically delegate to
this method.
"""
function columnaccess end

columnaccess(x::T) where {T} = columnaccess(T)
columnaccess(::Type{T}) where {T} = false

"""
    Tables.schema(x) => Union{Nothing, Tables.Schema}

Attempt to retrieve the schema of the object returned by `Tables.rows` or `Tables.columns`.
If the `AbstractRow` iterator or `AbstractColumns` object can't determine its schema, `nothing` will be returned.
Otherwise, a `Tables.Schema` object is returned, with the column names and types available for use.
"""
function schema end

schema(x) = nothing

"""
    Tables.materializer(x) => Callable

For a table input, return the "sink" function or "materializing" function that can take a
Tables.jl-compatible table input and make an instance of the table type. This enables "transform"
workflows that take table inputs, apply transformations, potentially converting the table to
a different form, and end with producing a table of the same type as the original input. The
default materializer is `Tables.columntable`, which converts any table input into a `NamedTuple`
of `Vector`s.

It is recommended that for users implementing `MyType`, they define only
`materializer(::Type{<:MyType})`. `materializer(::MyType)` will then automatically delegate to
this method.
"""
function materializer end

materializer(x::T) where {T} = materializer(T)
materializer(::Type{T}) where {T} = columntable

"""
    Tables.columns(x) => AbstractColumns-compatible object

Accesses data of input table source `x` by returning an [`AbstractColumns`](@ref)-compatible
object, which allows retrieving entire columns by name or index. A retrieved column
is a 1-based indexable object that has a known length, i.e. supports
`length(col)` and `col[i]` for any `i = 1:length(col)`. Note that
even if the input table source is row-oriented by nature, an efficient generic
definition of `Tables.columns` is defined in Tables.jl to build a `AbstractColumns`-
compatible object object from the input rows.

The [`Tables.Schema`](@ref) of a `AbstractColumns` object can be queried via `Tables.schema(columns)`,
which may return `nothing` if the schema is unknown.
Column names can always be queried by calling `Tables.columnnames(columns)`, and individual columns
can be accessed by calling `Tables.getcolumn(columns, i::Int )` or `Tables.getcolumn(columns, nm::Symbol)`
with a column index or name, respectively.

Note that if `x` is an object in which columns are stored as vectors, the check that
these vectors use 1-based indexing is not performed (it should be ensured when `x` is constructed).
"""
function columns end

"""
    Tables.rows(x) => Row iterator

Accesses data of input table source `x` row-by-row by returning an [`AbstractRow`](@ref)-compatible iterator.
Note that even if the input table source is column-oriented by nature, an efficient generic
definition of `Tables.rows` is defined in Tables.jl to return an iterator of row views into
the columns of the input.

The [`Tables.Schema`](@ref) of an `AbstractRow` iterator can be queried via `Tables.schema(rows)`,
which may return `nothing` if the schema is unknown.
Column names can always be queried by calling `Tables.columnnames(row)` on an individual row,
and row values can be accessed by calling `Tables.getcolumn(row, i::Int )` or
`Tables.getcolumn(row, nm::Symbol)` with a column index or name, respectively.

See also [`rowtable`](@ref) and [`namedtupleiterator`](@ref).
"""
function rows end

# Schema implementation
"""
    Tables.Schema(names, types)

Create a `Tables.Schema` object that holds the column names and types for an `AbstractRow` iterator
returned from `Tables.rows` or an `AbstractColumns` object returned from `Tables.columns`.
`Tables.Schema` is dual-purposed: provide an easy interface for users to query these properties,
as well as provide a convenient "structural" type for code generation.

To get a table's schema, one can call `Tables.schema` on the result of `Tables.rows` or `Tables.columns`,
but also note that a table may return `nothing`, indicating that its column names and/or column element types
are unknown (usually not inferable). This is similar to the `Base.EltypeUnknown()` trait for iterators
when `Base.IteratorEltype` is called. Users should account for the `Tables.schema(tbl) => nothing` case
by using the properties of the results of `Tables.rows(x)` and `Tables.columns(x)` directly.

To access the names, one can simply call `sch.names` to return a collection of Symbols (`Tuple` or `Vector`).
To access column element types, one can similarly call `sch.types`, which will return a collection of types (like `(Int64, Float64, String)`).

The actual type definition is
```julia
struct Schema{names, types}
    storednames::Union{Nothing, Vector{Symbol}}
    storedtypes::Union{Nothing, Vector{Type}}
end
```
Where `names` is a tuple of `Symbol`s or `nothing`, and `types` is a tuple _type_ of types (like `Tuple{Int64, Float64, String}`) or `nothing`.
Encoding the names & types as type parameters allows convenient use of the type in generated functions
and other optimization use-cases, but users should note that when `names` and/or `types` are the `nothing` value, the names and/or types
are stored in the `storednames` and `storedtypes` fields. This is to account for extremely wide tables with columns in the 10s of thousands
where encoding the names/types as type parameters becomes prohibitive to the compiler. So while optimizations can be written on the typed
`names`/`types` type parameters, users should also consider handling the extremely wide tables by specializing on `Tables.Schema{nothing, nothing}`.
"""
struct Schema{names, types}
    storednames::Union{Nothing, Vector{Symbol}}
    storedtypes::Union{Nothing, Vector{Type}}
end

Schema{names, types}() where {names, types} = Schema{names, types}(nothing, nothing)
Schema(names::Tuple{Vararg{Symbol}}, ::Type{T}) where {T <: Tuple} = Schema{names, T}()
Schema(::Type{NamedTuple{names, types}}) where {names, types} = Schema{names, types}()

# whether names/types are stored or not
stored(::Schema{names, types}) where {names, types} = names === nothing && types === nothing
stored(::Nothing) = false

# pass through Ints to allow Tuples to act as rows
sym(x) = Symbol(x)
sym(x::Int) = x

Schema(names, ::Nothing) = Schema{Tuple(map(sym, names)), nothing}()

const SCHEMA_SPECIALIZATION_THRESHOLD = (2^16) - 1

function Schema(names, types; stored::Bool=false)
    if stored || length(names) > SCHEMA_SPECIALIZATION_THRESHOLD
        return Schema{nothing, nothing}([sym(x) for x in names], Type[T for T in types])
    else
        return Schema{Tuple(map(sym, names)), Tuple{types...}}()
    end
end

function Base.show(io::IO, sch::Schema)
    get(io, :print_schema_header, true) && println(io, "Tables.Schema:")
    nms = sch.names
    Base.print_matrix(io, hcat(nms isa Vector ? nms : collect(nms), sch.types === nothing ? fill(nothing, length(nms)) : collect(sch.types)))
end

function Base.getproperty(sch::Schema{names, types}, field::Symbol) where {names, types}
    if field === :names
        return names === nothing ? getfield(sch, :storednames) : names
    elseif field === :types
        if types === nothing
            return getfield(sch, :storedtypes)
        else
            ncol = fieldcount(types)
            if ncol <= 512
                # Type stable, but slower to compile
                return ntuple(i -> fieldtype(types, i), Val(ncol))
            else
                return Tuple(fieldtype(types, i) for i=1:ncol)
            end
        end
    else
        throw(ArgumentError("unsupported property for Tables.Schema"))
    end
end

Base.propertynames(::Schema) = (:names, :types)
==(a::Schema, b::Schema) = a.names == b.names && a.types == b.types

# partitions

"""
    Tables.partitions(x)

Request a "table" iterator from `x`. Each iterated element must be a "table" in the sense
that one may call `Tables.rows` or `Tables.columns` to get a row-iterator or collection
of columns. All iterated elements _must_ have identical schema, so that users may call
`Tables.schema(first_element)` on the first iterated element and know that each
subsequent iteration will match the same schema. The default definition is:
```julia
Tables.partitions(x) = (x,)
```
So that any input is assumed to be a single "table". This means users should feel free
to call `Tables.partitions` anywhere they're currently calling `Tables.columns` or
`Tables.rows`, and get back an iterator of those instead. In other words, "sink" functions
can use `Tables.partitions` whether or not the user passes a partionable table, since the
default is to treat a single input as a single, non-partitioned table.

[`Tables.partitioner(itr)`](@ref) is a convenience wrapper to provide table partitions
from any table iterator; this allows for easy wrapping of a `Vector` or iterator of tables
as valid partitions, since by default, they'd be treated as a single table.

A 2nd convenience method is provided with the definition:
```julia
Tables.partitions(x...) = x
```
That allows passing vararg tables and they'll be treated as separate partitions. Sink
functions may allow vararg table inputs and can "splat them through" to `partitions`.

For convenience, `Tables.partitions(x::Iterators.PartitionIterator) = x` and
`Tables.partitions(x::Tables.Partitioner) = x` are defined to handle cases
where user created partitioning with the `Iterators.partition` or
[`Tables.partitioner`](@ref) functions.
"""
partitions(x) = (x,)
partitions(x...) = x
partitions(x::Iterators.PartitionIterator) = x

"""
    Tables.LazyTable(f, arg)

A "table" type that delays materialization until `Tables.columns` or `Tables.rows` is called.
This allows, for example, sending a `LazyTable` to a remote process or thread which can
then call `Tables.columns` or `Tables.rows` to "materialize" the table. Is used by default
in `Tables.partitioner(f, itr)` where a materializer function `f` is passed to each element
of an iterable `itr`, allowing distributed/concurrent patterns like:

```julia
for tbl in Tables.partitions(Tables.partitioner(CSV.File, list_of_csv_files))
    Threads.@spawn begin
        cols = Tables.columns(tbl)
        # do stuff with cols
    end
end
```
In this example, `CSV.File` will be called like `CSV.File(x)` for each element of the
`list_of_csv_files` iterable, but _not until_ `Tables.columns(tbl)` is called, which
in this case happens in a thread-spawned task, allowing files to be parsed and processed
in parallel.
"""
struct LazyTable{F, T}
    f::F
    x::T
end

columns(x::LazyTable) = columns(x.f(x.x))
rows(x::LazyTable) = rows(x.f(x.x))

struct Partitioner{T}
    x::T
end

"""
    Tables.subset(x, inds; viewhint=nothing)

Return one or more rows from table `x` according to the position(s) specified by `inds`:

- If `inds` is a single non-boolean integer return a row object.
- If `inds` is a vector of non-boolean integers, a vector of booleans, or a `:`, return a subset of the original table according to the indices.
  In this case, the returned type is not necessarily the same as the original table type.

If other types of `inds` are passed than specified above the behavior is undefined.

The `viewhint` argument tries to influence whether the returned object is a view of the original table
or an independent copy:

- If `viewhint=nothing` (the default) then the implementation for a specific table type
  is free to decide  whether to return a copy or a view.
- If `viewhint=true` then a view is returned and if `viewhint=false` a copy is returned.
  This applies both to returning a row or a table.

Any specialized implementation of `subset` must support the `viewhint=nothing` argument.
Support for `viewhint=true` or `viewhint=false` is optional
(i.e. implementations may ignore the keyword argument and return a view or a copy regardless of `viewhint` value).
"""
function subset(x::T, inds; viewhint::Union{Bool, Nothing}=nothing, view::Union{Bool, Nothing}=nothing) where {T}
    if view !== nothing
        @warn "`view` keyword argument is deprecated for `Tables.subset`, use `viewhint` instead"
        viewhint = view
    end
    # because this method is being called, we know `x` didn't define it's own Tables.subset
    # first check if it supports column access, and if so, apply inds and wrap columns in a DictColumnTable
    if columnaccess(x)
        cols = columns(x)
        if inds isa Integer
            return ColumnsRow(cols, inds)
        else
            ret = viewhint === true ? _map(c -> Base.view(c, inds), cols) : _map(c -> c[inds], cols)
            return DictColumnTable(schema(cols), ret)
        end
    end
    # otherwise, let's get the rows and see if we can apply inds to them
    r = rows(x)
    if r isa AbstractVector
        inds isa Integer && return r[inds]
        ret = viewhint === true ? Base.view(x, inds) : x[inds]
        (ret isa AbstractVector) || throw(ArgumentError("`Tables.subset`: invalid `inds` argument, expected `AbstractVector` output, got $(typeof(ret))"))
        return ret
    end
    throw(ArgumentError("no default `Tables.subset` implementation for type: $T"))
end

vectorcheck(x::AbstractVector) = x
vectorcheck(x) = throw(ArgumentError("`Tables.subset`: invalid `inds` argument, expected `AbstractVector` output, got $(typeof(x))"))
_map(f, cols) = OrderedDict(nm => vectorcheck(f(getcolumn(cols, nm))) for nm in columnnames(cols))


"""
    Tables.partitioner(f, itr)
    Tables.partitioner(x)

Convenience methods to generate table iterators. The first method takes a "materializer"
function `f` and an iterator `itr`, and will call `Tables.LazyTable(f, x) for x in itr`
for each iteration. This allows delaying table materialization until `Tables.columns`
or `Tables.rows` are called on the `LazyTable` object (which will call `f(x)`). This
allows a common desired pattern of materializing and processing a table on a remote
process or thread, like:

```julia
for tbl in Tables.partitions(Tables.partitioner(CSV.File, list_of_csv_files))
    Threads.@spawn begin
        cols = Tables.columns(tbl)
        # do stuff with cols
    end
end
```

The second method is provided because the default behavior of `Tables.partition(x)`
is to treat `x` as a single, non-partitioned table. This method allows users to easily
wrap a `Vector` or generator of tables as table partitions to pass to sink functions
able to utilize `Tables.partitions`.
"""
partitioner(x) = Partitioner(x)
partitioner(f, itr) = partitioner((LazyTable(f, x) for x in itr))

partitions(x::Partitioner) = x

Base.IteratorEltype(::Type{P}) where {S,P<:Partitioner{S}} = Base.IteratorEltype(S)
Base.eltype(::Type{P}) where {S,P<:Partitioner{S}} = eltype(S)
Base.IteratorSize(::Type{P}) where {S,P<:Partitioner{S}} = Base.IteratorSize(S)
Base.length(x::Partitioner) = length(x.x)
Base.size(x::Partitioner) = size(x.x)
Base.iterate(x::Partitioner, st...) = iterate(x.x, st...)

const SPECIALIZATION_THRESHOLD = 100

# reference implementations: Vector of NamedTuples and NamedTuple of Vectors
include("namedtuples.jl")

# helper functions
include("utils.jl")

# generic fallback definitions
include("fallbacks.jl")

# allow any valid iterator to be a table
include("tofromdatavalues.jl")

# matrix integration
include("matrix.jl")

# dict tables
include("dicts.jl")

include("scan.jl")

"""
    Tables.columnindex(table, name::Symbol)

Return the column index (1-based) of a column by `name` in a table with a known schema; returns 0 if `name` doesn't exist in table
"""
columnindex(table, colname::Symbol) = columnindex(schema(table), colname)

"""
    Tables.columntype(table, name::Symbol)

Return the column element type of a column by `name` in a table with a known schema; returns Union{} if `name` doesn't exist in table
"""
columntype(table, colname::Symbol) = columntype(schema(table), colname)

Base.@pure columnindex(::Schema{names, types}, name::Symbol) where {names, types} = columnindex(names, name)

"given names and a Symbol `name`, compute the index (1-based) of the name in names"
Base.@pure function columnindex(names::Tuple{Vararg{Symbol}}, name::Symbol)
    i = 1
    for nm in names
        nm === name && return i
        i += 1
    end
    return 0
end

Base.@pure columntype(::Schema{names, types}, name::Symbol) where {names, types} = columntype(names, types, name)

"given tuple type and a Symbol `name`, compute the type of the name in the tuples types"
Base.@pure function columntype(names::Tuple{Vararg{Symbol}}, ::Type{types}, name::Symbol) where {types <: Tuple}
    i = 1
    for nm in names
        nm === name && return fieldtype(types, i)
        i += 1
    end
    return Union{}
end

end # module

## generic `Tables.rows` and `Tables.columns` fallbacks
## if a table provides Tables.rows or Tables.columns,
## we'll provide a default implementation of the other

# Turn any AbstractColumns into an AbstractRow iterator

# get the number of rows in the incoming table
function rowcount(cols)
    names = columnnames(cols)
    isempty(names) && return 0
    return length(getcolumn(cols, names[1]))
end

# a lazy row view into a AbstractColumns object
struct ColumnsRow{T} <: AbstractRow
    columns::T # an `AbstractColumns`-compatible object
    row::Int # row number
end

getcolumns(c::ColumnsRow) = getfield(c, :columns)
getrow(c::ColumnsRow) = getfield(c, :row)

# AbstractRow interface
Base.@propagate_inbounds getcolumn(c::ColumnsRow, ::Type{T}, col::Int, nm::Symbol) where {T} = getcolumn(getcolumns(c), T, col, nm)[getrow(c)]
Base.@propagate_inbounds getcolumn(c::ColumnsRow, i::Int) = getcolumn(getcolumns(c), i)[getrow(c)]
Base.@propagate_inbounds getcolumn(c::ColumnsRow, nm::Symbol) = getcolumn(getcolumns(c), nm)[getrow(c)]
columnnames(c::ColumnsRow) = columnnames(getcolumns(c))

@generated function Base.isless(c::ColumnsRow{T}, d::ColumnsRow{T}) where {names, T <: NamedTuple{names}}
    exprs = Expr[]
    for n in names
        var1 = Expr(:., :c, QuoteNode(n))
        var2 = Expr(:., :d, QuoteNode(n))
        bl = quote
            a, b = $var1, $var2
            isless(a, b) && return true
            isequal(a, b) || return false
        end
        push!(exprs, bl)
    end
    push!(exprs, :(return false))
    Expr(:block, exprs...)
end

@generated function Base.isequal(c::ColumnsRow{T}, d::ColumnsRow{T}) where {names, T <: NamedTuple{names}}
    exprs = Expr[]
    for n in names
        var1 = Expr(:., :c, QuoteNode(n))
        var2 = Expr(:., :d, QuoteNode(n))
        push!(exprs, :(isequal($var1, $var2) || return false))
    end
    push!(exprs, :(return true))
    Expr(:block, exprs...)
end

# RowIterator wraps an AbstractColumns object and provides row iteration via lazy row views
struct RowIterator{T}
    columns::T
    len::Int
end

Base.eltype(::Type{R}) where {T,R<:RowIterator{T}} = ColumnsRow{T}
Base.length(x::RowIterator) = getfield(x, :len)
Base.getproperty(x::RowIterator, nm::Symbol) = getcolumn(x, nm)
Base.getproperty(x::RowIterator, i::Int) = getcolumn(x, i)
Base.propertynames(x::RowIterator) = columnnames(x)
isrowtable(::Type{<:RowIterator}) = true

columnaccess(::Type{<:RowIterator}) = true
columns(x::RowIterator) = getfield(x, :columns)
columnnames(x::RowIterator) = columnnames(columns(x))
getcolumn(x::RowIterator, nm::Symbol) = getcolumn(columns(x), nm)
getcolumn(x::RowIterator, i::Int) = getcolumn(columns(x), i)
materializer(x::RowIterator) = materializer(columns(x))
schema(x::RowIterator) = schema(columns(x))

@inline function Base.iterate(rows::RowIterator, st=1)
    st > length(rows) && return nothing
    return ColumnsRow(columns(rows), st), st + 1
end

# this is our generic Tables.rows fallback definition
@noinline nodefault(T) = throw(ArgumentError("no default `Tables.rows` implementation for type: $T"))

rows(x::T) where {T} = _rows(x)

# split out so we can re-use it in the matrix fallback
function _rows(x::T) where {T}
    isrowtable(x) && return x
    # because this method is being called, we know `x` didn't define it's own Tables.rows
    # first check if it supports column access, and if so, wrap it in a RowIterator
    if columnaccess(x)
        cols = columns(x)
        return RowIterator(cols, Int(rowcount(cols)))
    # otherwise, if the input is at least iterable, we'll wrap it in an IteratorWrapper
    # which will iterate the input, validating that elements support the AbstractRow interface
    # and unwrapping any DataValues that are encountered
    elseif IteratorInterfaceExtensions.isiterable(x)
        return nondatavaluerows(x)
    end
    nodefault(T)
end

rows(::Type{T}) where {T} = throw(ArgumentError("no `Tables.rows` implementation for: $T. `Tables.rows` expects to work on a table _instance_ rather than a _type_."))

# for AbstractRow iterators, we define a "collect"-like routine to build up columns from iterated rows

"""
    Tables.allocatecolumn(::Type{T}, len) => returns a column type (usually `AbstractVector`) with size to hold `len` elements

Custom column types can override with an appropriate "scalar" element type that should dispatch to their column allocator.
Alternatively, and more generally, custom scalars can overload `DataAPI.defaultarray` to signal the default array type.
In this case the signaled array type must support a constructor accepting `undef` for initialization.
"""
function allocatecolumn(T, len)
    a = DataAPI.defaultarray(T, 1)(undef, len)
    Missing <: T && fill!(a, missing)
    return a
end

@inline function _allocatecolumns(::Schema{names, types}, len) where {names, types}
    if @generated
        vals = Tuple(:(allocatecolumn($(fieldtype(types, i)), len)) for i = 1:fieldcount(types))
        return :(NamedTuple{$(map(Symbol, names))}(($(vals...),)))
    else
        return NamedTuple{map(Symbol, names)}(Tuple(allocatecolumn(fieldtype(types, i), len) for i = 1:fieldcount(types)))
    end
end

@inline function allocatecolumns(sch::Schema{names, types}, len) where {names, types}
    if fieldcount(types) <= SPECIALIZATION_THRESHOLD
        return _allocatecolumns(sch, len)
    else
        return NamedTuple{map(Symbol, names)}(Tuple(allocatecolumn(fieldtype(types, i), len) for i = 1:fieldcount(types)))
    end
end

# add! will push! or setindex! a value depending on if the row-iterator HasLength or not
@inline add!(val, col::Int, nm, dest::AbstractArray, ::Union{Base.HasLength, Base.HasShape}, row) = setindex!(dest, val, row)
@inline add!(val, col::Int, nm, dest::AbstractArray, L, row) = push!(dest, val)

@inline function buildcolumns(schema, rowitr::T) where {T}
    L = Base.IteratorSize(T)
    len = Base.haslength(T) ? length(rowitr) : 0
    nt = allocatecolumns(schema, len)
    for (i, row) in enumerate(rowitr)
        eachcolumns(add!, schema, row, nt, L, i)
    end
    return nt
end

@inline add!(dest::AbstractArray, val, ::Union{Base.HasLength, Base.HasShape}, row) = setindex!(dest, val, row)
@inline add!(dest::AbstractArray, val, T, row) = push!(dest, val)

@inline function add_or_widen!(val, col::Int, nm, dest::AbstractArray{T}, row, updated, L) where {T}
    if val isa T || promote_type(typeof(val), T) <: T
        add!(dest, val, L, row)
        return
    else
        new = allocatecolumn(promote_type(T, typeof(val)), length(dest))
        row > 1 && copyto!(new, 1, dest, 1, row - 1)
        add!(new, val, L, row)
        updated[] = ntuple(i->i == col ? new : updated[][i], length(updated[]))
        return
    end
end

function __buildcolumns(rowitr, st, sch, columns, rownbr, updated)
    while true
        state = iterate(rowitr, st)
        state === nothing && break
        row, st = state
        rownbr += 1
        eachcolumns(add_or_widen!, sch, row, columns, rownbr, updated, Base.IteratorSize(rowitr))
        # little explanation here: we just called add_or_widen! for each column value of our row
        # note that when a column's type is widened, `updated` is set w/ the new set of columns
        # we then check if our current `columns` isn't the same object as our `updated` ref
        # if it isn't, we're going to call __buildcolumns again, passing our new updated ref as
        # columns, which allows __buildcolumns to specialize (i.e. recompile) based on the new types
        # of updated. So a new __buildcolumns will be compiled for each widening event.
        columns !== updated[] && return __buildcolumns(rowitr, st, sch, updated[], rownbr, updated)
    end
    return updated
end

# for the schema-less case, we do one extra step of initializing each column as an `EmptyVector`
# and doing an initial widening for each column in _buildcolumns, before passing the widened
# set of columns on to __buildcolumns
struct EmptyVector <: AbstractVector{Union{}}
    len::Int
end
Base.IndexStyle(::Type{EmptyVector}) = Base.IndexLinear()
Base.size(x::EmptyVector) = (x.len,)
Base.getindex(x::EmptyVector, i::Int) = throw(UndefRefError())

function _buildcolumns(rowitr, row, st, sch, columns, updated)
    eachcolumns(add_or_widen!, sch, row, columns, 1, updated, Base.IteratorSize(rowitr))
    return __buildcolumns(rowitr, st, sch, updated[], 1, updated)
end

if isdefined(Base, :fieldtypes)
    _fieldtypes = fieldtypes
else
    _fieldtypes(T) = (fieldtype(T, i) for i = 1:fieldcount(T))
end

# when Tables.schema(x) === nothing
@inline function buildcolumns(::Nothing, rowitr::T) where {T}
    state = iterate(rowitr)
    if state === nothing
        # empty input iterator; check if it has eltype and maybe we can return a better typed empty NamedTuple
        if Base.IteratorEltype(rowitr) == Base.HasEltype()
            WT = wrappedtype(eltype(rowitr))
            if WT <: Tuple
                return allocatecolumns(Schema((Symbol("Column$i") for i = 1:fieldcount(WT)), _fieldtypes(WT)), 0)
            elseif isconcretetype(WT) && fieldcount(WT) > 0
                return allocatecolumns(Schema(fieldnames(WT), _fieldtypes(WT)), 0)
            end
        end
        return NamedTuple()
    end
    row, st = state
    names = Tuple(columnnames(row))
    len = Base.haslength(T) ? length(rowitr) : 0
    sch = Schema(names, nothing)
    columns = Tuple(EmptyVector(len) for _ = 1:length(names))
    return NamedTuple{map(Symbol, names)}(_buildcolumns(rowitr, row, st, sch, columns, Ref{Any}(columns))[])
end

"""
    Tables.CopiedColumns

For some sinks, there's a concern about whether they can safely "own" columns from the input.
If mutation will be allowed, to be safe, they should always copy input columns, to avoid unintended mutation
to the original source.
When we've called `buildcolumns`, however, Tables.jl essentially built/owns the columns,
and it's happy to pass ownership to the sink. Thus, any built columns will be wrapped
in a `CopiedColumns` struct to signal to the sink that essentially "a copy has already been made"
and they're safe to assume ownership.
"""
struct CopiedColumns{T} <: AbstractColumns
    x::T
end

source(x::CopiedColumns) = getfield(x, :x)
istable(::Type{<:CopiedColumns}) = true
columnaccess(::Type{<:CopiedColumns}) = true
columns(x::CopiedColumns) = x
schema(x::CopiedColumns) = schema(source(x))
materializer(x::CopiedColumns) = materializer(source(x))

getcolumn(x::CopiedColumns, ::Type{T}, col::Int, nm::Symbol) where {T} = getcolumn(source(x), T, col, nm)
getcolumn(x::CopiedColumns, i::Int) = getcolumn(source(x), i)
getcolumn(x::CopiedColumns, nm::Symbol) = getcolumn(source(x), nm)
columnnames(x::CopiedColumns) = columnnames(source(x))

# here's our generic fallback Tables.columns definition
@inline columns(x::T) where {T} = _columns(x)

@inline function _columns(x::T) where {T}
    # because this method is being called, we know `x` didn't define it's own Tables.columns method
    # first check if it explicitly supports row access, and if so, build up the desired columns
    if rowaccess(x)
        r = rows(x)
        return CopiedColumns(buildcolumns(schema(r), r))
    # though not widely supported, if a source supports the TableTraits column interface, use it
    elseif TableTraits.supports_get_columns_copy_using_missing(x)
        return CopiedColumns(TableTraits.get_columns_copy_using_missing(x))
    # otherwise, if the source is at least iterable, we'll wrap it in an IteratorWrapper and
    # build columns from that, which will check if the source correctly iterates valid AbstractRow objects
    # and unwraps DataValues for us
    elseif IteratorInterfaceExtensions.isiterable(x)
        iw = nondatavaluerows(x)
        return CopiedColumns(buildcolumns(schema(iw), iw))
    end
    throw(ArgumentError("no default `Tables.columns` implementation for type: $T"))
end

# implement default nrow and ncol methods for DataAPI.jl

# this covers also MatrixTable
DataAPI.nrow(table::AbstractColumns) = rowcount(table)
DataAPI.ncol(table::AbstractColumns) = length(columnnames(table))

DataAPI.nrow(table::AbstractRowTable) = length(table)
DataAPI.ncol(table::AbstractRowTable) = isempty(table) ? 0 : length(columnnames(first(table)))

# Tables.jl Documentation

This guide provides documentation around the powerful tables interfaces in the Tables.jl package.
Note that the package, and hence, documentation, are geared towards package and library developers
who intend to implement and consume the interfaces. Users, on the other hand, benefit from these
other packages that provide useful access to table data in various formats or workflows. While everyone
is encouraged to understand the interfaces and the functionality they allow, just note that most users
don't need to use Tables.jl directly.

With that said, don't hesitate to [open a new issue](https://github.com/JuliaData/Tables.jl/issues/new), even
just for a question, or come chat with us on the [#data](https://julialang.slack.com/messages/data/) slack
channel with questions, concerns, or clarifications. Also one can find list of packages that supports
Tables.jl interface in [INTEGRATIONS.md](https://github.com/JuliaData/Tables.jl/blob/master/INTEGRATIONS.md).

For declarative projection, filtering, and row bounds that sources can push
down, see [Scan Requests](scan.md) (`Tables.Scan`). Please refer to
[TableOperations.jl](https://github.com/JuliaData/TableOperations.jl) for common table operations
such as  `select`, `transform`, `filter` and  `map` and to [TableTransforms.jl](https://github.com/JuliaML/TableTransforms.jl)
for more sophisticated transformations.

```@contents
Depth = 3
Pages = [
    "index.md",
    "using-the-interface.md",
    "scan.md",
    "implementing-the-interface.md",
    "api.md",
]
```

Packages currently integrating with Tables.jl:
* [ARFFFiles](https://github.com/cjdoris/ARFFFiles.jl.git)
* [AcuteML](https://github.com/aminya/AcuteML.jl.git)
* [AlgebraOfGraphics](https://github.com/JuliaPlots/AlgebraOfGraphics.jl.git)
* [ArchGDAL](https://github.com/yeesian/ArchGDAL.jl.git)
* [Arrow](https://github.com/JuliaData/Arrow.jl.git)
* [AxisIndices](https://github.com/Tokazama/AxisIndices.jl.git)
* [AxisKeys](https://github.com/mcabbott/AxisKeys.jl.git)
* [AxisTables](https://github.com/Tokazama/AxisTables.jl.git)
* [BAT](https://github.com/bat/BAT.jl.git)
* [BangBang](https://github.com/JuliaFolds/BangBang.jl.git)
* [BraidChains](https://github.com/PeaceFounder/BraidChains.jl.git)
* [BrowseTables](https://github.com/tpapp/BrowseTables.jl.git)
* [CBSOData3](https://github.com/HenricoWitvliet/CBSOData3.jl.git)
* [CSV](https://github.com/JuliaData/CSV.jl.git)
* [Catlab](https://github.com/AlgebraicJulia/Catlab.jl.git)
* [CausalInference](https://github.com/mschauer/CausalInference.jl.git)
* [CoDa](https://github.com/JuliaEarth/CoDa.jl.git)
* [CurrentPopulationSurvey](https://github.com/mthelm85/CurrentPopulationSurvey.jl.git)
* [DBFTables](https://github.com/JuliaData/DBFTables.jl.git)
* [DataConvenience](https://github.com/xiaodaigh/DataConvenience.jl.git)
* [DataFrames](https://github.com/JuliaData/DataFrames.jl.git)
* [DataFramesMeta](https://github.com/JuliaData/DataFramesMeta.jl.git)
* [DataKnots](https://github.com/rbt-lang/DataKnots.jl.git)
* [DataTools](https://github.com/JuliaFolds/DataTools.jl.git)
* [DeIdentification](https://github.com/bcbi/DeIdentification.jl.git)
* [DiffEqBase](https://github.com/SciML/DiffEqBase.jl.git)
* [DimensionalData](https://github.com/rafaqz/DimensionalData.jl.git)
* [DungAnalyse](https://github.com/yakir12/DungAnalyse.jl.git)
* [Econometrics](https://github.com/Nosferican/Econometrics.jl.git)
* [EvoTrees](https://github.com/Evovest/EvoTrees.jl.git)
* [FITSTables](https://github.com/ajwheeler/FITSTables.jl.git)
* [FWFTables](https://github.com/HenricoWitvliet/FWFTables.jl.git)
* [Feather](https://github.com/JuliaData/Feather.jl.git)
* [FixedEffectModels](https://github.com/FixedEffects/FixedEffectModels.jl.git)
* [FlatGeobuf](https://github.com/evetion/FlatGeobuf.jl.git)
* [FormattedTables](https://github.com/tom--lee/FormattedTables.jl.git)
* [FreqTables](https://github.com/nalimilan/FreqTables.jl.git)
* [FunctionalTables](https://github.com/tpapp/FunctionalTables.jl.git)
* [GADM](https://github.com/JuliaGeo/GADM.jl.git)
* [GLFixedEffectModels](https://github.com/jmboehm/GLFixedEffectModels.jl.git)
* [GeoDataFrames](https://github.com/evetion/GeoDataFrames.jl.git)
* [GeoStatsBase](https://github.com/JuliaEarth/GeoStatsBase.jl.git)
* [GeometryBasics](https://github.com/JuliaGeometry/GeometryBasics.jl.git)
* [HurdleDMR](https://github.com/AsafManela/HurdleDMR.jl.git)
* [Impute](https://github.com/invenia/Impute.jl.git)
* [IndexedTables](https://github.com/JuliaData/IndexedTables.jl.git)
* [InteractiveFixedEffectModels](https://github.com/FixedEffects/InteractiveFixedEffectModels.jl.git)
* [InvariantCausalPrediction](https://github.com/drcxcruz/InvariantCausalPrediction.jl.git)
* [JDBC](https://github.com/JuliaDatabases/JDBC.jl.git)
* [JDF](https://github.com/xiaodaigh/JDF.jl.git)
* [JLBoost](https://github.com/xiaodaigh/JLBoost.jl.git)
* [JSONLines](https://github.com/danielw2904/JSONLines.jl.git)
* [JSONTables](https://github.com/JuliaData/JSONTables.jl.git)
* [JSServe](https://github.com/SimonDanisch/JSServe.jl.git)
* [JellyMe4](https://github.com/palday/JellyMe4.jl.git)
* [KeywordSearch](https://github.com/beacon-biosignals/KeywordSearch.jl.git)
* [LazIO](https://github.com/evetion/LazIO.jl.git)
* [LibPQ](https://github.com/invenia/LibPQ.jl.git)
* [LightQuery](https://github.com/bramtayl/LightQuery.jl.git)
* [MarkdownTables](https://github.com/tpapp/MarkdownTables.jl.git)
* [MCMCChains](https://github.com/TuringLang/MCMCChains.jl.git)
* [MDTable](https://github.com/TheRoniOne/MDTable.jl.git)
* [MLJ](https://github.com/alan-turing-institute/MLJ.jl.git)
* [MLJBase](https://github.com/alan-turing-institute/MLJBase.jl.git)
* [MLJFlux](https://github.com/alan-turing-institute/MLJFlux.jl.git)
* [MLJGLMInterface](https://github.com/alan-turing-institute/MLJGLMInterface.jl.git)
* [MLJLinearModels](https://github.com/alan-turing-institute/MLJLinearModels.jl.git)
* [MLJModels](https://github.com/alan-turing-institute/MLJModels.jl.git)
* [MLJScientificTypes](https://github.com/alan-turing-institute/MLJScientificTypes.jl.git)
* [MLJXGBoostInterface](https://github.com/alan-turing-institute/MLJXGBoostInterface.jl.git)
* [Matte](https://github.com/angusmoore/Matte.jl.git)
* [Metida](https://github.com/PharmCat/Metida.jl.git)
* [Microbiome](https://github.com/BioJulia/Microbiome.jl.git)
* [MixedAnova](https://github.com/Jejulia/MixedAnova.jl.git)
* [MixedModels](https://github.com/JuliaStats/MixedModels.jl.git)
* [ModelParameters](https://github.com/rafaqz/ModelParameters.jl.git)
* [MulticlassPerceptron](https://github.com/davidbp/MulticlassPerceptron.jl.git)
* [Mustache](https://github.com/jverzani/Mustache.jl.git)
* [MySQL](https://github.com/JuliaDatabases/MySQL.jl.git)
* [NLreg](https://github.com/dmbates/NLreg.jl.git)
* [ODBC](https://github.com/JuliaDatabases/ODBC.jl.git)
* [ObservationDims](https://github.com/invenia/ObservationDims.jl.git)
* [OmniSci](https://github.com/omnisci/OmniSci.jl.git)
* [Oracle](https://github.com/felipenoris/Oracle.jl.git)
* [PGFPlotsX](https://github.com/KristofferC/PGFPlotsX.jl.git)
* [Parquet](https://github.com/JuliaIO/Parquet.jl.git)
* [PersistenceDiagrams](https://github.com/mtsch/PersistenceDiagrams.jl.git)
* [PersistenceDiagramsBase](https://github.com/mtsch/PersistenceDiagramsBase.jl.git)
* [Pluto](https://github.com/fonsp/Pluto.jl.git)
* [PostgresCatalog](https://github.com/rbt-lang/PostgresCatalog.jl.git)
* [PredictMD](https://github.com/bcbi/PredictMD.jl.git)
* [PredictMDExtra](https://github.com/bcbi/PredictMDExtra.jl.git)
* [PrettyTables](https://github.com/ronisbr/PrettyTables.jl.git)
* [RadiationDetectorSignals](https://github.com/JuliaPhysics/RadiationDetectorSignals.jl.git)
* [RadiationSpectra](https://github.com/JuliaPhysics/RadiationSpectra.jl.git)
* [RankAggregation](https://github.com/JuliaEarth/RankAggregation.jl.git)
* [ReadWriteDlm2](https://github.com/strickek/ReadWriteDlm2.jl.git)
* [Recombinase](https://github.com/piever/Recombinase.jl.git)
* [RegressionDiscontinuity](https://github.com/nignatiadis/RegressionDiscontinuity.jl.git)
* [SASLib](https://github.com/tk3369/SASLib.jl.git)
* [SQLite](https://github.com/JuliaDatabases/SQLite.jl.git)
* [Schemata](https://github.com/JockLawrie/Schemata.jl.git)
* [ScientificTypes](https://github.com/alan-turing-institute/ScientificTypes.jl.git)
* [ShaderAbstractions](https://github.com/SimonDanisch/ShaderAbstractions.jl.git)
* [Shapefile](https://github.com/JuliaGeo/Shapefile.jl.git)
* [SolidStateDetectors](https://github.com/JuliaPhysics/SolidStateDetectors.jl.git)
* [SossMLJ](https://github.com/cscherrer/SossMLJ.jl.git)
* [SpineBasedRecordLinkage](https://github.com/JockLawrie/SpineBasedRecordLinkage.jl.git)
* [StataDTAFiles](https://github.com/tpapp/StataDTAFiles.jl.git)
* [StatsMakie](https://github.com/JuliaPlots/StatsMakie.jl.git)
* [StatsModels](https://github.com/JuliaStats/StatsModels.jl.git)
* [StatsPlots](https://github.com/JuliaPlots/StatsPlots.jl.git)
* [Strapping](https://github.com/JuliaData/Strapping.jl.git)
* [StructArrays](https://github.com/JuliaArrays/StructArrays.jl.git)
* [TSML](https://github.com/IBM/TSML.jl.git)
* [TableIO](https://github.com/lungben/TableIO.jl.git)
* [TableOperations](https://github.com/JuliaData/TableOperations.jl.git)
* [TableView](https://github.com/JuliaComputing/TableView.jl.git)
* [TableWidgets](https://github.com/piever/TableWidgets.jl.git)
* [Taro](https://github.com/aviks/Taro.jl.git)
* [TextAnalysis](https://github.com/JuliaText/TextAnalysis.jl.git)
* [TimeSeries](https://github.com/JuliaStats/TimeSeries.jl.git)
* [Trajectories](https://github.com/mschauer/Trajectories.jl.git)
* [Transducers](https://github.com/JuliaFolds/Transducers.jl.git)
* [TypedTables](https://github.com/JuliaData/TypedTables.jl.git)
* [UnROOT](https://github.com/JuliaHEP/UnROOT.jl.git)
* [UpROOT](https://github.com/JuliaHEP/UpROOT.jl.git)
* [ValueShapes](https://github.com/oschulz/ValueShapes.jl.git)
* [Vcov](https://github.com/matthieugomez/Vcov.jl.git)
* [XLSX](https://github.com/felipenoris/XLSX.jl.git)
* [YAXArrays](https://github.com/meggart/YAXArrays.jl.git)

# Scan Requests

`Tables.Scan` is a logical request for projection, filtering, row bounds, and
output conversion. It does not require a physical full-table scan. A source can
use an index, statistics, partition pruning, or any other exact optimization.

The API has two roles:

- Consumers construct a [`Tables.Scan`](@ref) and pass it to a source or to
  [`Tables.scan`](@ref).
- Source implementations inspect, resolve, and consume supported parts of the
  request while they read data.

## Consumer API

```@example scan
using Tables

table = (
    id = [1, 2, 3, 4],
    status = ["trial", "active", "active", "closed"],
    price = [5, 20, 12, 30],
)

request = Tables.Scan(
    select = (:id, :price => Float64 => :amount),
    filter = Tables.colcmp(==, Tables.col(:status), "active") &
             (Tables.col(:price) >= 10),
    limit = 10,
)

Tables.scan(table, request)
```

The operation order is fixed:

1. Resolve references against source column names.
2. Evaluate the filter.
3. Apply `offset`, then `limit`, to qualifying rows.
4. Select, rename, and convert output columns.

Filters always use source names. A rename does not change the name visible to
the filter.

### Selection

`select=Tables.All()` is the default and keeps every column. `select=()` selects
zero columns while preserving the result's row count.

A selection accepts names, indices, regular expressions, `Tables.All()`, and
`Tables.Not(...)`. Pair forms add a type override or output name:

```julia
Tables.Scan(select = (
    :id,
    r"^metric_",
    :price => Float64,
    :qty => Int => :quantity,
))
```

Selection order defines output order. Duplicate output names are an error.

### Filter expressions

`Tables.col(ref)` creates a column reference. The supported predicates are:

- `Tables.colcmp(op, column, value)` for `==`, `!=`, `<`, `<=`, `>`, and `>=`.
- Ordered shorthand such as `Tables.col(:price) >= 10`.
- `Tables.colin(column, values)` for membership.
- `Tables.isnull(column)` and its negation for `missing` checks.
- `startswith`, `endswith`, and `contains` for strings.
- `&`, `|`, and `!` for Boolean composition.

Expression nodes contain plain data. They do not store callbacks. This makes a
request inspectable and suitable for serialization, pushdown, and static
compilation.

### Missing values

Filter evaluation uses SQL-like three-valued logic:

- Comparisons, membership, and string predicates lift a missing column value to
  `missing`.
- `Tables.isnull(column)` returns `true` for `missing` and `false` otherwise.
- `&`, `|`, and `!` propagate `missing` with three-valued Boolean rules.
- The top-level filter keeps a row only when its result is exactly `true`.

These lifting rules are deliberate. Julia functions other than comparison
operators do not generally lift `missing` on their own.

The name `Tables.isnull` also avoids defining `Base.ismissing(::Tables.Col)`.
Such a method would specialize a broad Base fallback and can invalidate
unrelated compiled code when Tables loads.

### Unmatched references

The default `validate=true` rejects any selection or filter reference that does
not match the source schema. With `validate=false`, an unmatched selection is
dropped and an unmatched filter column behaves as an all-missing column. This
mode supports schema evolution when fields can be absent.

## Source Implementations

A source does not need to support every operation. It can consume the parts it
can implement exactly and pass the rest to [`Tables.scan`](@ref). It can also
reject a request that it cannot safely execute.

[`Tables.resolve`](@ref) resolves a request against source names. Its
`BoundScan` result contains:

- `columns`: selected source indices, output names, and type overrides.
- `filter`: a filter with positional references normalized to source names.
- `filtercols`: source indices required by the filter.
- `limit`, `offset`, and `validate`: the remaining row and validation settings.

The normalized filter can be evaluated over a table containing only the
`filtercols` columns:

```julia
bound = Tables.resolve(request, source_names)
mask = Tables.filtermask(bound, predicate_columns)
```

If a source consumes an axis, it removes that axis from the residual. The
axes compose in a fixed order — filter, then row bounds, then projection —
so an axis can only be removed together with every axis that executes before
it. A source that evaluated the filter itself (for example with
`Tables.filtermask`) hands the rest to the generic executor:

```julia
residual = Tables.Scan(request; filter=nothing)
result = Tables.scan(filtered_columns, residual)
```

A source that also applied `limit`/`offset` to the qualifying rows strips
those too (`Tables.Scan(request; filter=nothing, limit=nothing, offset=0)`,
leaving only projection). Two constraints follow from the ordering:

- `limit`/`offset` count qualifying rows, after the filter. A source that
  cannot consume the filter must leave the row bounds in the residual as
  well.
- Projection may be stripped (`select=Tables.All()`, the projection identity)
  only when no residual filter references a column the projection dropped or
  renamed — the residual filter still uses source column names.

Only remove work that the source performed exactly.

A statistics check that only prunes impossible partitions does not consume the
filter.

`Tables.OpNode(name, args)` is the extension point for source-specific,
plain-data operations. A source can recognize and consume a named operation
before it calls `Tables.resolve`. Resolution and the generic executor reject an
unconsumed `OpNode`.

Zero-column results retain their row count. Sources should preserve the same
property when they return a fully pushed result.

```@docs; canonical = false
Tables.Scan
Tables.scan
Tables.col
Tables.colcmp
Tables.colin
Tables.isnull
Tables.resolve
Tables.filtermask
Tables.describe
```

# Using the Interface (i.e. consuming Tables.jl-compatible sources)

We start by discussing _usage_ of the Tables.jl interface functions, since that can help contextualize _implementing_ them for custom table types.

At a high level, Tables.jl provides two powerful APIs for predictably accessing data from any table-like source:
```julia
# access data of input table `x` row-by-row
# Tables.rows must return a row iterator
rows = Tables.rows(x)

# we can iterate through each row
for row in rows
    # example of getting all values in the row
    # don't worry, there are other ways to more efficiently process rows
    rowvalues = [Tables.getcolumn(row, col) for col in Tables.columnnames(row)]
end

# access data of input table `x` column-by-column
# Tables.columns returns an object where individual, entire columns can be accessed
columns = Tables.columns(x)

# iterate through each column name in table
for col in Tables.columnnames(columns)
    # retrieve entire column by column name
    # a column is an indexable collection
    # with known length (i.e. supports
    # `length(column)` and `column[i]`)
    column = Tables.getcolumn(columns, col)
end
```

So we see two high-level functions here, [`Tables.rows`](@ref), and [`Tables.columns`](@ref).

```@docs; canonical = false
Tables.rows
Tables.columns
```

Given these two powerful data access methods, let's walk through real, albeit somewhat simplified versions of how packages actually use these methods.

## `Tables.rows` usage

First up, let's take a look at the [SQLite.jl](https://github.com/JuliaDatabases/SQLite.jl) package and how it uses the Tables.jl interface to allow loading of generic table-like data into a sqlite relational table. Here's the code:
```julia
function load!(table, db::SQLite.DB, tablename)
    # get input table rows
    rows = Tables.rows(table)
    # query for schema of data
    sch = Tables.schema(rows)
    # create table using tablename and schema from input table
    createtable!(db, tablename, sch)
    # build insert statement
    params = chop(repeat("?,", length(sch.names)))
    stmt = Stmt(db, "INSERT INTO $tablename VALUES ($params)")
    # start a transaction for inserting rows
    transaction(db) do
        # iterate over rows in the input table
        for row in rows
            # Tables.jl provides a utility function
            # Tables.eachcolumn, which allows efficiently
            # applying a function to each column value in a row
            # it's called with a schema and row, and applies
            # a user-provided function to the column value `val`, index `i`
            # and column name `nm`. Here, we bind the row values
            # to our parameterized SQL INSERT statement and then
            # call `sqlite3_step` to execute the INSERT statement.
            Tables.eachcolumn(sch, row) do val, i, nm
                bind!(stmt, i, val)
            end
            sqlite3_step(stmt.handle)
            sqlite3_reset(stmt.handle)
        end
    end
    return
end
```

This is pretty straightforward usage: it calls [`Tables.rows`](@ref) on the input table source,
and since we need the schema to setup the database table, we query it via [`Tables.schema`](@ref).
We then iterate the rows in our table via `for row in rows`, and use the convenient
[`Tables.eachcolumn`](@ref) to efficiently apply a function to each value in the row. Note that
we didn't call [`Tables.columnnames`](@ref) or [`Tables.getcolumn`](@ref) at all, since they're utilized
by [`Tables.eachcolumn`](@ref) itself. [`Tables.eachcolumn`](@ref) is optimized to provide type-stable, and even
constant-propagation of column index, name, and type in some cases to allow for efficient
consumption of row values.

One wrinkle to consider is the "unknown schema" case; i.e. what if our [`Tables.schema`](@ref)
call had returned `nothing` (this can be the case for exotic table sources like lazily mapped
transformations over rows in a table):
```julia
function load!(sch::Nothing, rows, db::SQLite.DB, tablename)
    # sch is nothing === unknown schema
    # start iteration on input table rows
    state = iterate(rows)
    state === nothing && return
    row, st = state
    # query column names of first row
    names = Tables.columnnames(row)
    # partially construct Tables.Schema by at least passing
    # the column names to it
    sch = Tables.Schema(names, nothing)
    # create table if needed
    createtable!(db, tablename, sch)
    # build insert statement
    params = chop(repeat("?,", length(names)))
    stmt = Stmt(db, "INSERT INTO $nm VALUES ($params)")
    # start a transaction for inserting rows
    transaction(db) do
        while true
            # just like before, we can still use `Tables.eachcolumn`
            # even with our partially constructed Tables.Schema
            # to apply a function to each value in the row
            Tables.eachcolumn(sch, row) do val, i, nm
                bind!(stmt, i, val)
            end
            sqlite3_step(stmt.handle)
            sqlite3_reset(stmt.handle)
            # keep iterating rows until we finish
            state = iterate(rows, st)
            state === nothing && break
            row, st = state
        end
    end
    return name
end
```

The strategy taken here is to start iterating the input source, and using the first row
as a guide, we make a [`Tables.Schema`](@ref) object with just the column names, which we can
then still pass to [`Tables.eachcolumn`](@ref) to apply our `bind!` function to each row value.

## `Tables.columns` usage

Ok, now let's take a look at a case utilizing [`Tables.columns`](@ref).
The following code is taken from the [DataFrames.jl](https://github.com/JuliaData/DataFrames.jl/blob/master/src/other/tables.jl)
Tables.jl implementation:
```julia
getvector(x::AbstractVector) = x
getvector(x) = collect(x)

# note that copycols is ignored in this definition (Tables.CopiedColumns implies copies have already been made)
fromcolumns(x::Tables.CopiedColumns, names; copycols::Bool=true) =
    DataFrame(AbstractVector[getvector(Tables.getcolumn(x, nm) for nm in names],
              Index(names),
              copycols=false)
fromcolumns(x, names; copycols::Bool=true) =
    DataFrame(AbstractVector[getvector(Tables.getcolumn(x, nm) for nm in names],
              Index(names),
              copycols=copycols)

function DataFrame(x; copycols::Bool=true)
    # get columns from input table source
    cols = Tables.columns(x)
    # get column names as Vector{Symbol}, which is required
    # by core DataFrame constructor
    names = collect(Symbol, Tables.columnnames(cols))
    return fromcolumns(cols, names; copycols=copycols)
end
```

So here we have a generic `DataFrame` constructor that takes a single, untyped argument,
calls [`Tables.columns`](@ref) on it, then [`Tables.columnnames`](@ref) to get the column names.
It then passes the [`Tables.AbstractColumns`](@ref)-compatible object to an internal function `fromcolumns`,
which dispatches on a special kind of `Tables.AbstractColumns` object called a [`Tables.CopiedColumns`](@ref),
which wraps any `Tables.AbstractColumns`-compatible object that has already had copies of its
columns made, and are thus safe for the columns-consumer to assume ownership of (this is because
DataFrames.jl, by default makes copies of all columns upon construction). In both cases, individual
columns are collected in `Vector{AbstractVector}`s by calling `Tables.getcolumn(x, nm)` for each column name.
A final note is the call to `getvector` on each column, which ensures each column is materialized
as an `AbstractVector`, as is required by the DataFrame constructor.

Note in both the rows and columns usages, we didn't need to worry about the natural orientation
of the input data; we just called [`Tables.rows`](@ref) or [`Tables.columns`](@ref) as was most natural for
the table-specific use-case, knowing that it will Just Work™️.

## Tables.jl Utilities

Before moving on to _implementing_ the Tables.jl interfaces, we take a quick
break to highlight some useful utility functions provided by Tables.jl:

```@docs; canonical = false
Tables.Schema
Tables.schema
Tables.subset
Tables.partitions
Tables.partitioner
Tables.rowtable
Tables.columntable
Tables.dictrowtable
Tables.dictcolumntable
Tables.namedtupleiterator
Tables.datavaluerows
Tables.nondatavaluerows
Tables.table
Tables.matrix
Tables.eachcolumn
Tables.materializer
Tables.columnindex
Tables.columntype
Tables.rowmerge
Tables.Row
Tables.Columns
```

# Implementing the Interface (i.e. becoming a Tables.jl source)

Now that we've seen how one _uses_ the Tables.jl interface, let's walk-through how to implement it; i.e. how can I
make my custom type valid for Tables.jl consumers?

For a type `MyTable`, the interface to becoming a proper table is straightforward:

| Required Methods                             | Default Definition           | Brief Description                                                                                                                                   |
|----------------------------------------------|------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------|
| `Tables.istable(::Type{MyTable})`            |                              | Declare that your table type implements the interface                                                                                               |
|  **One of:**                                 |                              |                                                                                                                                                     |
| `Tables.rowaccess(::Type{MyTable})`          |                              | Declare that your table type defines a `Tables.rows(::MyTable)` method                                                                              |
| `Tables.rows(x::MyTable)`                    |                              | Return an `Tables.AbstractRow`-compatible iterator from your table                                                                                  |
| **Or:**                                      |                              |                                                                                                                                                     |
| `Tables.columnaccess(::Type{MyTable})`       |                              | Declare that your table type defines a `Tables.columns(::MyTable)` method                                                                           |
| `Tables.columns(x::MyTable)`                 |                              | Return an `Tables.AbstractColumns`-compatible object from your table                                                                                |
| **Optional methods**                         |                              |                                                                                                                                                     |
| `Tables.schema(x::MyTable)`                  | `Tables.schema(x) = nothing` | Return a [`Tables.Schema`](@ref) object from your `Tables.AbstractRow` iterator or `Tables.AbstractColumns` object; or `nothing` for unknown schema |
| `Tables.materializer(::Type{MyTable})`       | `Tables.columntable`         | Declare a "materializer" sink function for your table type that can construct an instance of your type from any Tables.jl input                     |
| `Tables.subset(x::MyTable, inds; viewhint)`  |                              | Return a row or a sub-table of the original table                                                                                                   |
| `DataAPI.nrow(x::MyTable)`                   |                              | Return number of rows of table `x`                                                                                                                  |
| `DataAPI.ncol(x::MyTable)`                   |                              | Return number of columns of table `x`                                                                                                               |

Based on whether your table type has defined `Tables.rows` or `Tables.columns`, you then ensure that the `Tables.AbstractRow` iterator
or `Tables.AbstractColumns` object satisfies the respective interface.

As an additional source of documentation, see [this discourse post](https://discourse.julialang.org/t/struggling-to-implement-tables-jl-interface-for-vector-mystruct/42318/7?u=quinnj) outlining in detail a walk-through of making a row-oriented table.

## `Tables.AbstractRow`

```@docs; canonical = false
Tables.AbstractRow
```

## `Tables.AbstractColumns`

```@docs; canonical = false
Tables.AbstractColumns
```

## Implementation Example
As an extended example, let's take a look at some code defined in Tables.jl for treating `AbstractVecOrMat`s as tables.

First, we define a special `MatrixTable` type that will wrap an `AbstractVecOrMat`, and allow easy overloading for the
Tables.jl interface.

```julia
struct MatrixTable{T <: AbstractVecOrMat} <: Tables.AbstractColumns
    names::Vector{Symbol}
    lookup::Dict{Symbol, Int}
    matrix::T
end
# declare that MatrixTable is a table
Tables.istable(::Type{<:MatrixTable}) = true
# getter methods to avoid getproperty clash
names(m::MatrixTable) = getfield(m, :names)
matrix(m::MatrixTable) = getfield(m, :matrix)
lookup(m::MatrixTable) = getfield(m, :lookup)
# schema is column names and types
Tables.schema(m::MatrixTable{T}) where {T} = Tables.Schema(names(m), fill(eltype(T), size(matrix(m), 2)))
```

Here we defined `Tables.istable` for all `MatrixTable` types, signaling that they implement the Tables.jl interfaces.
We also defined [`Tables.schema`](@ref) by pulling the column names out that we stored, and since `AbstractVecOrMat` have a single
`eltype`, we repeat it for each column (the call to `fill`). Note that defining [`Tables.schema`](@ref) is optional on tables; by default, `nothing`
is returned and Tables.jl consumers should account for both known and unknown schema cases. Returning a schema when possible allows consumers
to have certain optimizations when they can know the types of all columns upfront (and if the # of columns isn't too large)
to generate more efficient code.

Now, in this example, we're actually going to have `MatrixTable` implement _both_ `Tables.rows` and `Tables.columns`
methods itself, i.e. it's going to return itself from those functions, so here's first how we make our `MatrixTable` a
valid `Tables.AbstractColumns` object:

```julia
# column interface
Tables.columnaccess(::Type{<:MatrixTable}) = true
Tables.columns(m::MatrixTable) = m
# required Tables.AbstractColumns object methods
Tables.getcolumn(m::MatrixTable, ::Type{T}, col::Int, nm::Symbol) where {T} = matrix(m)[:, col]
Tables.getcolumn(m::MatrixTable, nm::Symbol) = matrix(m)[:, lookup(m)[nm]]
Tables.getcolumn(m::MatrixTable, i::Int) = matrix(m)[:, i]
Tables.columnnames(m::MatrixTable) = names(m)
```

We define `columnaccess` for our type, then `columns` just returns the `MatrixTable` itself, and then we define
the three `getcolumn` methods and `columnnames`. Note the use of a `lookup` `Dict` that maps column name to column index
so we can figure out which column to return from the matrix. We're also storing the column names in our `names` field
so the `columnnames` implementation is trivial. And that's it! Literally! It can now be written out to a csv file,
stored in a sqlite or other database, converted to DataFrame or JuliaDB table, etc. Pretty fun.

And now for the `Tables.rows` implementation:
```julia
# declare that any MatrixTable defines its own `Tables.rows` method
rowaccess(::Type{<:MatrixTable}) = true
# just return itself, which means MatrixTable must iterate `Tables.AbstractRow`-compatible objects
rows(m::MatrixTable) = m
# the iteration interface, at a minimum, requires `eltype`, `length`, and `iterate`
# for `MatrixTable` `eltype`, we're going to provide a custom row type
Base.eltype(m::MatrixTable{T}) where {T} = MatrixRow{T}
Base.length(m::MatrixTable) = size(matrix(m), 1)

Base.iterate(m::MatrixTable, st=1) = st > length(m) ? nothing : (MatrixRow(st, m), st + 1)

# a custom row type; acts as a "view" into a row of an AbstractVecOrMat
struct MatrixRow{T} <: Tables.AbstractRow
    row::Int
    source::MatrixTable{T}
end
# required `Tables.AbstractRow` interface methods (same as for `Tables.AbstractColumns` object before)
# but this time, on our custom row type
getcolumn(m::MatrixRow, ::Type, col::Int, nm::Symbol) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), col]
getcolumn(m::MatrixRow, i::Int) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), i]
getcolumn(m::MatrixRow, nm::Symbol) =
    getfield(getfield(m, :source), :matrix)[getfield(m, :row), getfield(getfield(m, :source), :lookup)[nm]]
columnnames(m::MatrixRow) = names(getfield(m, :source))
```
Here we start by defining `Tables.rowaccess` and `Tables.rows`, and then the iteration interface methods,
since we declared that a `MatrixTable` itself is an iterator of `Tables.AbstractRow`-compatible objects. For `eltype`,
we say that a `MatrixTable` iterates our own custom row type, `MatrixRow`. `MatrixRow` subtypes
`Tables.AbstractRow`, which provides interface implementations for several useful behaviors (indexing,
iteration, property-access, etc.); essentially it makes our custom `MatrixRow` type more convenient to work with.

Implementing the `Tables.AbstractRow` interface is straightforward, and very similar to our implementation
of `Tables.AbstractColumns` previously (i.e. the same methods for `getcolumn` and `columnnames`).

And that's it. Our `MatrixTable` type is now a fully fledged, valid Tables.jl source and can be used throughout
the ecosystem. Now, this is obviously not a lot of code; but then again, the actual Tables.jl interface
implementations tend to be fairly simple, given the other behaviors that are already defined for table types
(i.e. table types tend to already have a `getcolumn` like function defined).

## `Tables.isrowtable`

One option for certain table types is to define `Tables.isrowtable` to automatically satisfy the Tables.jl interface.
This can be convenient for "natural" table types that already iterate rows.
```@docs; canonical = false
Tables.isrowtable
```

## Testing Tables.jl Implementations

One question that comes up is what the best strategies are for testing a Tables.jl implementation. Continuing with
our `MatrixTable` example, let's see some useful ways to test that things are working as expected.

```julia
mat = [1 4.0 "7"; 2 5.0 "8"; 3 6.0 "9"]
```

First, we define a matrix literal with three columns of various differently typed values.

```julia
# first, create a MatrixTable from our matrix input
mattbl = Tables.table(mat)
# test that the MatrixTable `istable`
@test Tables.istable(typeof(mattbl))
# test that it defines row access
@test Tables.rowaccess(typeof(mattbl))
@test Tables.rows(mattbl) === mattbl
# test that it defines column access
@test Tables.columnaccess(typeof(mattbl))
@test Tables.columns(mattbl) === mattbl
# test that we can access the first "column" of our matrix table by column name
@test mattbl.Column1 == [1,2,3]
# test our `Tables.AbstractColumns` interface methods
@test Tables.getcolumn(mattbl, :Column1) == [1,2,3]
@test Tables.getcolumn(mattbl, 1) == [1,2,3]
@test Tables.columnnames(mattbl) == [:Column1, :Column2, :Column3]
# now let's iterate our MatrixTable to get our first MatrixRow
matrow = first(mattbl)
@test eltype(mattbl) == typeof(matrow)
# now we can test our `Tables.AbstractRow` interface methods on our MatrixRow
@test matrow.Column1 == 1
@test Tables.getcolumn(matrow, :Column1) == 1
@test Tables.getcolumn(matrow, 1) == 1
@test propertynames(mattbl) == propertynames(matrow) == [:Column1, :Column2, :Column3]
```

So, it looks like our `MatrixTable` type is looking good. It's doing everything we'd expect with regards to accessing
its rows or columns via the Tables.jl API methods. Testing a table source like this is fairly straightforward since
we're really just testing that our interface methods are doing what we expect them to do.

Now, while we didn't go over a "sink" function for matrices in our walkthrough, there does indeed exist a `Tables.matrix` function that allows converting any table input source into a plain Julia `Matrix` object.

Having both Tables.jl "source" and "sink" implementations (i.e. a type that is a Tables.jl-compatible source,
as well as a way to _consume_ other tables), allows us to do some additional "round trip" testing:

```julia
rt = [(a=1, b=4.0, c="7"), (a=2, b=5.0, c="8"), (a=3, b=6.0, c="9")]
ct = (a=[1,2,3], b=[4.0, 5.0, 6.0])
```

In addition to our `mat` object earlier, we can define a couple simple "tables"; in this case `rt` is a kind of default "row table" as a `Vector` of `NamedTuple`s, while `ct` is a default "column table" as a `NamedTuple` of `Vector`s. Notice that they contain mostly the same data as our matrix literal earlier, yet in slightly different storage formats. These default "row" and "column" tables are supported by default in Tables.jl due do their natural table representations, and hence can be excellent tools in testing table integrations.

```julia
# let's turn our row table into a plain Julia Matrix object
mat = Tables.matrix(rt)
# test that our matrix came out like we expected
@test mat[:, 1] == [1, 2, 3]
@test size(mat) == (3, 3)
@test eltype(mat) == Any
# so we successfully consumed a row-oriented table,
# now let's try with a column-oriented table
mat2 = Tables.matrix(ct)
@test eltype(mat2) == Float64
@test mat2[:, 1] == ct.a

# now let's take our matrix input, and make a column table out of it
tbl = Tables.table(mat) |> columntable
@test keys(tbl) == (:Column1, :Column2, :Column3)
@test tbl.Column1 == [1, 2, 3]
# and same for a row table
tbl2 = Tables.table(mat2) |> rowtable
@test length(tbl2) == 3
@test map(x->x.Column1, tbl2) == [1.0, 2.0, 3.0]
```
